<?php

include_once $_SERVER['DOCUMENT_ROOT'].'/data/uploads/language/config.php';

$config = array (

	//e7Studio Engine Setup
	'engine_path' => $configArr['engine_path'],  //path to engine		

	
	//Site Setup
	'root_path' => $configArr['root_path'],  //path
	'domain' => $configArr['domain'],  //domain bez http || www
	'site_title' => 'Webmedia client website',  //set to html default title
	'use_language' => false,
	'default_language' => 'en',
	'langs' => array('en'),
	

	//Debug Setup	
	'debug' => false,  //dali da pokazva debug?
	'debug_ips' => array (
		'80.80.149.234',  //deyan belashtica
		'78.130.227.163',  //deyan pld
		'78.130.225.209' //deyan maxtelecom 
	), 
	

	//MySQL Setup
	'mysql_host' => 'localhost', 
	'mysql_user' => $configArr['mysql_user'], 
	'mysql_pass' => $configArr['mysql_pass'], 
	'mysql_db' => $configArr['mysql_db'], 

	//Upload Files Setup
	'max_audio_size' => 1024 * 1024 * 500,  //500 MB
	'audio_ext' => array (
		'mp3' 
	), 

	'max_video_size' => 1024 * 1024 * 500,  //500 MB
	'video_ext' => array (
		'flv' 
	), 

	'max_file_size' => 1024 * 1024 * 10,  //10 MB
	'file_ext' => array (
		'pdf',
		'xls',
		'xlsx',
		'doc',
		'docx',
		'txt',
		'rtf',
		'png',
		'jpg' 
	),

	'max_upload_size' => 1024 * 1024 * 500,  //500 MB
	'upload_ext' => array(
		'jpg',
		'png',
		'zip'
	),
	
	'max_photo_size' => 1024 * 1024 * 10,  //10 MB
	'photo_ext' => array (
		'jpg', 
		'gif', 
		'png' 
	), 

	'photo_sizes' => array (
		'A' => '50x50' 
	),
	
	'avatar_photo_sizes' => array (
		'A' => '80x80' 
	),
	
	'homeimage_photo_sizes' => array (
		'A' => '590x242' 
	),
	
	
);

//Data Server Configuration
$config['data_server_path'] = $config['root_path'].'data/';

if(substr($_SERVER['SERVER_NAME'], 0, 4) == 'www.') {
	$config['data_server'] = 'http://www.'.$config['domain'].'/data/';
}
else {
	$config['data_server'] = 'http://'.$config['domain'].'/data/';
}

//FCKEditor Setup
$config ['fckfiles_short'] = '/data/uploads/fck/';
$config ['fckfiles'] = $config ['data_server_path'] . '/uploads/fck/';

$config['recaptcha_public_key'] = '6Le7n7wSAAAAAHth1qfwrobV6zV29O4NQbY67vJF';
$config['recaptcha_private_key'] = '6Le7n7wSAAAAAEQ-Ljdys7exRAj7EQA5NGYSbH02';

//PayPal Settings
$config['paypal'] = array(
	'url' => 'https://www.paypal.com/cgi-bin/webscr', //url na koeto da prashta formata
	'business' => 'demo@cloneforest.com', //Your PayPal ID or an email address associated with your PayPal account. Email addresses must be confirmed. 
	'currency' => 'USD' //valuta v koqto e cenata EUR, USD etc.
);

//Emoticons
$config['emoticons'] = array(
	':D' => 'emoticon_grin.png',
	':O' => 'emoticon_surprised.png',
	']:)' => 'emoticon_evilgrin.png',
	':))' => 'emoticon_happy.png',
	':P' => 'emoticon_tongue.png',
	':(' => 'emoticon_unhappy.png',
	';)' => 'emoticon_wink.png',
	':)' => 'emoticon_smile.png',
);

?>