<?php 

$langArray = array(

#BASE
	'username' => 'Username',
	'password' => 'password',
	'email' => 'E-mail',
	
	'remember_me' => 'Remember me',
	'login' => 'Login',
	'logout' => 'Logout',

	'welcome' => 'Welcome',
	'edit_my_profile' => 'Edit my profile',
	'back' => 'Back',
	'back_to_site' => 'Back to site',

	'add' => 'Add',
	'add_new' => 'Add new',
	'edit' => 'Edit',
	'delete' => 'Delete',
	'list' => 'Preview',
	'send' => 'Send',
	'save' => 'Save',

	'yes' => 'Yes',
	'no' => 'NO',

	'up' => 'Up',
	'down' => 'Down',

	'menu' => 'Menu',
	'home' => 'Home',

	'users' => 'Users',
	'groups' => 'Groups',
	'systems' => 'System settings',
	'system' => 'Settings',
	'support' => 'Support',

	'add_complete' => 'The information has been added successfully.',
	'edit_complete' => 'The information has been changed successfully.',
	'delete_complete' => 'The information has been deleted successfully.',
	'send_complete' => 'Sending completed.',

	'error_fill_this_field' => 'This field is obligatory.',
	'error_fill_this_field_all_langs' => 'This field is obligatory for all languages.',
	'error_fill_this_field_on' => 'This field is obligatory for ',
	'error_invalid_username_or_password' => 'Invalid username or password or the account is not activated.',

	'contact_with_us_info' => 'To contact us you can send us an email using the email contact form and we will answer you as soon as possible.',
	'request_sended' => 'Your request has been sent successfully. We will answer you as soon as possible at the phone number or the email you have indicated.',
	'contact_sended' => 'Your email has been send successfully. We will answer you as soon as possible at the phone number or the email you have indicated..',
	
	'system_information' => 'System information',
	'system_information_text' => '',

	'keyword' => 'Key word',
	'value' => 'Value',
	'subject' => 'Subject',
	'text' => 'Text',

	'meta_title' => 'Meta title',
	'meta_keywords' => 'Meta keywords',
	'meta_description' => 'Meta description',

	'waiting' => 'Waiting activation', 
	'activate' => 'Activated', 
	'banned' => 'Forgotten (banned)', 
	'generate_rand_password' => 'Generate a random password',

	'avatar' => 'Avatar',
	'city' => 'City',
	'address' => 'Address',
	'postcode' => 'Post code',
	'phone' => 'Telephone',
	'names' => 'Names',
	'status' => 'Status',
	'name' => 'Name',
	'modules' => 'Modules',
	'sort' => 'Sort',

	'addPhotos' => 'Add image',
	'choose_photos' => 'Choose an image',
	'via_url' => 'Add via URL (*.jpg, *.gif, *.png)',
	'title' => 'Title',

	'error_exist_username' => 'The username is not available.',
	'error_not_valid_email' => 'The e-mail you have entered is not valid.',
	'error_exist_email' => 'The e-mail you have entered is already taken.',
	'access_error' => 'You do not have rights to accesss this module.',

	'error_no_file_upload' => 'No file is attacted.',
	'error_invalid_file_ext' => 'The file is not allowed.',
	'error_file_too_big' => 'The file is too big',
	'error_file_not_set' => 'You have not chosen a file',

	'bg' => 'Bulgarian',
	'en' => 'English',

	'copy_value' => 'Copy the value of the field for all languages.',

###
#	GLOBALS
###

	'are_you_sure_to_delete' => 'Are you sure you want to delete',
	'no_records' => 'No records found.',

	#PAGES
	'pages' => 'Pages',

	'visible' => 'Visible',
	'in_menu' => 'Show in the main menu',
	'subpages' => 'Subpages',
	'subpage_of' => 'Subpage of',
	'none' => 'None',
	'key' => 'Key',

	'error_key_exist' => 'A page with this key already exists.',

	#CATEGORIES
	'categories' => 'Categories',

	'subcategories' => 'Subcategories',
	'subcategory_of' => 'Subcategory of',

	#TAGS
	'tags' => 'Tags',

	#ATTRIBUTES
	'attributes' => 'Attributes',
	'attribute' => 'Attribute',

	'type' => 'Type',
	'photo' => 'Photo',

	#QUIZ
	'quiz' => 'Quiz',
	
	'answers' => 'Answers',
	'answer' => 'Answer',
	'right' => 'Right',

	#BULLETIN
	'bulletin' => 'Bulletin',

	'emails' => 'E-mails',
	'send_bulletin' => 'Create a new bulletin',
	'unsubscribe' => 'Unsubscribed',
	'subscribe' => 'Subscribe',
	'unsubscribe2' => 'Unsubscribe',
	'readed' => 'Read',
	'view' => 'View',
	'sended_at' => 'Send to',

	#COUNTRIES
	'countries' => 'Countries',

	#ITEMS
	'items' => 'Items',

	'queue' => 'Queue',
	'date' => 'Date',
	'preview' => 'Preview',
	'user' => 'User',
	'none1' => 'None',

	'action' => 'Action',
	'approve' => 'Approval',
	'back_with_comment' => 'Return the item with a comment',
	'remove_item' => 'Remove the item',
	'price' => 'Price',
	'free_file' => 'Free file',

	'are_you_sure_submit' => 'Are you sure you want to submit this action?',

	'queue_update' => 'Queue updated',
	'remove_item_update' => 'Remove item update',
	'new_price' => 'New price',
	'weekly_features_to' => 'Weekly features to',

	'reported' => 'Reported',
	'previewed' => 'Previewed',

	#PERCENTS
	'percents' => 'Percentages',

	'percent' => 'Percentage',
	'from_sum' => 'From sum',
	'to_sum' => 'To sum',

	'error_from_over_to' => 'The final sum must be higher that the initial one',

	#CONTACTS
	'contacts' => 'Contacts',

	#USERS
	'withdraws' => 'Gain paying up',

	'australian_res' => 'Australian resident',
	'paid' => 'Paid',
	'payout' => 'Pay out',

	'complete_withdraw' => 'The is notified as paid out and is deducted for the user',
	'error_set_valid_sum' => 'You have to enter a valid sum',
	'error_not_enought_money_earning' => 'The user has not gained the money which is indicated',

#ADMIN MENU
	'dashboard' => 'Dashboard',
	'report_comments' => 'Reported comments',
	'reports' => 'Reports',
	'reported_by' => 'Reported by',
	'report_check' => 'Report previewed',

#ADMIN
	'sales_this_month' => 'This month\'s sales',
	'users_this_month' => 'This months\'s users',
	'sales_total' => 'Totals sales',
	'users_total' => 'Total users',
	'win_this_month' => 'This month\'s profit',
	'clear_win_this_month' => 'This month\'s net profit',
	'referal_money_this_month' => 'Referent program money',
	'user_win_this_month' => 'User\'s profit',
	'withdraw_this_month' => 'Sums for paying out this month',
	'withdraw_true_this_month' => 'Paid out sums this month',
	'finance' => 'Finance',
	'items_for_approve' => 'Items for approval',
	'no_items_for_approve' => 'No items for approval',
	'quick_links' => 'Quick links',
	'win' => 'Profit',
	'request_date' => 'Request date',
	'commission' => 'Commission',
	'sales_earnings' => 'Sales earnings',
	'referal_earnings' => 'Referal earnings',
	'issue_categories' => 'Issue categories',
	'complete_answer_issue' => 'Your reply has been sent successfully to the user.',
	'error_answer_issue' => 'Sending reply error occurred',
	'wrote' => 'Wrote',
	'last_contact' => 'Last contact',
	'read_more' => 'Read more',
	'language' => 'Language',
	'complete_change_language' => 'You have successfully changed the system language',

	'from_date' => 'From date',
	'to_date' => 'To dat',
	'report_type' => 'Report type',
	'generate_report' => 'Generate report',
	'results' => 'Results',

	'report_1' => 'Global',
	'report_2' => 'Earnings',
	'report_3' => 'Deposit',
	'report_4' => 'Paid out sums',
	'report_5' => 'At users ',

#FRONT
	
	'complete_unsubscribe' => 'You have successfully unsubscribed form our bulletin',

	'sign_up' => 'Registration',
	'verify_email' => 'Registration confirmed',
	'complete' => 'complete',

	'all_fields_required' => 'All fiels are obligatory',

	'step' => 'Step',
	'view_all' => 'View all',

	'your_details' => 'Profile details',
	'account_information' => 'Account information',
	'first_name' => 'Name',
	'last_name' => 'Last name',
	're_type' => 'Retype',
	'check_availability' => 'Check whether it is aveilable',
	'agree_with_terms' => 'I declare that I agree with the webiste terms of use',
	'sign_me_to_newsletter' => 'Add my email in the bulletins',
	'create_account' => 'Create my account',
	'why_sign_up' => 'Why should I sign up?',
	'why_sign_up_info' => '<p>It only takes a couple of minutes and your account will let you:</p>
		<ul class="fancy-list">
			<li>Deposit Cash &amp; Download Files</li>
			<li>Have Your Own Profile Page</li>
			<li>Chat on the Forums</li>
			<li>Sell Your Own Work</li>
			<li>Refer Members to Make Money</li>
		</ul>',

	'error_short_pass' => 'The password is too short',
	'error_bad_pass' => 'The password is not strong enough. Please type a more complicated password',
	'error_good_pass' => 'The password is good',
	'error_strong_pass' => 'The password is complicated. Well done!',
	'error_same_password' => 'The password and the username are the same.',
	'error_sensetive_pass' => 'Choose a secured password for your account. Passwords such as \'123456\', \'password\' and \'xxxxxx\' are not recommended!',

	'error_not_set_username' => 'You have to input a username',
	'error_exist_username' => 'The username already exists. Please input another.',
	'error_free_username' => 'The username is free',
	'error_not_valid_username' => 'The usermane have to consists only of letters, numbers and low dash',
	'error_password_not_match' => 'The two passwords do not match',
	'error_emails_not_match' => 'The e-mails do not match',
	'error_not_agree_with_terms' => 'You must agree the website terms of use',
	'error_wrong_captcha' => 'You have to input the code from the picture',
	'error_fill_firstname' => 'You have to input your name',
	'error_fill_lastname' => 'You have to input your last name',
	'error_fill_email' => 'You have to input your email',
	'error_fill_email_confirm' => 'You have to confirm your email',
	'error_fill_password' => 'You have to input your password',
	'error_fill_password_confirm' => 'You have to confirm your password',
	'error_not_valid_activate_key' => 'Profile activation key is not valid.',
	'error_invalid_username_email' => 'No match found between your username and the email you have input',
	'error_invalid_user_email' => 'Invalid user email',
	'error_wrong_old_password' => 'Your current password is not valid',
	'error_choose_license' => 'You have to choose your license',
	'error_wrong_category' => 'You have to chosen a non-existing category',
	'error_not_set_name' => 'You have to input a name',
	'error_not_set_description' => 'You have to input description',
	'error_not_set_thumbnail' => 'You have to choose a thumbnail',
	'error_thumbnail_jpg' => 'Thumbnail should be JPG or PNG file',
	'error_not_set_theme_preview' => 'You have to choose a theme preview',
	'error_theme_preview_zip' => 'Theme preview should be ZIP file',
	'error_not_set_main_file' => 'You have to choose a file',
	'error_main_file_zip' => 'Main file should be ZIP file',
	'error_not_set_category' => 'You have to choose a category',
	'error_not_set_tags' => 'You have to fill the three fields with tags',
	'error_not_set_source_license' => 'You have to confirm that you have rights to use all the materials in your template',
	'error_set_all_attributes' => 'You have to mark all the attributes',
	'error_set_price' => 'You have to input price',
	'error_set_comment_to_user' => 'You have to set comment to the user',
	'error_quiz' => 'You have to answer all questions correctly. You have {$RIGHT} right answers from {$TOTAL} questions',
	'error_not_set_price' => 'You have to input price',
	'error_deposit' => 'An errror occurred whlie recieving deposit',
	'error_not_set_question' => 'You have not asked a question',
	'error_not_set_answer' => 'You have not set an answer',
	'error_login_to_buy' => 'You have to login to shop',
	'error_paing' => 'Payment error',
	'error_not_enought_money' => 'You don\'t have enough money in your account',
	'error_item_comment' => 'An error occurred when leaving a comment',
	'error_not_set_message' => 'You have to write a message',
	'error_all_fields_required' => 'You have to fullfil all the fields',
	'error_invalid_email' => 'The email you have input is not valid',
	'wrong_amount' => 'You have not input a sum',
	'wrong_amount2' => 'You have input an invalid sum',
	'error_service' => 'You have not choosen a way of payment',
	'error_payment_email_address' => 'You have to input and confirm you email',
	'error_australian_resident' => 'you have to input ABN and ACN',
	'error_certificate' => 'You have to buy a theme to get a certificate',

	'complete_create_account' => 'Your profile was created successfully. An account activation has been sent to the indicated email.',
	'complete_activate_account' => 'You account has been activated successfully. You can login with your username and password.',
	'complete_reset_password' => 'You new password is sent to your email',
	'complete_send_username' => 'Your username is sent to your email',
	'complete_change_password' => 'Your password is successfully changed',
	'complete_exclusive_author_off' => 'You are unsubscribe as exclusive author',
	'complete_exclusive_author_on' => 'You have been marked as exclusive author',
	'complete_save_license' => 'You selling licenses are successfully saved',
	'complete_change_avatar_image' => 'You have successfully changed your avatar and profile photo',
	'complete_update_personal_info' => 'Your personal data has been successfully saved',
	'complete_update_social_networks' => 'You have successfully changed your social networks',
	'complete_upload_item' => 'Your item has been added to the approval queue',
	'complete_approve_item' => 'The item is approved successfully',
	'complete_unapprove_item' => 'The item is returned to user for revision',
	'complete_delete_item' => 'The item is successfully deleted',
	'complete_update_item' => 'You changed your item successfully',
	'complete_update_upload_item' => 'The changes are accepted. After our administrators review it, they will be visible in the site',
	'complete_delete_item' => 'The item has been removed from the data base', 
	'complete_approve_item_update' => 'The item\'s updates are approved',
	'complete_delete_item_update' => 'the item\'s updates are rejected',
	'complete_score_quiz' => 'The quiz is successfully passed. You can start selling your works.',
	'complete_deposit' => 'Your deposit has been marked successfully. You can now shop from our website',
	'complete_add_faq' => 'The question and the answer have been added successfully',
	'complete_delete_faq' => 'The question and the answer have been deleted successfully',
	'complete_buy_theme' => 'The theme has been successfully bought',
	'complete_add_comment' => 'The comment has been added successfully',
	'complete_report_comment' => 'Thank you for reporting the comment',
	'complete_add_reply' => 'Your reply has been added successfully',
	'complete_bookmark_item' => 'The theme is added to your favorites',
	'complete_add_collection' => 'The collection has been added successfully',
	'complete_edit_collection' => 'The collection has been changes successfully',
	'complete_delete_collection' => 'The collection has been deleted',
	'complete_delete_bookmark' => 'The theme is removed form your collection',
	'complete_save_feature' => 'The updates are saved',
	'complete_send_email' => 'The mail is sent successfully',
	'complete_add_to_newsletter' => 'Your email is added to your newsletter',
	'complete_add_withdrawal' => 'Your request for recieving the earned money is accepted',

	'already_in_newsletter' => 'Your email is already added tou our newsletter',
	'error_newsletter' => 'An error occurred while adding the data. Please check and try again',

	'forgot_password' => 'Forgotten password',
	'forgot_username' => 'Forgotten username',
	'its_free' => 'It is free',
	'register_now' => 'Register now',

	'reset_password_info' => 'Fill your username and email and we will send you the new password there',
	'reset_password' => 'New password',
	'lost_username_info' => 'Fill the email you have signed up and we will send you our usename',

	'my_account' => 'My account',

	'change_your_password' => 'Change your password',
	'current_password' => 'Current password',
	'new_password' => 'New password',
	'exclusive_author' => 'Exclisive Author',
	'exclusive_author_info' => '<p>Agreeing to keep your portfolio of items for sale exclusive to the Marketplaces entitles you to a higher percentage of each sale - from 40% to 70%. You can still sell <strong>other</strong> items elsewhere (on other marketplaces, your own site) however any items you place on an Marketplace must be exclusively sold there.</p><p>Your account is set up as:</p>',
	'exclusive_author_true' => '<h3 class="underlined">Exclusive Author</h3><p>You can opt-out of the exclusivity program by clicking the button below. You will be given a 30 day grace period wherein the agreement is still observed after which your payments will return to normal and you may commence selling your items elsewhere.</p>',	
	'exclusive_author_false' => '<h3 class="underlined">Non-Exclusive Author</h3><p>You can opt-out of the exclusivity program by clicking the button below. You will be given a 30 day grace period wherein the agreement is still observed after which your payments will return to normal and you may commence selling your items elsewhere.</p>',
	'exclusive_off' => 'Unsubscribe me as exclusive author',
	'exclusive_on' => 'Subscribe me as exclusive author',
	'sale_license' => 'Sale license',
	'sale_license_info' => '<p>Choose the licences that your items are sold under. Note that not all licences will be used for all types of items. The Standard Single-Use Licence is mandatory.</p>',
	'extended_license' => 'Full license',
	'personal_license' => 'Personal use license',	
	'avatar_homepage_image' => 'Avatar and image page',
	'homepage_image' => 'Profile photo',
	'replace' => 'Replace',
	'personal_information' => 'Personal information',
	'company_name' => 'Company name',
	'company_name_info' => 'If you want your invoices addressed to a company. Leave blank to use your full name.',
	'profile_head' => 'profile title',
	'profile_head_info' => 'Appears on your profile page',
	'profile_text' => 'Description',
	'lives_in' => 'Current city',
	'lives_in_info' => 'For example: Sofia',
	'do_not_display_country' => 'Do not show the country I\'m from',
	'country' => 'Country',
	'country_info' => 'Your country selection determines what flag appears in your badges',
	'available_freelance' => 'Available for Freelance?',
	'formatting_help' => '
<p>Format your entry with some basic HTML. or here is a refresher:</p>
<p>
	&lt;strong&gt;&lt;/strong&gt; to make things bold<br />
	&lt;em&gt;&lt;/em&gt; to emphasize<br />
	&lt;ul&gt;&lt;li&gt; or &lt;ol&gt;&lt;li&gt; to make lists<br />
	&lt;h3&gt; or &lt;h4&gt; to make headings<br />
	&lt;pre&gt;&lt;/pre&gt; for code blocks<br />
	&lt;code&gt;&lt;/code&gt; for a few words of code<br />
	&lt;a&gt;&lt;/a&gt; for links<br />
	&lt;img&gt; to paste in an image (it\'ll need to be hosted somewhere else though)<br />
	&lt;blockquote&gt;&lt;/blockquote&gt; to quote somebody<br />
</p>

<p class="smiley-help">
  <img src="/images/smileys/grin.png" alt=":grin:" />
  <img src="/images/smileys/shocked.png" alt=":shocked:" />
  <img src="/images/smileys/crying.png" alt=":cry:" />
  
</p>	
	',
	'social_network_links' => 'Social media profiles',

	'wrong_page' => 'You have chosen a non-existing page',
	
	'begin_upload' => 'Upload an item',
	'upload' => 'Upload',
	'help' => 'Help',
	'name_desc' => 'Name &amp; description',
	'description' => 'Description',
	'upload_name_info' => 'Max 50 symbols',
	'upload_desc_info' => 'This field is used for search, so please be descriptive!',	
	'files' => 'Files',
	'thumbnail' => 'Thumbnail',
	'thumbnail_info' => 'JPEG 80x80px Thumbnail',
	'theme_preview' => 'Theme Preview',
	'theme_preview_info' => 'ZIP file of images (png/jpg) w/ optional text descriptions for display on the site',
	'main_file' => 'Main Files(s)',
	'main_file_info' => 'ZIP - All Files For Download',
	'filesize_info' => 'Please note we only accept file sizes of up to 500mb.',
	'category_attributes' => 'Category &amp; Attribute',
	'demo_url' => 'Demo URL',
	'demo_url_info' => '*Optional* link to a live preview on your own hosting (i.e. http://my-site.com/demo/).',
	'category' => 'Category',
	'switch_category' => 'Choose category',
	'usage_tags' => 'Usage Tags',
	'usage_tags_info' => 'eg photography, designer, fashion, corporate',
	'style_tags' => 'Style Tags',
	'style_tags_info' => 'eg grunge, clean, vintage',
	'features_tags' => 'Features Tags',
	'features_tags_info' => 'eg jquery, php, Flash',
	'tags_info' => 'Enter up to 15 tags across all categories.',
	'message_to_reviewer' => 'Message to item reviewed',
	'comment' => 'Comment',
	'comment_info' => 'Please state URLs and details for any source images, code, video, audio or other items that you have used in the file, even if you have taken the photographs yourself.',
	'upload_terms' => 'Any images / sounds / video / code / flash used which are not my own work have been appropriately licensed for resale. Other than these items, this work is entirely my own and I have full rights to sell it on website.',
	'switch_upload_category' => 'Choose other category',
	
	'get_item_accepted' => 'Get your item accepted',
	'get_item_accepted_text' => '<p>To give your item the best chance possible to be accepted, please make sure you\'ve:</p>
      <ul class="fancy-list">
        <li>Read and follow the upload instructions.</li>
        <li>Listed any assets and their copyright compliance in the NOTES TO REVIEWERS box.</li>
        <li>Added useful tags and ensured they\'re spelled correctly (this helps buyers find your file).</li>
        <li>Added a thorough and useful item description (this also helps buyers find your file).</li>
      </ul>
    <p>If you\'ve done all that, you\'re ready to upload. Thanks for selling with us!</p>',

	'profile' => 'Profile',
	'settings' => 'Settings',
	'portfolio' => 'Portfolio',

	'wrong_user' => 'You have chosen an non-existing user',
	
	'page' => 'Page',
	'of' => 'of',
	'themes' => 'Themes',
	'no_items' => 'No items found',
	'sales' => 'Sales',
	'in' => 'In',
	'order_by' => 'Sort by',
	'rating' => 'Rating',
	'list_view' => 'List',	
	'grid_view' => 'Grid',

	'off_prepaid_deposit' => 'off any item when you use prepaid deposits!',
	
	'about_the_author' => 'About the author',
	'update_description' => 'Description update',
	'enter_new_details' => 'Enter new data',

	'wrong_item' => 'You have chosen a non-existing item',

	'save_changes' => 'Save changes',
	'update_item_tags_review' => 'Files and tags update (requires administrator\'s preview)',
	'delete_item' => 'Delete the item',
	'delete_item_question' => 'Are you sure you want to delete the item? Once deleted it can not ne restored again!',
	'delete_forever' => 'delete the item forever',

	'is_in_update_queue' => 'You have already make changes that are approved.',

	'message_quiz_to_upload' => 'In order to upload your files for sale first you have to pass our quiz.',
	'check_quiz' => 'check the quiz',
	'question' => 'Question',
	'quiz_info' => 'You have to answer all questions to sell you works',

	'deposit' => 'Deposit',
	'current_balance' => 'Currenet ballance',
	'need_invoice' => '<strong>Need a tax invoice?</strong><br />Make sure you\'ve added your company name to the',
	'how_much_deposit' => 'How Much Do You Want to Deposit?',
	'deposit_info' => 'Deposits are in US$, are non-refundable and will expire one year from your last deposit',
	'pay_via_paypal' => 'Pay via PayPal',
	'paypal_info' => 'You will be transferred to a secure PayPal page.<br/> After payment your cash will display in the top panel.',
	'pay' => 'Pay',
	'deposit_history' => 'Deposit from $',
	'paypal_proceed' => 'In a few seconds you will transferred in PayPal system.',
	'select_amount' => 'Select amount',
	'make_payment' => 'Make payment',
	'return_to_site' => 'Back to site',

	'wrong_item' => 'You have chosen a non-existing item',
	
	'screenshots' => 'Screenshots',
	'live_preview' => 'Preview',
	'by' => 'by',
	'comments' => 'Comments',
	'more_items_by' => 'More items by',
	'prepaid_just' => 'Prepaid customers<br/> pay just',
	'how' => 'How',
	'prepay_account' => 'Pay from account',
	'prepay_off' => 'With our deposit system not only will purchasing be much faster, but we’ll also take $2 off the price!',
	'click_to_deposit' => 'Charge your account',
	'this_is_your_file' => 'This is one of your files',	
	'votes' => 'Votes',
	'view_portfolio' => 'View portfolio',

	'all' => 'All',
	'features' => 'Features',
	'usage' => 'Usage',
	'style' => 'Style',
	'details' => 'Details',
	'faqs' => 'FAQs',
	'comments1' => 'Comments',
	'create_faq' => 'Create FAQ',
	'no_faq' => 'No questions and answers added yet.',

	'personal_license_info' => '<strong>You Can Use This Item In:</strong> a website (commercial, personal, client), or intranet site project ...',
	'extended_license_info' => '<strong>You Can Use This Item In:</strong> a template for a Web Service such as WPMU, or as part of a Software Package for sale ...',

	'purchase' => 'Buy',
	'buy_now_paypal' => 'Buy Now <span>(via PayPal)</span>',
	'via_paypal' => 'via PayPal',
	'redirect_to_paypal' => 'You will be redirected to pay',
	'use_prepaid_deposit' => 'Use Prepaid Deposits <span>(Save $2)</span>',
	'from_your_account_balance' => 'from your account balance',
	'make_deposit' => 'Make deposit',
	'already_buyed' => 'You have already bought this item. you can download it from <a href="{$URL}" title="">here</a>, but if you like you can buy it again',
	'remove_frame' => 'Remove the frame',
	'purchase_this' => 'Buy this item',
	'item_preview' => 'Preview the item',
	'comment_item' => 'Comment this item',
	'comment_reply_notify' => 'Notify me when I recieve a reply',
	'post_comment' => 'Post comment',
	'no_comments' => 'No comments posted yet',
	'says' => 'Says',
	'posted' => 'Posted ',
	'report' => 'Report',
	'reply' => 'Reply',

	'are_you_sure_report' => 'Are you sure you want to report irregularity?',

	'wrong_comment' => 'You have chosen a non-existing comment',
	'reply_to_comment' => 'Reply to comment',
	'post_reply' => 'Post your reply',	
	'author' => 'Author',
	'replied' => 'Replied',

	'all_right_reserved' => 'All rights reserved',
	'report_file' => 'Report this file',

	'bookmark_this' => 'Bookmark in favorites',
	'private_bookmark' => 'Personal favorites',
	'or' => 'or',
	'create_bookmark' => 'Create a new collection',
	'new_collection' => 'New collection',
	'public_visible' => 'Public view',

	'collections' => 'collections',
	'create_collection' => 'Create collection',
	'create' => 'Create',
	'your_public_collections' => 'Your public collections',
	'your_private_collections' => 'Your personal collections',

	'no_public_collections' => 'No public collections added',
	'no_private_collections' => 'No personal collections added',

	'wrong_collection' => 'You have chosen a non-existing collection',

	'home_info' => 'Site Templates and Themes from',
	'home_info2' => ' and etc.',

	'collection_owner' => 'Collection owner',
	'edit_collection' => 'Edit collection',
	'delete_collection' => 'Delete collection',
	'rate_this_collection' => 'rate this collection',
	'you_rate' => 'You rated with',

	'are_you_sure_delete_collection' => 'Are you sure you want to delete the collection?',
	'are_you_sure_delete_bookmark' => 'Are you sure you want to delete an item from the collection?',

	'download_for_free' => 'Download free',
	'free_file_info' => 'This file is marked as free. Every user has one personal license for free private use.<br />You can download the file from here<a href="{$URL}" title="">here</a>',

	'all_files' => 'All files',
	'all_categories' => 'All categories',
	'more_categories' => 'More categories',
	'browse_all_files' => 'Browse all files',

	'wrong_category' => 'You have chosen a non-existing category',

	'recent_items' => 'Recent Items',
	'more_recent_files' => 'Show More Recent Items',
	'grab_free_file' => 'Take a free copy of the file from',
	'here' => 'here',
	'featured_author' => 'Featured Author',
	'featured_author_info' => 'Our current featured author here on website is {$USERNAME} who joined in {$MONTH} {$YEAR}, has a portfolio of {$ITEMS} items for sale and has racked up {$SALES} sales!',
	'view_portfolio_of' => 'View portfolio of',
	'some_work_of' => 'Some works of',
	'start_browsing' => 'Browse files',
	'weekly_features' => 'Weekly Features',

	'featured_items' => 'Featured Item',
	'item' => 'Item',

	'public_collections' => 'Public collection',
	'view_all_collections' => 'View all collection',
	'feature_file' => 'Feature file',
	'member_since' => 'Member since',
	'social_profiles' => 'Social profiles',
	'profile_email_info' => 'All messages are recorded and spam is not tolerated.Your email address will be shown to the recipient.',
	'from' => 'from',
	'message' => 'Message',	
	'support_hours' => 'Support Hours',
	'support_hours_info' => 'Support is open 7 days a week. Support tickets will generally be answered within 24 hours, complex issues may take longer.',
	'send_support_ticket' => 'Send support ticket',
	'support_info' => 'Support can take up to 2 days during busy periods to answer your query, but the Wiki may have the answer you need, right now.',
	
	'contact_username' => 'Your username on the Marketplaces',
	'contact_email' => 'We need to know the email address which is registered to your Marketplace account for verification purposes.',
	'contact_issue' => 'Let\'s start with the best category your problem falls into.',
	'contact_paypal' => 'Tell us about the financial or transaction related issue you\'re experiencing.',
	'contact_transaction' => 'This information will help us to locate the payment in our account',
	'contact_financial' => 'Tell us about the financial or transaction related issue you\'re experiencing.',
	'contact_item' => 'Please provide us with a link to the item you would like a refund for.',
	'contact_details2' => 'Detailed explanation of the problem(s) you are experiencing with this item. Please be as specific as possible when describing the issue so that our reviewers can attempt to reproduce it.',
	'contact_details3' => 'Tell us about your account-related issue or question.',
	'contact_details4' => 'Please provide as much detail as possible.',
	'contact_details5' => 'Tell us about your copyright related issue. Please provide as much detail as possible.',

	'your_issue' => 'Your Issue',
	'select_issue' => '- Select an Issue -',
	'paypal_issue' => 'PayPal Issue',
	'general_financial_issue' => 'General Financial Issue',
	'item_or_file_issue' => 'Item or File Issues',
	'account_issue' => 'Account Issues',
	'copyright_issue' => 'Copyright Related Issues',
	'license_questions' => 'License Questions',
	'general_inquiry' => 'General Inquiry',

/*	'paypal_issue_info' => '<p>Due to the complex nature of financial enquires please be sure to provide all relevant information pertaining to your issue, including: a thorough explanation of your issue and any transaction receipt details, such as a PayPal transaction ID or MoneyBookers receipt number.</p><p>Providing this information will ensure that your issue is dealt with as quickly as possible.</p>',
	'transaction_id' => 'Transaction ID/Receipt ID',
	'financial_issue_info' => '<p>Due to the complex nature of financial enquires please be sure to provide all relevant information pertaining to your issue, including: a thorough explanation of your issue and any transaction receipt details, such as a PayPal transaction ID or MoneyBookers receipt number.</p><p>Providing this information will ensure that your issue is dealt with as quickly as possible.</p>',
	'item_issue_info' => '<h3>Item or File issues</h3>
<p>Unfortunately Support cannot assist you if you are experiencing general technical difficulties with an item that you have purchased on the Marketplace. If you are having difficulty getting an item you have purchased to work properly, please follow these simple steps.</p>
<ol>
	<li>Read the documentation that was provided with the file, even if you are an experienced user. There are often essential instructions contained in these documents.</li>
	<li>Read the comments and FAQ tab on the item page. If you\'re having a problem, chances are another buyer has been in the same position. There may already be an answer to your question there. If your problem hasn\'t yet been addressed, you can post a new question on the item page.</li>
	<li>Ensure you have the technical skills required to utilize the file effectively. Generally all files purchased on the Marketplace will require at least some prior knowledge to use correctly. If you\'re not sure, try searching Google for a how-to.</li>
	<li>If you still cannot get the file to work as desired, you can contact the author of the file via their profile page on the Marketplace. It is important to note that, although encouraged to do so <strong>authors ARE NOT required to provide Support and you are not guaranteed a response.</strong></li>
</ol>
<p>If you have completed these steps and still believe the file is not as described or malfunctioning, you may request a refund in the form of a site credit.</p>
<h3>Our refund policy</h3>
<p>We will happily issue a refund as a site credit for any file which is not as described, or if it is malfunctioning. In instances where a file has been purchased incorrectly, we will only refund if you have not already downloaded the file.</p>
<p><strong>Please note</strong> - initiating an unauthorized chargeback with your financial institution or illegitimately disputing a transaction using PayPal or MoneyBookers is considered fraud and will result in the disablement of your account until the issue has been resolved. Please note that deposits are non-refundable as laid out in our Membership Terms and Conditions (Clause 13. Payments from Member Ledger).</p>',
	'account_issue_info' => '<h3>Account Issues</h3>
<p>If you are having difficulty accessing your account and are receiving an error that says:<em>"too many attempts to log in"</em>, then please wait one hour and then try again. If you are still having difficulties, please try resetting your password by using the <a href="http://activeden.net/reset_password">forgotten password tool</a>.</p>
<p><strong>Finally, if you still cannot gain access try clearing your browser cookies and cache.</strong></p>
<h3>Username Changes</h3>
<p>When submitting a username change request to Support, please provide two preferences for your new username in case the first is already taken. <em>Note: Users can only change their username once.</em></p>',
	'copyright_issue_info' => '<p><strong>If you believe an item on the Marketplace infringes your copyright, you must submit an official DMCA take-down notification.</strong><br/><br/> Marketplace takes allegations of copyright infringement seriously, which is why we ask all individuals or entities that believe their copyright has been infringed to send us an official and legal notification of the infraction. This is due to the serious nature of these allegations and the possible legal implications for all parties involved. For more information on how to submit a DMCA request, please read here: </p>
<p>
	<strong>
		<span style="font-weight: normal;">
			<em>Please send all completed DMCA requests to:</em>
		</span>
		<br />
		<span style="font-weight: normal;">
			
		</span>
	</strong>
</p>
<h3>Report Copyright Violation</h3>
<p><strong>If you would like to report a possible violation which you have noticed that does not directly involve you.</strong><br/><br/>
If you are concerned an item on the Marketplace may infringe on another person or company\'s copyright and would like to let us know, please provide as much detail as possible and use the form below. We will take any actions necessary upon receipt of your notice. <em>Please be aware that we will not respond to these emails unless specifically requested to.</em></p>
<p><strong>If you have found any of our content being pirated content online.</strong><br/><br />
Please tell us about it! Make sure to include a link(s) to the content which you have found being distributed illegally. We will take any actions necessary to get these files removed.</p>',
	'license_issue_info' => '<strong>Support cannot answer license questions.</strong> Unfortunately, due to the sensitive and legal nature of licensing questions, Support is not qualified to provide assistance with these types of inquiries. Please review all relevant support documentation regarding licenses.',
*/

	'description_of_issue' => 'Description of your issue',

	'item_link' => 'Item Link',
	'how_can_we_help' => 'How can we help you?',
	
	'issue' => 'Issue',
	'submit' => 'Send',

	'monthly_newsletter' => 'Monthly Newsletter',
	'check_out_the_archive' => 'CHECK OUT THE ARCHIVE',

	'no_bulletin' => 'No bulletins addede yet',
	'followers' => 'Followers',
	'follow' => 'follow',
	'unfollow' => 'unfollow',
	'authors_i_follow' => 'Authors I Follow',

	'history' => 'History',
	'deposit_history1' => 'Deposit History',
	'transaction_id1' => 'Transaction id',
	'when' => 'When',
	'withdrawal' => 'Withdrawal',

	'your_total_balance_is' => 'Your total account balance is',
	'withdraw_earning' => 'This includes cash deposited through PayPal and earnings.  You are only able to withdraw earnings.',
	'current_balance_deposit' => 'Current Balance of Cash Deposited (Paid via PayPal)',
	'current_balance_earning' => 'Current Balance of Earnings (What you can withdraw)',

	'make_payment_request' => 'Make a Payment Request',
	'payment_info' => 'All withdrawals are issued on the 15th of the following month (except when the 15th falls on a weekend or public holiday, in which case it is issued on the next business day).',
	'amount' => 'Amount',
	'all_earning_note' => 'Please note that the "ALL EARNINGS" request must be renewed each month.<br />This means clicking it will not result in automatic withdrawals for future months.',
	'all_earning' => 'All earnings',
	'available_at' => 'available at',
	'all_earning_info' => 'If you choose the "All earnings" option, you must still meet the minimum withdrawal amounts below.  Your withdrawal request will not be processed unless it meets the minimum requirements.',
	'payment_method' => 'Payment Method',
	'payment_info2' => 'Minimum $50.00 for Moneybookers and PayPal<br />Minimum $500.00 for International Money Transfer',
	'paypal_address' => 'Paypal Address',
	'moneybookers_address' => 'Moneybookers Address',
	'confirm_address' => 'Please confirm address',
	'swift_transfer' => 'You Full Address (including country):
Bank Account name (your full name that appears on your bank account statement):
Bank Account number:
SWIFT Code:
IBAN (if any):
Bank Name in Full:
Bank Branch Address:
Destination Country:',
	'taxation' => 'Taxation',
	'australian_resident' => 'I am an Australian Resident for Taxation Purposes.',
	'i_am_author' => 'I am an author as a hobby and have another main source of income.',
	'i_am_not_author' => 'I am not an author as a hobby and/or this is my main source of income.',
	'swift_info2' => 'Please note that a $35.00 transaction fee is charged on all International Transfers (SWIFT).<br /><br />Marketplace cannot be held responsible for delays, extra costs or financial loss that arises from being provided incorrect account information, so please ensure that you double check the details with your financial institution prior to submitting a request for a SWIFT Wire Transfer.',
	'submit_request' => 'Submit Request',
	
	'downloads' => 'Downloads',
	'download_immediately' => 'Download Immediately',
	'download_immediately_info' => 'You should download your purchases <strong>immediately</strong> as items may be removed from time to time.',

	'no_download_items' => 'No items bought yet',
	'download' => 'Download',

	'license_certificate' => 'Licence Certificate',
	'current_featured_item' => 'Current featured item',
	'featured_last_six_months' => 'Items Featured in the Last Six Months',
	'featured_authors' => 'Recently Featured Authors',
	'browse_categories' => 'Browse Categories',
	'featured_files' => 'Featured Files',
	'available_freelancer' => 'Available for freelance work',
	'top_authors' => 'Top Authors',
	'view_public_collections' => 'View public collections',

	'verify_registration' => '<h2 class="decorator">Check Your Email</h2><p>You\'ll receive an email with a verification link.<br/>Click the link to finalise your account!</p>',
	'complete_activate' => '<h2 class="decorator">Congratulations</h2><p>Your account is now ready to roll! You can now:</p>',
	'deposit_cash' => 'Deposit Cash and Download Files',
	'have_own_profile' => 'Have Your Own Profile Page',
	
	'old_price' => 'Old price',
	'one_extended_licence' => 'ONE EXTENDED LICENCE',
	'one_regular_licence' => 'ONE REGULAR LICENCE',

	'licence_text' => '
LICENCE CERTIFICATE : {$DOMAIN}
==============================================

This document certifies the purchase of:
{$LICENCE}
as defined in the standard terms and conditions on the Marketplaces.

Licensor\'s Author Username: {$USERNAME}
Licensee: {$FIRSTNAME} {$LASTNAME}

For the item:
{$ITEMNAME}

http://{$DOMAIN}/{$LANGUAGEURL}items/{$ITEMID}
Item ID: {$ITEMID}

Licence Code: LCN{$ORDERID}



For any queries related to this document or license please contact support@{$DOMAIN}.


==== THIS IS NOT A TAX RECEIPT OR INVOICE ====		
	',

	'freelance' => 'Freelance',
	'i_am_available' => 'I am available',
	'this_week_stats' => 'This Week\'s Stats',
	'you_earned' => 'You have earned',
	'you_sold' => 'You have sold',	

	'earnings' => 'Earnings',
	'redeem_earning' => 'Redeem Your Earnings?',
	'request_payout' => 'Request a Payout',
	'your_current_rate' => 'Your Current Rate',
	'rate_info1' => 'Your rates are determined based on whether you are selling items exclusively on the Marketplaces and on your volume of sales.',
	'rate_info2' => 'That\'s the total value of sales you\'ve made on the Marketplaces! We use that figure to determine what your rate is. You just need to make...',
	'rate_info3' => '...more to get to the next commission rate. See <a href="/percents/">Table of Rates</a> for more info.',

	'total_earning' => 'Total Earnings',
	'referals' => 'Referrals',
	'month' => 'Month',
	'buy_items' => 'Items bought',
	'your_balance' => 'Your Balance',
	'following_items' => 'Following items',

	'no_referals_earning' => 'You have not yet get any money from a referal program',
	'total_referal_earning' => 'Total Referral Earnings',
	'total_sales' => 'Total Sales',
	'sales_graph' => 'Sales Graph',
	'earnings_graph' => 'Earnings Graph',
	'statement' => 'Statement',
	'download_csv' => 'Download a CSV File',
	'download_csv_info' => '<p>This is a full statement of activity that has altered your account balance. It lists all your items sales, purchases, deposits, withdrawals, exclusive author program enrollment and un-enrollment, referral program earnings, etc.</p><p>You can <strong class="strong"><a href="{$URL}">download your statement in CSV format</a></strong>, open it in a spreadsheet and perform your own calculations, graphing, etc.</p>',
	'statement_for' => 'Statement for',
	'current_month' => 'Current Month (incomplete statement)',
	'past_statements' => 'Past Statements',
	'withdraw_money' => 'withdraw',
	'receive_money' => 'Received',
	'purchase_money' => 'Purchase money',
	'deposit_money' => 'deposit money',
	'earning_money' => 'Money earning',
	'buy_item' => 'Buy an item',
	'sold_item' => 'Items sold',
	'referal_money' => 'Money earned through referal program',
	'to' => 'To',

	'your_recent_comments' => 'Your Recent Comments',

	'want_to_be_freefile' => 'I want my file to be free',

	'welcome_text' => 'Welcome to website! Read our, visit the for recent news and make yourself at home! You can find information in our.',
	'last_signin' => 'LAST SIGNIN',
	'balance' => 'BALANCE',
	'balance1' => 'Balance',
	'hello' => 'Hello',
	'popular_files' => 'Popular Files',
	'searching' => 'Search',
	'upload_theme' => 'Upload theme',
	'lost_username' => 'Restore username',
	'new_username' => 'New user name',

	'weekly_top_sells' => 'Weekly Top Sellers',
	'three_monthly' => 'Top Sellers - 3 months ending',
	'top_authors_in' => 'Top Authors in',
	'week_ending' => 'Week Ending',

	'start_searching' => 'Start Searching',
	'finetune_results' => 'Fine-tune results',
	'search_within' => 'Search Within',
	'view_account_history' => 'View Account History',

	'no_results_found' => 'No Results Were Found',
	'search_for' => 'Search For',
	'search_in' => 'Search In',
	'search_again' => 'Search Again',
	'search' => 'Search',
	'search_collections' => 'Search Collections',
	'show_popular_items' => 'Show Popular Items',
	'purchased' => 'Purchased',

	'grid_total' => 'Total earnings',
	'grid_receive' => 'Users\' commission',
	'grid_referal' => 'Referal program sums',
	'grid_win' => 'Net total',
	'grid_deposit' => 'Deposit sum',
	'grid_withdraw' => 'Paid out sums',
	'graph' => 'Graphic',
	'filter' => 'Filter',

	'what_are_collections' => 'What are Collections?',
	'what_are_collections_text' => 'Collections are groups of items compiled by different users on a theme.<br /><br />They can be set to Private for personal use, or Public so that they appear on this page and on a user\'s homepage.',
	'ok' => 'OK',
	'no_collections' => 'No collections found',

	'marketplace_members' => 'Marketplace Members',
	'total_marketplace_items' => 'Total Marketplace Items',
	'follow_us' => 'Follow us',
	'rss_feed' => 'RSS Feed',
	'help_and_support' => 'Help and Support',
	'contact_support' => 'Contact Support',
	'terms_of_usage' => 'TERMS OF USAGE',
	'copyright' => 'COPYRIGHT',
	'category_rss' => 'New Item Notifications For This Category',
	'user_rss' => 'New Item RSS Feed',
	'currency' => 'Currency',

# EMAILS
	'email_activate_subject' => 'Activate your profile',
	'email_activate_text' => 'To actovate your profile in {$DOMAIN}, please click the following link:	

{$LINK}
', 

	'email_reset_password' => 'New password',
	'email_reset_password_text' => 'Your data for login in {$DOMAIN} are:	

usename: {$USERNAME}
password: {$PASSWORD}
', 

	'email_lost_username' => 'Send your username',
	'email_lost_username_text' => 'Your username for {$DOMAIN} is {$USERNAME}',

	'email_unapprove_item_subject' => 'Your item was unapproved',
	'email_unapprove_item_text' => 'Your item {$THEMENAME} is returned for approval with the following comment:

{$COMMENT}	
	
You can change the item and release it again for approval.
	',

	'email_unapprove_delete_item_subject' => 'Your item was rejected',
	'email_unapprove_delete_item_text' => 'Your item {$THEMENAME} is rejected with the following comment:

{$COMMENT}	
	',

	'email_unapprove_delete_item_update_subject' => 'Your item update was rejected',
	'email_unapprove_delete_item_update_text' => 'Updates of your item {$THEMENAME} we rejected with the following comment:
	
{$COMMENT}	
	',

	'email_report_comment_subject' => 'Have new reported comment',
	'email_report_comment_text' => 'Report about irregularity in comment.',

	'email_new_reply_subject' => 'Have new reply to your comment',
	'email_new_reply_text' => 'A reply is added to your comment {$THEMENAME}
	
{$URL}	
	',

	'email_profile_subject' => 'Message from your profile',
	'email_profile_text' => '{$USERNAME} ({$EMAIL}) sent you an email:
	
{$MESSAGE}	
	',

);

$langArray['monthArr'] = array(
	1 => 'January',
	2 => 'February',
	3 => 'March',
	4 => 'April',
	5 => 'May',
	6 => 'June',
	7 => 'July',
	8 => 'August',
	9 => 'September',
	10 => 'Octomber',
	11 => 'November',
	12 => 'December',
	'01' => 'January',
	'02' => 'February',
	'03' => 'March',
	'04' => 'April',
	'05' => 'May',
	'06' => 'June',
	'07' => 'July',
	'08' => 'August',
	'09' => 'September'
);

$langArray['earningArr'] = array(
	100 => 'Sold between 0 and 100',
	1000 => 'Sold between 100 and 1 000'
);

$langArray['moneyArr'] = array(
	10 => 'Bought between 1 and 10 items',
	100 => 'Bought between 10 and 100 items'
);

?>