<?php
/**
*
* @ This file is created by Decodeby.US
* @ deZender Public (PHP5 Decompiler)
*
* @	Version			:	1.0.0.1
* @	Author			:	Ps2Gamer & Cyko
* @	Release on		:	07.06.2011
* @	Official site	:	http://decodeby.us
*
*/

class geoip
{

    public $flags = NULL;
    public $filehandle = NULL;
    public $memory_buffer = NULL;
    public $databaseType = NULL;
    public $databaseSegments = NULL;
    public $record_length = NULL;
    public $shmid = NULL;
    public $GEOIP_COUNTRY_CODE_TO_NUMBER = array
    (
        "" => 0,
        "AP" => 1,
        "EU" => 2,
        "AD" => 3,
        "AE" => 4,
        "AF" => 5,
        "AG" => 6,
        "AI" => 7,
        "AL" => 8,
        "AM" => 9,
        "AN" => 10,
        "AO" => 11,
        "AQ" => 12,
        "AR" => 13,
        "AS" => 14,
        "AT" => 15,
        "AU" => 16,
        "AW" => 17,
        "AZ" => 18,
        "BA" => 19,
        "BB" => 20,
        "BD" => 21,
        "BE" => 22,
        "BF" => 23,
        "BG" => 24,
        "BH" => 25,
        "BI" => 26,
        "BJ" => 27,
        "BM" => 28,
        "BN" => 29,
        "BO" => 30,
        "BR" => 31,
        "BS" => 32,
        "BT" => 33,
        "BV" => 34,
        "BW" => 35,
        "BY" => 36,
        "BZ" => 37,
        "CA" => 38,
        "CC" => 39,
        "CD" => 40,
        "CF" => 41,
        "CG" => 42,
        "CH" => 43,
        "CI" => 44,
        "CK" => 45,
        "CL" => 46,
        "CM" => 47,
        "CN" => 48,
        "CO" => 49,
        "CR" => 50,
        "CU" => 51,
        "CV" => 52,
        "CX" => 53,
        "CY" => 54,
        "CZ" => 55,
        "DE" => 56,
        "DJ" => 57,
        "DK" => 58,
        "DM" => 59,
        "DO" => 60,
        "DZ" => 61,
        "EC" => 62,
        "EE" => 63,
        "EG" => 64,
        "EH" => 65,
        "ER" => 66,
        "ES" => 67,
        "ET" => 68,
        "FI" => 69,
        "FJ" => 70,
        "FK" => 71,
        "FM" => 72,
        "FO" => 73,
        "FR" => 74,
        "FX" => 75,
        "GA" => 76,
        "GB" => 77,
        "GD" => 78,
        "GE" => 79,
        "GF" => 80,
        "GH" => 81,
        "GI" => 82,
        "GL" => 83,
        "GM" => 84,
        "GN" => 85,
        "GP" => 86,
        "GQ" => 87,
        "GR" => 88,
        "GS" => 89,
        "GT" => 90,
        "GU" => 91,
        "GW" => 92,
        "GY" => 93,
        "HK" => 94,
        "HM" => 95,
        "HN" => 96,
        "HR" => 97,
        "HT" => 98,
        "HU" => 99,
        "ID" => 100,
        "IE" => 101,
        "IL" => 102,
        "IN" => 103,
        "IO" => 104,
        "IQ" => 105,
        "IR" => 106,
        "IS" => 107,
        "IT" => 108,
        "JM" => 109,
        "JO" => 110,
        "JP" => 111,
        "KE" => 112,
        "KG" => 113,
        "KH" => 114,
        "KI" => 115,
        "KM" => 116,
        "KN" => 117,
        "KP" => 118,
        "KR" => 119,
        "KW" => 120,
        "KY" => 121,
        "KZ" => 122,
        "LA" => 123,
        "LB" => 124,
        "LC" => 125,
        "LI" => 126,
        "LK" => 127,
        "LR" => 128,
        "LS" => 129,
        "LT" => 130,
        "LU" => 131,
        "LV" => 132,
        "LY" => 133,
        "MA" => 134,
        "MC" => 135,
        "MD" => 136,
        "MG" => 137,
        "MH" => 138,
        "MK" => 139,
        "ML" => 140,
        "MM" => 141,
        "MN" => 142,
        "MO" => 143,
        "MP" => 144,
        "MQ" => 145,
        "MR" => 146,
        "MS" => 147,
        "MT" => 148,
        "MU" => 149,
        "MV" => 150,
        "MW" => 151,
        "MX" => 152,
        "MY" => 153,
        "MZ" => 154,
        "NA" => 155,
        "NC" => 156,
        "NE" => 157,
        "NF" => 158,
        "NG" => 159,
        "NI" => 160,
        "NL" => 161,
        "NO" => 162,
        "NP" => 163,
        "NR" => 164,
        "NU" => 165,
        "NZ" => 166,
        "OM" => 167,
        "PA" => 168,
        "PE" => 169,
        "PF" => 170,
        "PG" => 171,
        "PH" => 172,
        "PK" => 173,
        "PL" => 174,
        "PM" => 175,
        "PN" => 176,
        "PR" => 177,
        "PS" => 178,
        "PT" => 179,
        "PW" => 180,
        "PY" => 181,
        "QA" => 182,
        "RE" => 183,
        "RO" => 184,
        "RU" => 185,
        "RW" => 186,
        "SA" => 187,
        "SB" => 188,
        "SC" => 189,
        "SD" => 190,
        "SE" => 191,
        "SG" => 192,
        "SH" => 193,
        "SI" => 194,
        "SJ" => 195,
        "SK" => 196,
        "SL" => 197,
        "SM" => 198,
        "SN" => 199,
        "SO" => 200,
        "SR" => 201,
        "ST" => 202,
        "SV" => 203,
        "SY" => 204,
        "SZ" => 205,
        "TC" => 206,
        "TD" => 207,
        "TF" => 208,
        "TG" => 209,
        "TH" => 210,
        "TJ" => 211,
        "TK" => 212,
        "TM" => 213,
        "TN" => 214,
        "TO" => 215,
        "TL" => 216,
        "TR" => 217,
        "TT" => 218,
        "TV" => 219,
        "TW" => 220,
        "TZ" => 221,
        "UA" => 222,
        "UG" => 223,
        "UM" => 224,
        "US" => 225,
        "UY" => 226,
        "UZ" => 227,
        "VA" => 228,
        "VC" => 229,
        "VE" => 230,
        "VG" => 231,
        "VI" => 232,
        "VN" => 233,
        "VU" => 234,
        "WF" => 235,
        "WS" => 236,
        "YE" => 237,
        "YT" => 238,
        "RS" => 239,
        "ZA" => 240,
        "ZM" => 241,
        "ME" => 242,
        "ZW" => 243,
        "A1" => 244,
        "A2" => 245,
        "O1" => 246,
        "AX" => 247,
        "GG" => 248,
        "IM" => 249,
        "JE" => 250,
        "BL" => 251,
        "MF" => 252
    );
    public $GEOIP_COUNTRY_CODES = array
    (
        0 => "",
        1 => "AP",
        2 => "EU",
        3 => "AD",
        4 => "AE",
        5 => "AF",
        6 => "AG",
        7 => "AI",
        8 => "AL",
        9 => "AM",
        10 => "AN",
        11 => "AO",
        12 => "AQ",
        13 => "AR",
        14 => "AS",
        15 => "AT",
        16 => "AU",
        17 => "AW",
        18 => "AZ",
        19 => "BA",
        20 => "BB",
        21 => "BD",
        22 => "BE",
        23 => "BF",
        24 => "BG",
        25 => "BH",
        26 => "BI",
        27 => "BJ",
        28 => "BM",
        29 => "BN",
        30 => "BO",
        31 => "BR",
        32 => "BS",
        33 => "BT",
        34 => "BV",
        35 => "BW",
        36 => "BY",
        37 => "BZ",
        38 => "CA",
        39 => "CC",
        40 => "CD",
        41 => "CF",
        42 => "CG",
        43 => "CH",
        44 => "CI",
        45 => "CK",
        46 => "CL",
        47 => "CM",
        48 => "CN",
        49 => "CO",
        50 => "CR",
        51 => "CU",
        52 => "CV",
        53 => "CX",
        54 => "CY",
        55 => "CZ",
        56 => "DE",
        57 => "DJ",
        58 => "DK",
        59 => "DM",
        60 => "DO",
        61 => "DZ",
        62 => "EC",
        63 => "EE",
        64 => "EG",
        65 => "EH",
        66 => "ER",
        67 => "ES",
        68 => "ET",
        69 => "FI",
        70 => "FJ",
        71 => "FK",
        72 => "FM",
        73 => "FO",
        74 => "FR",
        75 => "FX",
        76 => "GA",
        77 => "GB",
        78 => "GD",
        79 => "GE",
        80 => "GF",
        81 => "GH",
        82 => "GI",
        83 => "GL",
        84 => "GM",
        85 => "GN",
        86 => "GP",
        87 => "GQ",
        88 => "GR",
        89 => "GS",
        90 => "GT",
        91 => "GU",
        92 => "GW",
        93 => "GY",
        94 => "HK",
        95 => "HM",
        96 => "HN",
        97 => "HR",
        98 => "HT",
        99 => "HU",
        100 => "ID",
        101 => "IE",
        102 => "IL",
        103 => "IN",
        104 => "IO",
        105 => "IQ",
        106 => "IR",
        107 => "IS",
        108 => "IT",
        109 => "JM",
        110 => "JO",
        111 => "JP",
        112 => "KE",
        113 => "KG",
        114 => "KH",
        115 => "KI",
        116 => "KM",
        117 => "KN",
        118 => "KP",
        119 => "KR",
        120 => "KW",
        121 => "KY",
        122 => "KZ",
        123 => "LA",
        124 => "LB",
        125 => "LC",
        126 => "LI",
        127 => "LK",
        128 => "LR",
        129 => "LS",
        130 => "LT",
        131 => "LU",
        132 => "LV",
        133 => "LY",
        134 => "MA",
        135 => "MC",
        136 => "MD",
        137 => "MG",
        138 => "MH",
        139 => "MK",
        140 => "ML",
        141 => "MM",
        142 => "MN",
        143 => "MO",
        144 => "MP",
        145 => "MQ",
        146 => "MR",
        147 => "MS",
        148 => "MT",
        149 => "MU",
        150 => "MV",
        151 => "MW",
        152 => "MX",
        153 => "MY",
        154 => "MZ",
        155 => "NA",
        156 => "NC",
        157 => "NE",
        158 => "NF",
        159 => "NG",
        160 => "NI",
        161 => "NL",
        162 => "NO",
        163 => "NP",
        164 => "NR",
        165 => "NU",
        166 => "NZ",
        167 => "OM",
        168 => "PA",
        169 => "PE",
        170 => "PF",
        171 => "PG",
        172 => "PH",
        173 => "PK",
        174 => "PL",
        175 => "PM",
        176 => "PN",
        177 => "PR",
        178 => "PS",
        179 => "PT",
        180 => "PW",
        181 => "PY",
        182 => "QA",
        183 => "RE",
        184 => "RO",
        185 => "RU",
        186 => "RW",
        187 => "SA",
        188 => "SB",
        189 => "SC",
        190 => "SD",
        191 => "SE",
        192 => "SG",
        193 => "SH",
        194 => "SI",
        195 => "SJ",
        196 => "SK",
        197 => "SL",
        198 => "SM",
        199 => "SN",
        200 => "SO",
        201 => "SR",
        202 => "ST",
        203 => "SV",
        204 => "SY",
        205 => "SZ",
        206 => "TC",
        207 => "TD",
        208 => "TF",
        209 => "TG",
        210 => "TH",
        211 => "TJ",
        212 => "TK",
        213 => "TM",
        214 => "TN",
        215 => "TO",
        216 => "TL",
        217 => "TR",
        218 => "TT",
        219 => "TV",
        220 => "TW",
        221 => "TZ",
        222 => "UA",
        223 => "UG",
        224 => "UM",
        225 => "US",
        226 => "UY",
        227 => "UZ",
        228 => "VA",
        229 => "VC",
        230 => "VE",
        231 => "VG",
        232 => "VI",
        233 => "VN",
        234 => "VU",
        235 => "WF",
        236 => "WS",
        237 => "YE",
        238 => "YT",
        239 => "RS",
        240 => "ZA",
        241 => "ZM",
        242 => "ME",
        243 => "ZW",
        244 => "A1",
        245 => "A2",
        246 => "O1",
        247 => "AX",
        248 => "GG",
        249 => "IM",
        250 => "JE",
        251 => "BL",
        252 => "MF"
    );
    public $GEOIP_COUNTRY_CODES3 = array
    (
        0 => "",
        1 => "AP",
        2 => "EU",
        3 => "AND",
        4 => "ARE",
        5 => "AFG",
        6 => "ATG",
        7 => "AIA",
        8 => "ALB",
        9 => "ARM",
        10 => "ANT",
        11 => "AGO",
        12 => "AQ",
        13 => "ARG",
        14 => "ASM",
        15 => "AUT",
        16 => "AUS",
        17 => "ABW",
        18 => "AZE",
        19 => "BIH",
        20 => "BRB",
        21 => "BGD",
        22 => "BEL",
        23 => "BFA",
        24 => "BGR",
        25 => "BHR",
        26 => "BDI",
        27 => "BEN",
        28 => "BMU",
        29 => "BRN",
        30 => "BOL",
        31 => "BRA",
        32 => "BHS",
        33 => "BTN",
        34 => "BV",
        35 => "BWA",
        36 => "BLR",
        37 => "BLZ",
        38 => "CAN",
        39 => "CC",
        40 => "COD",
        41 => "CAF",
        42 => "COG",
        43 => "CHE",
        44 => "CIV",
        45 => "COK",
        46 => "CHL",
        47 => "CMR",
        48 => "CHN",
        49 => "COL",
        50 => "CRI",
        51 => "CUB",
        52 => "CPV",
        53 => "CX",
        54 => "CYP",
        55 => "CZE",
        56 => "DEU",
        57 => "DJI",
        58 => "DNK",
        59 => "DMA",
        60 => "DOM",
        61 => "DZA",
        62 => "ECU",
        63 => "EST",
        64 => "EGY",
        65 => "ESH",
        66 => "ERI",
        67 => "ESP",
        68 => "ETH",
        69 => "FIN",
        70 => "FJI",
        71 => "FLK",
        72 => "FSM",
        73 => "FRO",
        74 => "FRA",
        75 => "FX",
        76 => "GAB",
        77 => "GBR",
        78 => "GRD",
        79 => "GEO",
        80 => "GUF",
        81 => "GHA",
        82 => "GIB",
        83 => "GRL",
        84 => "GMB",
        85 => "GIN",
        86 => "GLP",
        87 => "GNQ",
        88 => "GRC",
        89 => "GS",
        90 => "GTM",
        91 => "GUM",
        92 => "GNB",
        93 => "GUY",
        94 => "HKG",
        95 => "HM",
        96 => "HND",
        97 => "HRV",
        98 => "HTI",
        99 => "HUN",
        100 => "IDN",
        101 => "IRL",
        102 => "ISR",
        103 => "IND",
        104 => "IO",
        105 => "IRQ",
        106 => "IRN",
        107 => "ISL",
        108 => "ITA",
        109 => "JAM",
        110 => "JOR",
        111 => "JPN",
        112 => "KEN",
        113 => "KGZ",
        114 => "KHM",
        115 => "KIR",
        116 => "COM",
        117 => "KNA",
        118 => "PRK",
        119 => "KOR",
        120 => "KWT",
        121 => "CYM",
        122 => "KAZ",
        123 => "LAO",
        124 => "LBN",
        125 => "LCA",
        126 => "LIE",
        127 => "LKA",
        128 => "LBR",
        129 => "LSO",
        130 => "LTU",
        131 => "LUX",
        132 => "LVA",
        133 => "LBY",
        134 => "MAR",
        135 => "MCO",
        136 => "MDA",
        137 => "MDG",
        138 => "MHL",
        139 => "MKD",
        140 => "MLI",
        141 => "MMR",
        142 => "MNG",
        143 => "MAC",
        144 => "MNP",
        145 => "MTQ",
        146 => "MRT",
        147 => "MSR",
        148 => "MLT",
        149 => "MUS",
        150 => "MDV",
        151 => "MWI",
        152 => "MEX",
        153 => "MYS",
        154 => "MOZ",
        155 => "NAM",
        156 => "NCL",
        157 => "NER",
        158 => "NFK",
        159 => "NGA",
        160 => "NIC",
        161 => "NLD",
        162 => "NOR",
        163 => "NPL",
        164 => "NRU",
        165 => "NIU",
        166 => "NZL",
        167 => "OMN",
        168 => "PAN",
        169 => "PER",
        170 => "PYF",
        171 => "PNG",
        172 => "PHL",
        173 => "PAK",
        174 => "POL",
        175 => "SPM",
        176 => "PCN",
        177 => "PRI",
        178 => "PSE",
        179 => "PRT",
        180 => "PLW",
        181 => "PRY",
        182 => "QAT",
        183 => "REU",
        184 => "ROU",
        185 => "RUS",
        186 => "RWA",
        187 => "SAU",
        188 => "SLB",
        189 => "SYC",
        190 => "SDN",
        191 => "SWE",
        192 => "SGP",
        193 => "SHN",
        194 => "SVN",
        195 => "SJM",
        196 => "SVK",
        197 => "SLE",
        198 => "SMR",
        199 => "SEN",
        200 => "SOM",
        201 => "SUR",
        202 => "STP",
        203 => "SLV",
        204 => "SYR",
        205 => "SWZ",
        206 => "TCA",
        207 => "TCD",
        208 => "TF",
        209 => "TGO",
        210 => "THA",
        211 => "TJK",
        212 => "TKL",
        213 => "TLS",
        214 => "TKM",
        215 => "TUN",
        216 => "TON",
        217 => "TUR",
        218 => "TTO",
        219 => "TUV",
        220 => "TWN",
        221 => "TZA",
        222 => "UKR",
        223 => "UGA",
        224 => "UM",
        225 => "USA",
        226 => "URY",
        227 => "UZB",
        228 => "VAT",
        229 => "VCT",
        230 => "VEN",
        231 => "VGB",
        232 => "VIR",
        233 => "VNM",
        234 => "VUT",
        235 => "WLF",
        236 => "WSM",
        237 => "YEM",
        238 => "YT",
        239 => "SRB",
        240 => "ZAF",
        241 => "ZMB",
        242 => "MNE",
        243 => "ZWE",
        244 => "A1",
        245 => "A2",
        246 => "O1",
        247 => "ALA",
        248 => "GGY",
        249 => "IMN",
        250 => "JEY",
        251 => "BLM",
        252 => "MAF"
    );
    public $GEOIP_COUNTRY_NAMES = array
    (
        0 => "",
        1 => "Asia/Pacific Region",
        2 => "Europe",
        3 => "Andorra",
        4 => "United Arab Emirates",
        5 => "Afghanistan",
        6 => "Antigua and Barbuda",
        7 => "Anguilla",
        8 => "Albania",
        9 => "Armenia",
        10 => "Netherlands Antilles",
        11 => "Angola",
        12 => "Antarctica",
        13 => "Argentina",
        14 => "American Samoa",
        15 => "Austria",
        16 => "Australia",
        17 => "Aruba",
        18 => "Azerbaijan",
        19 => "Bosnia and Herzegovina",
        20 => "Barbados",
        21 => "Bangladesh",
        22 => "Belgium",
        23 => "Burkina Faso",
        24 => "Bulgaria",
        25 => "Bahrain",
        26 => "Burundi",
        27 => "Benin",
        28 => "Bermuda",
        29 => "Brunei Darussalam",
        30 => "Bolivia",
        31 => "Brazil",
        32 => "Bahamas",
        33 => "Bhutan",
        34 => "Bouvet Island",
        35 => "Botswana",
        36 => "Belarus",
        37 => "Belize",
        38 => "Canada",
        39 => "Cocos (Keeling) Islands",
        40 => "Congo, The Democratic Republic of the",
        41 => "Central African Republic",
        42 => "Congo",
        43 => "Switzerland",
        44 => "Cote D'Ivoire",
        45 => "Cook Islands",
        46 => "Chile",
        47 => "Cameroon",
        48 => "China",
        49 => "Colombia",
        50 => "Costa Rica",
        51 => "Cuba",
        52 => "Cape Verde",
        53 => "Christmas Island",
        54 => "Cyprus",
        55 => "Czech Republic",
        56 => "Germany",
        57 => "Djibouti",
        58 => "Denmark",
        59 => "Dominica",
        60 => "Dominican Republic",
        61 => "Algeria",
        62 => "Ecuador",
        63 => "Estonia",
        64 => "Egypt",
        65 => "Western Sahara",
        66 => "Eritrea",
        67 => "Spain",
        68 => "Ethiopia",
        69 => "Finland",
        70 => "Fiji",
        71 => "Falkland Islands (Malvinas)",
        72 => "Micronesia, Federated States of",
        73 => "Faroe Islands",
        74 => "France",
        75 => "France, Metropolitan",
        76 => "Gabon",
        77 => "United Kingdom",
        78 => "Grenada",
        79 => "Georgia",
        80 => "French Guiana",
        81 => "Ghana",
        82 => "Gibraltar",
        83 => "Greenland",
        84 => "Gambia",
        85 => "Guinea",
        86 => "Guadeloupe",
        87 => "Equatorial Guinea",
        88 => "Greece",
        89 => "South Georgia and the South Sandwich Islands",
        90 => "Guatemala",
        91 => "Guam",
        92 => "Guinea-Bissau",
        93 => "Guyana",
        94 => "Hong Kong",
        95 => "Heard Island and McDonald Islands",
        96 => "Honduras",
        97 => "Croatia",
        98 => "Haiti",
        99 => "Hungary",
        100 => "Indonesia",
        101 => "Ireland",
        102 => "Israel",
        103 => "India",
        104 => "British Indian Ocean Territory",
        105 => "Iraq",
        106 => "Iran, Islamic Republic of",
        107 => "Iceland",
        108 => "Italy",
        109 => "Jamaica",
        110 => "Jordan",
        111 => "Japan",
        112 => "Kenya",
        113 => "Kyrgyzstan",
        114 => "Cambodia",
        115 => "Kiribati",
        116 => "Comoros",
        117 => "Saint Kitts and Nevis",
        118 => "Korea, Democratic People's Republic of",
        119 => "Korea, Republic of",
        120 => "Kuwait",
        121 => "Cayman Islands",
        122 => "Kazakstan",
        123 => "Lao People's Democratic Republic",
        124 => "Lebanon",
        125 => "Saint Lucia",
        126 => "Liechtenstein",
        127 => "Sri Lanka",
        128 => "Liberia",
        129 => "Lesotho",
        130 => "Lithuania",
        131 => "Luxembourg",
        132 => "Latvia",
        133 => "Libyan Arab Jamahiriya",
        134 => "Morocco",
        135 => "Monaco",
        136 => "Moldova, Republic of",
        137 => "Madagascar",
        138 => "Marshall Islands",
        139 => "Macedonia",
        140 => "Mali",
        141 => "Myanmar",
        142 => "Mongolia",
        143 => "Macau",
        144 => "Northern Mariana Islands",
        145 => "Martinique",
        146 => "Mauritania",
        147 => "Montserrat",
        148 => "Malta",
        149 => "Mauritius",
        150 => "Maldives",
        151 => "Malawi",
        152 => "Mexico",
        153 => "Malaysia",
        154 => "Mozambique",
        155 => "Namibia",
        156 => "New Caledonia",
        157 => "Niger",
        158 => "Norfolk Island",
        159 => "Nigeria",
        160 => "Nicaragua",
        161 => "Netherlands",
        162 => "Norway",
        163 => "Nepal",
        164 => "Nauru",
        165 => "Niue",
        166 => "New Zealand",
        167 => "Oman",
        168 => "Panama",
        169 => "Peru",
        170 => "French Polynesia",
        171 => "Papua New Guinea",
        172 => "Philippines",
        173 => "Pakistan",
        174 => "Poland",
        175 => "Saint Pierre and Miquelon",
        176 => "Pitcairn Islands",
        177 => "Puerto Rico",
        178 => "Palestinian Territory",
        179 => "Portugal",
        180 => "Palau",
        181 => "Paraguay",
        182 => "Qatar",
        183 => "Reunion",
        184 => "Romania",
        185 => "Russian Federation",
        186 => "Rwanda",
        187 => "Saudi Arabia",
        188 => "Solomon Islands",
        189 => "Seychelles",
        190 => "Sudan",
        191 => "Sweden",
        192 => "Singapore",
        193 => "Saint Helena",
        194 => "Slovenia",
        195 => "Svalbard and Jan Mayen",
        196 => "Slovakia",
        197 => "Sierra Leone",
        198 => "San Marino",
        199 => "Senegal",
        200 => "Somalia",
        201 => "Suriname",
        202 => "Sao Tome and Principe",
        203 => "El Salvador",
        204 => "Syrian Arab Republic",
        205 => "Swaziland",
        206 => "Turks and Caicos Islands",
        207 => "Chad",
        208 => "French Southern Territories",
        209 => "Togo",
        210 => "Thailand",
        211 => "Tajikistan",
        212 => "Tokelau",
        213 => "Turkmenistan",
        214 => "Tunisia",
        215 => "Tonga",
        216 => "Timor-Leste",
        217 => "Turkey",
        218 => "Trinidad and Tobago",
        219 => "Tuvalu",
        220 => "Taiwan",
        221 => "Tanzania, United Republic of",
        222 => "Ukraine",
        223 => "Uganda",
        224 => "United States Minor Outlying Islands",
        225 => "United States",
        226 => "Uruguay",
        227 => "Uzbekistan",
        228 => "Holy See (Vatican City State)",
        229 => "Saint Vincent and the Grenadines",
        230 => "Venezuela",
        231 => "Virgin Islands, British",
        232 => "Virgin Islands, U.S.",
        233 => "Vietnam",
        234 => "Vanuatu",
        235 => "Wallis and Futuna",
        236 => "Samoa",
        237 => "Yemen",
        238 => "Mayotte",
        239 => "Serbia",
        240 => "South Africa",
        241 => "Zambia",
        242 => "Montenegro",
        243 => "Zimbabwe",
        244 => "Anonymous Proxy",
        245 => "Satellite Provider",
        246 => "Other",
        247 => "Aland Islands",
        248 => "Guernsey",
        249 => "Isle of Man",
        250 => "Jersey",
        251 => "Saint Barthelemy",
        252 => "Saint Martin"
    );

}

function geoip_load_shared_mem( $file )
{
    $fp = fopen( $file, "rb" );
    if ( !$fp )
    {
        echo "error opening ";
        echo $file;
        echo ": ";
        echo $php_errormsg;
        echo "\n";
        exit( );
    }
    $s_array = fstat( $fp );
    $size = $s_array['size'];
    if ( $shmid = @shmop_open( GEOIP_SHM_KEY, "w", 0, 0 ) )
    {
        shmop_delete( $shmid );
        shmop_close( $shmid );
    }
    $shmid = shmop_open( GEOIP_SHM_KEY, "c", 420, $size );
    shmop_write( $shmid, fread( $fp, $size ), 0 );
    shmop_close( $shmid );
}

function _setup_segments( $gi )
{
    $gi->databaseType = GEOIP_COUNTRY_EDITION;
    $gi->record_length = STANDARD_RECORD_LENGTH;
    if ( $gi->flags & GEOIP_SHARED_MEMORY )
    {
        $offset = shmop_size( $gi->shmid ) - 3;
        $i = 0;
        for ( ; $i < STRUCTURE_INFO_MAX_SIZE; ++$i )
        {
            $delim = @shmop_read( $gi->shmid, $offset, 3 );
            $offset += 3;
            if ( $delim == chr( 255 ).chr( 255 ).chr( 255 ) )
            {
                $gi->databaseType = ord( @shmop_read( $gi->shmid, $offset, 1 ) );
                ++$offset;
                if ( $gi->databaseType == GEOIP_REGION_EDITION_REV0 )
                {
                    $gi->databaseSegments = GEOIP_STATE_BEGIN_REV0;
                    break;
                }
                else
                {
                    if ( $gi->databaseType == GEOIP_REGION_EDITION_REV1 )
                    {
                        $gi->databaseSegments = GEOIP_STATE_BEGIN_REV1;
                        break;
                    }
                    else
                    {
                        if ( !( $gi->databaseType == GEOIP_CITY_EDITION_REV0 ) || !( $gi->databaseType == GEOIP_CITY_EDITION_REV1 ) || !( $gi->databaseType == GEOIP_ORG_EDITION ) || !( $gi->databaseType == GEOIP_ISP_EDITION ) || !( $gi->databaseType == GEOIP_ASNUM_EDITION ) )
                        {
                            break;
                        }
                        $gi->databaseSegments = 0;
                        $buf = @shmop_read( $gi->shmid, $offset, SEGMENT_RECORD_LENGTH );
                        $j = 0;
                        for ( ; $j < SEGMENT_RECORD_LENGTH; ++$j )
                        {
                            $gi['databaseSegments'] += ord( $buf[$j] ) << $j * 8;
                        }
                        if ( !( $gi->databaseType == GEOIP_ORG_EDITION ) || !( $gi->databaseType == GEOIP_ISP_EDITION ) )
                        {
                            break;
                        }
                        $gi->record_length = ORG_RECORD_LENGTH;
                    }
                }
            }
            else
            {
                $offset -= 4;
            }
        }
        if ( $gi->databaseType == GEOIP_COUNTRY_EDITION || $gi->databaseType == GEOIP_PROXY_EDITION || $gi->databaseType == GEOIP_NETSPEED_EDITION )
        {
            $gi->databaseSegments = GEOIP_COUNTRY_BEGIN;
            return $gi;
        }
    }
    else
    {
        $filepos = ftell( $gi->filehandle );
        fseek( $gi->filehandle, -3, SEEK_END );
        $i = 0;
        for ( ; $i < STRUCTURE_INFO_MAX_SIZE; ++$i )
        {
            $delim = fread( $gi->filehandle, 3 );
            if ( $delim == chr( 255 ).chr( 255 ).chr( 255 ) )
            {
                $gi->databaseType = ord( fread( $gi->filehandle, 1 ) );
                if ( $gi->databaseType == GEOIP_REGION_EDITION_REV0 )
                {
                    $gi->databaseSegments = GEOIP_STATE_BEGIN_REV0;
                    break;
                }
                else
                {
                    if ( $gi->databaseType == GEOIP_REGION_EDITION_REV1 )
                    {
                        $gi->databaseSegments = GEOIP_STATE_BEGIN_REV1;
                        break;
                    }
                    else
                    {
                        if ( !( $gi->databaseType == GEOIP_CITY_EDITION_REV0 ) || !( $gi->databaseType == GEOIP_CITY_EDITION_REV1 ) || !( $gi->databaseType == GEOIP_ORG_EDITION ) || !( $gi->databaseType == GEOIP_ISP_EDITION ) || !( $gi->databaseType == GEOIP_ASNUM_EDITION ) )
                        {
                            break;
                        }
                        $gi->databaseSegments = 0;
                        $buf = fread( $gi->filehandle, SEGMENT_RECORD_LENGTH );
                        $j = 0;
                        for ( ; $j < SEGMENT_RECORD_LENGTH; ++$j )
                        {
                            $gi['databaseSegments'] += ord( $buf[$j] ) << $j * 8;
                        }
                        if ( !( $gi->databaseType == GEOIP_ORG_EDITION ) || !( $gi->databaseType == GEOIP_ISP_EDITION ) )
                        {
                            break;
                        }
                        $gi->record_length = ORG_RECORD_LENGTH;
                    }
                }
            }
            else
            {
                fseek( $gi->filehandle, -4, SEEK_CUR );
            }
        }
        if ( $gi->databaseType == GEOIP_COUNTRY_EDITION || $gi->databaseType == GEOIP_PROXY_EDITION || $gi->databaseType == GEOIP_NETSPEED_EDITION )
        {
            $gi->databaseSegments = GEOIP_COUNTRY_BEGIN;
        }
        fseek( $gi->filehandle, $filepos, SEEK_SET );
    }
    return $gi;
}

function geoip_open( $filename, $flags )
{
    ( );
    $gi = new GeoIP( );
    $gi->flags = $flags;
    if ( $gi->flags & GEOIP_SHARED_MEMORY )
    {
        $gi->shmid = shmop_open( GEOIP_SHM_KEY, "a", 0, 0 );
    }
    else
    {
        $gi->filehandle = fopen( $filename, "rb" );
        if ( $gi->flags & GEOIP_MEMORY_CACHE )
        {
            $s_array = fstat( $gi->filehandle );
            $gi->memory_buffer = fread( $gi->filehandle, $s_array['size'] );
        }
    }
    $gi = _setup_segments( $gi );
    return $gi;
}

function geoip_close( $gi )
{
    if ( $gi->flags & GEOIP_SHARED_MEMORY )
    {
        return TRUE;
    }
    return fclose( $gi->filehandle );
}

function geoip_country_id_by_name( $gi, $name )
{
    $addr = gethostbyname( $name );
    if ( !$addr && $addr == $name )
    {
        return FALSE;
    }
    return geoip_country_id_by_addr( $gi, $addr );
}

function geoip_country_code_by_name( $gi, $name )
{
    $country_id = geoip_country_id_by_name( $gi, $name );
    if ( $country_id !== FALSE )
    {
        return $gi->GEOIP_COUNTRY_CODES[$country_id];
    }
    return FALSE;
}

function geoip_country_name_by_name( $gi, $name )
{
    $country_id = geoip_country_id_by_name( $gi, $name );
    if ( $country_id !== FALSE )
    {
        return $gi->GEOIP_COUNTRY_NAMES[$country_id];
    }
    return FALSE;
}

function geoip_country_id_by_addr( $gi, $addr )
{
    $ipnum = ip2long( $addr );
    return _geoip_seek_country( $gi, $ipnum ) - GEOIP_COUNTRY_BEGIN;
}

function geoip_country_code_by_addr( $gi, $addr )
{
    if ( $gi->databaseType == GEOIP_CITY_EDITION_REV1 )
    {
        $record = geoip_record_by_addr( $gi, $addr );
        return $record->country_code;
    }
    $country_id = geoip_country_id_by_addr( $gi, $addr );
    if ( $country_id !== FALSE )
    {
        return $gi->GEOIP_COUNTRY_CODES[$country_id];
    }
    return FALSE;
}

function geoip_country_name_by_addr( $gi, $addr )
{
    if ( $gi->databaseType == GEOIP_CITY_EDITION_REV1 )
    {
        $record = geoip_record_by_addr( $gi, $addr );
        return $record->country_name;
    }
    $country_id = geoip_country_id_by_addr( $gi, $addr );
    if ( $country_id !== FALSE )
    {
        return $gi->GEOIP_COUNTRY_NAMES[$country_id];
    }
    return FALSE;
}

function _geoip_seek_country( $gi, $ipnum )
{
    $offset = 0;
    $depth = 31;
    for ( ; 0 <= $depth; --$depth )
    {
        if ( $gi->flags & GEOIP_MEMORY_CACHE )
        {
            $buf = substr( $gi->memory_buffer, 2 * $gi->record_length * $offset, 2 * $gi->record_length );
        }
        else if ( $gi->flags & GEOIP_SHARED_MEMORY )
        {
            $buf = @shmop_read( $gi->shmid, 2 * $gi->record_length * $offset, 2 * $gi->record_length );
        }
        else
        {
            if ( !( fseek( $gi->filehandle, 2 * $gi->record_length * $offset, SEEK_SET ) == 0 ) )
            {
                exit( "fseek failed" );
            }
            $buf = fread( $gi->filehandle, 2 * $gi->record_length );
        }
        $x = array( 0, 0 );
        $i = 0;
        for ( ; $i < 2; ++$i )
        {
            $j = 0;
            for ( ; $j < $gi->record_length; ++$j )
            {
                $x[$i] += ord( $buf[$gi->record_length * $i + $j] ) << $j * 8;
            }
        }
        if ( $ipnum & 1 << $depth )
        {
            if ( $gi->databaseSegments <= $x[1] )
            {
                return $x[1];
            }
            $offset = $x[1];
        }
        else if ( $gi->databaseSegments <= $x[0] )
        {
            return $x[0];
        }
        else
        {
            $offset = $x[0];
        }
    }
    trigger_error( "error traversing database - perhaps it is corrupt?", E_USER_ERROR );
    return FALSE;
}

function _get_org( $gi, $ipnum )
{
    $seek_org = _geoip_seek_country( $gi, $ipnum );
    if ( $seek_org == $gi->databaseSegments )
    {
        return;
    }
    $record_pointer = $seek_org + ( 2 * $gi->record_length - 1 ) * $gi->databaseSegments;
    if ( $gi->flags & GEOIP_SHARED_MEMORY )
    {
        $org_buf = @shmop_read( $gi->shmid, $record_pointer, MAX_ORG_RECORD_LENGTH );
    }
    else
    {
        fseek( $gi->filehandle, $record_pointer, SEEK_SET );
        $org_buf = fread( $gi->filehandle, MAX_ORG_RECORD_LENGTH );
    }
    $org_buf = substr( $org_buf, 0, strpos( $org_buf, 0 ) );
    return $org_buf;
}

function geoip_org_by_addr( $gi, $addr )
{
    if ( $addr == NULL )
    {
        return 0;
    }
    $ipnum = ip2long( $addr );
    return _get_org( $gi, $ipnum );
}

function _get_region( $gi, $ipnum )
{
    if ( $gi->databaseType == GEOIP_REGION_EDITION_REV0 )
    {
        $seek_region = _geoip_seek_country( $gi, $ipnum ) - GEOIP_STATE_BEGIN_REV0;
        if ( 1000 <= $seek_region )
        {
            $country_code = "US";
            $region = chr( ( $seek_region - 1000 ) / 26 + 65 ).chr( ( $seek_region - 1000 ) % 26 + 65 );
        }
        else
        {
            $country_code = $gi->GEOIP_COUNTRY_CODES[$seek_region];
            $region = "";
        }
        return array(
            $country_code,
            $region
        );
    }
    if ( $gi->databaseType == GEOIP_REGION_EDITION_REV1 )
    {
        $seek_region = _geoip_seek_country( $gi, $ipnum ) - GEOIP_STATE_BEGIN_REV1;
        if ( $seek_region < US_OFFSET )
        {
            $country_code = "";
            $region = "";
        }
        else if ( $seek_region < CANADA_OFFSET )
        {
            $country_code = "US";
            $region = chr( ( $seek_region - US_OFFSET ) / 26 + 65 ).chr( ( $seek_region - US_OFFSET ) % 26 + 65 );
        }
        else if ( $seek_region < WORLD_OFFSET )
        {
            $country_code = "CA";
            $region = chr( ( $seek_region - CANADA_OFFSET ) / 26 + 65 ).chr( ( $seek_region - CANADA_OFFSET ) % 26 + 65 );
        }
        else
        {
            $country_code = $gi->GEOIP_COUNTRY_CODES[( $seek_region - WORLD_OFFSET ) / FIPS_RANGE];
            $region = "";
        }
        return array(
            $country_code,
            $region
        );
    }
}

function geoip_region_by_addr( $gi, $addr )
{
    if ( $addr == NULL )
    {
        return 0;
    }
    $ipnum = ip2long( $addr );
    return _get_region( $gi, $ipnum );
}

function getdnsattributes( $l, $ip )
{
    ( );
    $r = new Net_DNS_Resolver( );
    $r->nameservers = array( "ws1.maxmind.com" );
    $p = $r->search( $l.".".$ip.".s.maxmind.com", "TXT", "IN" );
    $str = is_object( $p->answer[0] ) ? $p->answer[0]->string( ) : "";
    ereg( "\"(.*)\"", $str, &$regs );
    $str = $regs[1];
    return $str;
}

define( "GEOIP_COUNTRY_BEGIN", 16776960 );
define( "GEOIP_STATE_BEGIN_REV0", 16700000 );
define( "GEOIP_STATE_BEGIN_REV1", 16000000 );
define( "GEOIP_STANDARD", 0 );
define( "GEOIP_MEMORY_CACHE", 1 );
define( "GEOIP_SHARED_MEMORY", 2 );
define( "STRUCTURE_INFO_MAX_SIZE", 20 );
define( "DATABASE_INFO_MAX_SIZE", 100 );
define( "GEOIP_COUNTRY_EDITION", 106 );
define( "GEOIP_PROXY_EDITION", 8 );
define( "GEOIP_ASNUM_EDITION", 9 );
define( "GEOIP_NETSPEED_EDITION", 10 );
define( "GEOIP_REGION_EDITION_REV0", 112 );
define( "GEOIP_REGION_EDITION_REV1", 3 );
define( "GEOIP_CITY_EDITION_REV0", 111 );
define( "GEOIP_CITY_EDITION_REV1", 2 );
define( "GEOIP_ORG_EDITION", 110 );
define( "GEOIP_ISP_EDITION", 4 );
define( "SEGMENT_RECORD_LENGTH", 3 );
define( "STANDARD_RECORD_LENGTH", 3 );
define( "ORG_RECORD_LENGTH", 4 );
define( "MAX_RECORD_LENGTH", 4 );
define( "MAX_ORG_RECORD_LENGTH", 300 );
define( "GEOIP_SHM_KEY", 1329681409 );
define( "US_OFFSET", 1 );
define( "CANADA_OFFSET", 677 );
define( "WORLD_OFFSET", 1353 );
define( "FIPS_RANGE", 360 );
define( "GEOIP_UNKNOWN_SPEED", 0 );
define( "GEOIP_DIALUP_SPEED", 1 );
define( "GEOIP_CABLEDSL_SPEED", 2 );
define( "GEOIP_CORPORATE_SPEED", 3 );
?>
