<?php
/**
*
* @ This file is created by Decodeby.US
* @ deZender Public (PHP5 Decompiler)
*
* @	Version			:	1.0.0.1
* @	Author			:	Ps2Gamer & Cyko
* @	Release on		:	07.06.2011
* @	Official site	:	http://decodeby.us
*
*/

class upload
{

    public $upload_form_field = "FILE_UPLOAD";
    public $out_file_name = "";
    public $out_file_dir = "./";
    public $max_file_size = 0;
    public $make_script_safe = 1;
    public $force_data_ext = "";
    public $allowed_file_ext = array( );
    public $image_ext = array
    (
        0 => "gif",
        1 => "jpeg",
        2 => "jpg",
        3 => "jpe",
        4 => "png"
    );
    public $image_check = 1;
    public $file_extension = "";
    public $real_file_extension = "";
    public $error_no = 0;
    public $is_image = 0;
    public $original_file_name = "";
    public $parsed_file_name = "";
    public $saved_upload_name = "";

    public function __construct( )
    {
    }

    public function upload_process( )
    {
        $this->_clean_paths( );
        if ( !function_exists( "getimagesize" ) )
        {
            $this->image_check = 0;
        }
        $FILE_NAME = isset( $_FILES[$this->upload_form_field]['name'] ) ? $_FILES[$this->upload_form_field]['name'] : "";
        $FILE_SIZE = isset( $_FILES[$this->upload_form_field]['size'] ) ? $_FILES[$this->upload_form_field]['size'] : "";
        $FILE_TYPE = isset( $_FILES[$this->upload_form_field]['type'] ) ? $_FILES[$this->upload_form_field]['type'] : "";
        $FILE_TYPE = preg_replace( "/^(.+?);.*\$/", "\\1", $FILE_TYPE );
        if ( !isset( $_FILES[$this->upload_form_field]['name'] ) && $_FILES[$this->upload_form_field]['name'] == "" || !$_FILES[$this->upload_form_field]['name'] && !$_FILES[$this->upload_form_field]['size'] && $_FILES[$this->upload_form_field]['name'] == "none" )
        {
            $this->error_no = 1;
        }
        else
        {
            if ( !is_uploaded_file( $_FILES[$this->upload_form_field]['tmp_name'] ) )
            {
                $this->error_no = 1;
            }
            else
            {
                if ( is_array( $this->allowed_file_ext ) )
                {
                }
                if ( !count( $this->allowed_file_ext ) )
                {
                    $this->error_no = 2;
                }
                else
                {
                    $this->file_extension = $this->_get_file_extension( $FILE_NAME );
                    if ( !$this->file_extension )
                    {
                        $this->error_no = 2;
                    }
                    else
                    {
                        $this->real_file_extension = $this->file_extension;
                        if ( !in_array( $this->file_extension, $this->allowed_file_ext ) )
                        {
                            $this->error_no = 2;
                        }
                        else if ( $this->max_file_size && $this->max_file_size < $FILE_SIZE )
                        {
                            $this->error_no = 3;
                        }
                        else
                        {
                            $FILE_NAME = preg_replace( "/[^\\w\\.]/", "_", $FILE_NAME );
                            $this->original_file_name = $FILE_NAME;
                            if ( $this->out_file_name )
                            {
                                $this->parsed_file_name = $this->out_file_name;
                            }
                            else
                            {
                                $this->parsed_file_name = str_replace( ".".$this->file_extension, "", $FILE_NAME );
                            }
                            $renamed = 0;
                            if ( $this->make_script_safe && preg_match( "/\\.(cgi|pl|js|asp|php|html|htm|jsp|jar)(\\.|\$)/i", $FILE_NAME ) )
                            {
                                $FILE_TYPE = "text/plain";
                                $this->file_extension = "txt";
                                $this->parsed_file_name = preg_replace( "/\\.(cgi|pl|js|asp|php|html|htm|jsp|jar)(\\.|\$)/i", "\$2", $this->parsed_file_name );
                                $renamed = 1;
                            }
                            if ( is_array( $this->image_ext ) && count( $this->image_ext ) && in_array( $this->real_file_extension, $this->image_ext ) )
                            {
                                $this->is_image = 1;
                            }
                            if ( $this->force_data_ext && !$this->is_image )
                            {
                                $this->file_extension = str_replace( ".", "", $this->force_data_ext );
                            }
                            $this->parsed_file_name .= ".".$this->file_extension;
                            recursive_mkdir( $this->out_file_dir );
                            $this->saved_upload_name = $this->out_file_dir."/".md5( time( ).rand( 100, 1000 ) ).".".$this->file_extension;
                            if ( !@move_uploaded_file( $_FILES[$this->upload_form_field]['tmp_name'], $this->saved_upload_name ) )
                            {
                                $this->error_no = 4;
                            }
                            else
                            {
                                @chmod( $this->saved_upload_name, 508 );
                                if ( !$renamed )
                                {
                                    $this->check_xss_infile( );
                                    if ( $this->error_no )
                                    {
                                    }
                                }
                                else if ( $this->is_image && $this->image_check )
                                {
                                    $img_attributes = @getimagesize( $this->saved_upload_name );
                                    if ( is_array( $img_attributes ) )
                                    {
                                    }
                                    if ( !count( $img_attributes ) )
                                    {
                                        @unlink( $this->saved_upload_name );
                                        $this->error_no = 5;
                                    }
                                    else if ( !$img_attributes[2] )
                                    {
                                        @unlink( $this->saved_upload_name );
                                        $this->error_no = 5;
                                    }
                                    else
                                    {
                                        if ( $img_attributes[2] == 1 && ( $this->file_extension == "jpg" || $this->file_extension == "jpeg" ) )
                                        {
                                            @unlink( $this->saved_upload_name );
                                            $this->error_no = 5;
                                        }
                                        else
                                        {
                                        }
                                    }
                                }
                                else if ( filesize( $this->saved_upload_name ) != $_FILES[$this->upload_form_field]['size'] )
                                {
                                    @unlink( $this->saved_upload_name );
                                    $this->error_no = 1;
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    public function check_xss_infile( )
    {
        $fh = fopen( $this->saved_upload_name, "rb" );
        $file_check = fread( $fh, 512 );
        fclose( $fh );
        if ( !$file_check )
        {
            @unlink( $this->saved_upload_name );
            $this->error_no = 5;
        }
        else if ( preg_match( "#<script|<html|<head|<title|<body|<pre|<table|<a\\s+href|<img|<plaintext|<cross\\-domain\\-policy#si", $file_check ) )
        {
            @unlink( $this->saved_upload_name );
            $this->error_no = 5;
        }
    }

    public function _get_file_extension( $file )
    {
        return strtolower( str_replace( ".", "", substr( $file, strrpos( $file, "." ) ) ) );
    }

    public function _clean_paths( )
    {
        $this->out_file_dir = preg_replace( "#/\$#", "", $this->out_file_dir );
    }

}

?>
