<?php
/**
*
* @ This file is created by Decodeby.US
* @ deZender Public (PHP5 Decompiler)
*
* @	Version			:	1.0.0.1
* @	Author			:	Ps2Gamer & Cyko
* @	Release on		:	07.06.2011
* @	Official site	:	http://decodeby.us
*
*/

function __autoload( $class_name )
{
    if ( class_exists( $class_name ) )
    {
        return TRUE;
    }
    $file = ENGINE_PATH."classes/".$class_name.".class.php";
    if ( file_exists( $file ) )
    {
        require_once( $file );
        return TRUE;
    }
    if ( isset( $_GET['module'] ) && file_exists( ROOT_PATH."/modules/".$_GET['module']."/models/".$class_name.".class.php" ) )
    {
        require_once( ROOT_PATH."/modules/".$_GET['module']."/models/".$class_name.".class.php" );
        return TRUE;
    }
    if ( isset( $_GET['module'] ) && isadministration( $_GET['module'] ) && isset( $_GET['m'] ) && file_exists( ROOT_PATH."/modules/".$_GET['m']."/models/".$class_name.".class.php" ) )
    {
        require_once( ROOT_PATH."/modules/".$_GET['m']."/models/".$class_name.".class.php" );
        return TRUE;
    }
    if ( isset( $_GET['module'] ) && isadministration( $_GET['module'] ) && isset( $_GET['m'] ) && file_exists( ROOT_PATH."/modules/".$_GET['m']."/models/".$class_name.".class.php" ) )
    {
        require_once( ROOT_PATH."/modules/".$_GET['m']."/models/".$class_name.".class.php" );
    }
    return TRUE;
}

function check_email( $address )
{
    return preg_match( "/^[-!#\$%&'*+\\.\\/0-9=?A-Z^_`{|}~]+@([-0-9A-Z]+\\.)+([0-9A-Z]){2,4}\$/i", trim( $address ) );
}

function execute_time( )
{
    global $start_time;
    return microtime( TRUE ) - $start_time;
}

function abr( $var, $value )
{
    global $smarty;
    $smarty->assign_by_ref( $var, $value );
}

function langMessageReplace( $message, $vars )
{
    if ( preg_match_all( "/\\{\\\$(?P<named>[0-9A-Z_\\-]*)\\}/simx", $message, $result, PREG_PATTERN_ORDER ) )
    {
        foreach ( $result['named'] as $v )
        {
            if ( isset( $vars[$v] ) )
            {
                $message = str_ireplace( "{\$".$v."}", $vars[$v], $message );
            }
        }
    }
    unset( $vars );
    return $message;
}

function get_id( $level )
{
    global $config;
    if ( $config['use_language'] )
    {
        $level += 1;
    }
    if ( !isset( $_GET['array_url'][$level] ) )
    {
        return FALSE;
    }
    if ( strstr( $_GET['array_url'][$level], "." ) )
    {
        $all = explode( ".", $_GET['array_url'][$level] );
    }
    else
    {
        $all[0] = $_GET['array_url'][$level];
    }
    return $all[0];
}

function createTextAreaEditor( $params, &$smarty )
{
    global $config;
    require_once( $config['data_server_path']."/js/fckeditor/fckeditor.php" );
    $params['name'] = str_replace( "\\'", "", $params['name'] );
    ( $params['name'] );
    $oFCKeditor = new FCKeditor( );
    $oFCKeditor->BasePath = $config['data_server']."/js/fckeditor/";
    $oFCKeditor->Width = $params['width'];
    $oFCKeditor->Height = $params['height'];
    $oFCKeditor->Value = $params['value'];
    $oFCKeditor->ToolbarSet = "e7Toolbar";
    $oFCKeditor->AutoDetectPasteFromWord = TRUE;
    $oFCKeditor->Create( );
}

function remove_whitespace( $str )
{
    $str = str_replace( " ", "+", $str );
    $str = str_replace( "%20", "+", $str );
    $str = str_replace( "%", "", $str );
    $str = str_replace( "/", "+", $str );
    return $str;
}

function refresh( $url = "", $message = "", $type = "succes" )
{
    global $sitemapClass;
    if ( $url == "" )
    {
        $GLOBALS['_SERVER']['REQUEST_URI'] = str_ireplace( "//", "/", $_SERVER['REQUEST_URI'] );
        $url = "http://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI'];
    }
    if ( $message != "" )
    {
        $_SESSION['temp']['message_title'] = $message;
    }
    $_SESSION['temp']['message_type'] = $type;
    if ( isset( $sitemapClass ) && $_GET['module'] == "admin" && ( isset( $_POST['add'] ) || isset( $_POST['edit'] ) ) )
    {
        $sitemapClass->regenerateSiteMap( );
    }
    header( "Location: ".$url );
    exit( );
}

function login_redirect( $url, $fromUrl = "", $message = "" )
{
    if ( $fromUrl == "" )
    {
        $_SESSION['redirectUrl'] = "/".$_GET['url'];
    }
    else
    {
        $_SESSION['redirectUrl'] = $fromUrl;
    }
    if ( $message != "" )
    {
        $_SESSION['temp']['message_title'] = $message;
        $_SESSION['temp']['message_type'] = "error";
    }
    header( "Location: ".$url );
    exit( );
}

function getRefreshMessage( )
{
    if ( isset( $_SESSION['temp']['message_title'] ) )
    {
        $message['title'] = $_SESSION['temp']['message_title'];
        unset( $this->temp['message_title'] );
        if ( isset( $_SESSION['temp']['message_text'] ) )
        {
            $message['text'] = $_SESSION['temp']['message_text'];
            unset( $this->temp['message_text'] );
        }
        else
        {
            $message['text'] = "";
        }
        if ( isset( $_SESSION['temp']['message_type'] ) )
        {
            $message['type'] = $_SESSION['temp']['message_type'];
            unset( $this->temp['message_type'] );
            return $message;
        }
        $message['type'] = "";
        return $message;
    }
    return FALSE;
}

function truncate( $str, $length = 10, $trailing = "..." )
{
    $length -= mb_strlen( $trailing );
    if ( $length < mb_strlen( $str ) )
    {
        return mb_substr( $str, 0, $length ).$trailing;
    }
    $res = $str;
    return $res;
}

function addErrorMessage( $title, $msg = "", $type = "notice" )
{
    global $smarty;
    switch ( $type )
    {
    case "notice" :
        $class = "warning";
        break;
    case "error" :
        $class = "error";
        break;
    case "info" :
        $class = "info";
        break;
        $class = "success";
    }
    $msg = $smarty->get_template_vars( "errorMessage" )."\n\t\t\t<div class=\"box box-".$class."\">".$title." ".$msg."</div>";
    $smarty->assign_by_ref( "errorMessage", $msg );
    return TRUE;
}

function check_login( $type = "user" )
{
    global $_SESSION;
    global $langArray;
    if ( !isset( $_SESSION[$type] ) )
    {
        refresh( "/users/login/" );
    }
    return TRUE;
}

function check_login_bool( $type = "user" )
{
    global $_SESSION;
    if ( !isset( $_SESSION[$type] ) )
    {
        return FALSE;
    }
    return TRUE;
}

function check_admin_login( )
{
    global $config;
    global $languageURL;
    if ( !isset( $_SESSION['user']['is_admin'] ) )
    {
        refresh( "/".$languageURL.adminURL."/login/?check_admin_login" );
        exit( "Do not access !!!" );
    }
    return TRUE;
}

function check_admin_login_bool( )
{
    global $_SESSION;
    if ( !isset( $_SESSION['user']['is_admin'] ) )
    {
        return FALSE;
    }
    return TRUE;
}

function url( $url )
{
    $url = strip_tags( $url );
    $url = trim( $url );
    $url = preg_replace( "%[.,:'\"/\\\\[\\]{}\\%\\-_!?]%simx", " ", $url );
    $url = str_ireplace( " ", "-", $url );
    return $url;
}

function isAdministration( $module )
{
    if ( $module == adminURL )
    {
        return TRUE;
    }
    return FALSE;
}

function recursive_mkdir( $folder )
{
    $folder = explode( DIRECTORY_SEPARATOR, $folder );
    $mkfolder = "";
    $i = 0;
    for ( ; isset( $folder[$i] ); ++$i )
    {
        if ( $folder[$i] != "" )
        {
            $mkfolder .= $folder[$i];
            if ( !@is_dir( $mkfolder ) )
            {
                @mkdir( $mkfolder, 509 );
            }
            $mkfolder .= DIRECTORY_SEPARATOR;
        }
        else
        {
            $mkfolder .= DIRECTORY_SEPARATOR;
        }
    }
    return TRUE;
}

function recursive_rmdir( $dir, $DeleteMe = TRUE )
{
    if ( !( $dh = @opendir( $dir ) ) )
    {
        return;
    }
    while ( FALSE !== ( $obj = readdir( $dh ) ) )
    {
        if ( !( $obj == "." ) )
        {
            if ( $obj == ".." )
            {
                break;
            }
        }
        else
        {
            continue;
        }
        if ( !@unlink( $dir."/".$obj ) )
        {
            recursive_rmdir( $dir."/".$obj, TRUE );
        }
    }
    closedir( $dh );
    if ( $DeleteMe )
    {
        @rmdir( $dir );
    }
}

function check_debug( )
{
    global $config;
    if ( in_array( $_SERVER['REMOTE_ADDR'], $config['debug_ips'] ) && $config['debug'] === TRUE )
    {
        return TRUE;
    }
    return FALSE;
}

function add_debug( $val )
{
    global $debug;
    $debug .= $val."<BR /><BR />";
    return TRUE;
}

?>
