<?php
/**
*
* @ This file is created by Decodeby.US
* @ deZender Public (PHP5 Decompiler)
*
* @	Version			:	1.0.0.1
* @	Author			:	Ps2Gamer & Cyko
* @	Release on		:	07.06.2011
* @	Official site	:	http://decodeby.us
*
*/

function removeXSS( $val )
{
    $val = preg_replace( "/([\\x00-\\x08][\\x0b-\\x0c][\\x0e-\\x20])/", "", $val );
    $search = "abcdefghijklmnopqrstuvwxyz";
    $search .= "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    $search .= "1234567890!@#\$%^&*()";
    $search .= "~`\";:?+/={}[]-_|'\\";
    $i = 0;
    for ( ; $i < strlen( $search ); ++$i )
    {
        $val = preg_replace( "/(&#[x|X]0{0,8}".dechex( ord( $search[$i] ) ).";?)/i", $search[$i], $val );
        $val = preg_replace( "/(&#0{0,8}".ord( $search[$i] ).";?)/", $search[$i], $val );
    }
    $ra1 = array( "javascript", "vbscript", "expression", "applet", "meta", "xml", "blink", "style", "script", "embed", "object", "iframe", "frame", "frameset", "ilayer", "layer", "bgsound", "title", "base" );
    $ra2 = array( "onabort", "onactivate", "onafterprint", "onafterupdate", "onbeforeactivate", "onbeforecopy", "onbeforecut", "onbeforedeactivate", "onbeforeeditfocus", "onbeforepaste", "onbeforeprint", "onbeforeunload", "onbeforeupdate", "onblur", "onbounce", "oncellchange", "onchange", "onclick", "oncontextmenu", "oncontrolselect", "oncopy", "oncut", "ondataavailable", "ondatasetchanged", "ondatasetcomplete", "ondblclick", "ondeactivate", "ondrag", "ondragend", "ondragenter", "ondragleave", "ondragover", "ondragstart", "ondrop", "onerror", "onerrorupdate", "onfilterchange", "onfinish", "onfocus", "onfocusin", "onfocusout", "onhelp", "onkeydown", "onkeypress", "onkeyup", "onlayoutcomplete", "onload", "onlosecapture", "onmousedown", "onmouseenter", "onmouseleave", "onmousemove", "onmouseout", "onmouseover", "onmouseup", "onmousewheel", "onmove", "onmoveend", "onmovestart", "onpaste", "onpropertychange", "onreadystatechange", "onreset", "onresize", "onresizeend", "onresizestart", "onrowenter", "onrowexit", "onrowsdelete", "onrowsinserted", "onscroll", "onselect", "onselectionchange", "onselectstart", "onstart", "onstop", "onsubmit", "onunload" );
    $ra = array_merge( $ra1, $ra2 );
    $found = TRUE;
    while ( $found )
    {
        $val_before = $val;
        $i = 0;
        for ( ; $i < sizeof( $ra ); ++$i )
        {
            $pattern = "/";
            $j = 0;
            for ( ; $j < strlen( $ra[$i] ); ++$j )
            {
                if ( 0 < $j )
                {
                    $pattern .= "(";
                    $pattern .= "(&#[x|X]0{0,8}([9][a][b]);?)?";
                    $pattern .= "|(&#0{0,8}([9][10][13]);?)?";
                    $pattern .= ")?";
                }
                $pattern .= $ra[$i][$j];
            }
            $pattern .= "/i";
            $replacement = substr( $ra[$i], 0, 2 )."<x>".substr( $ra[$i], 2 );
            $val = preg_replace( $pattern, $replacement, $val );
            if ( $val_before == $val )
            {
                $found = FALSE;
            }
        }
    }
    return $val;
}

function urlsafe_b64encode( $string )
{
    $data = base64_encode( $string );
    $data = str_replace( array( "+", "/", "=" ), array( "-", "_", "" ), $data );
    return $data;
}

function urlsafe_b64decode( $string )
{
    $data = str_replace( array( "-", "_" ), array( "+", "/" ), $string );
    $mod4 = strlen( $data ) % 4;
    if ( $mod4 )
    {
        $data .= substr( "====", $mod4 );
    }
    $data = base64_decode( $data );
    return $data;
}

function strip_html_tags( $text )
{
    $text = preg_replace( array( "@<head[^>]*?>.*?</head>@siu", "@<style[^>]*?>.*?</style>@siu", "@<script[^>]*?.*?</script>@siu", "@<object[^>]*?.*?</object>@siu", "@<embed[^>]*?.*?</embed>@siu", "@<applet[^>]*?.*?</applet>@siu", "@<noframes[^>]*?.*?</noframes>@siu", "@<noscript[^>]*?.*?</noscript>@siu", "@<noembed[^>]*?.*?</noembed>@siu", "@</?((address)|(blockquote)|(center)|(del)|(marquee)|(map))@iu", "@</?((div)|(ins)|(isindex)|(pre))@iu", "@</?((dir)|(dl)|(dt)|(dd)|(menu))@iu", "@</?((form)|(button)|(fieldset)|(legend)|(input))@iu", "@</?((label)|(select)|(optgroup)|(option)|(textarea))@iu", "@</?((frameset)|(frame)|(iframe))@iu" ), array( " ", " ", " ", " ", " ", " ", " ", " ", " ", "\n\$0", "\n\$0", "\n\$0", "\n\$0", "\n\$0", "\n\$0", "\n\$0", "\n\$0" ), $text );
    return $text;
}

function sql_quote( $value, $toStrip = TRUE )
{
    $value = str_replace( "<x>", "", $value );
    if ( $toStrip )
    {
        $value = strip_html_tags( $value );
    }
    if ( get_magic_quotes_gpc( ) )
    {
        $value = stripslashes( $value );
    }
    $value = addslashes( $value );
    return $value;
}

function isBot( )
{
    $botlist = array( "Teoma", "diri", "alexa", "froogle", "Gigabot", "inktomi", "looksmart", "URL_Spider_SQL", "Firefly", "NationalDirectory", "Ask Jeeves", "TECNOSEEK", "InfoSeek", "WebFindBot", "girafabot", "crawler", "www.galaxy.com", "Googlebot", "Scooter", "Slurp", "msnbot", "appie", "FAST", "WebBug", "Spade", "ZyBorg", "rabaz", "Baiduspider", "Feedfetcher-Google", "TechnoratiSnoop", "Rankivabot", "Mediapartners-Google", "Sogou web spider", "WebAlta Crawler" );
    foreach ( $botlist as $bot )
    {
        if ( !ereg( $bot, $_SERVER['HTTP_USER_AGENT'] ) )
        {
            continue;
        }
        return TRUE;
    }
    return FALSE;
}

?>
