<?php 
	
function check_email($address) {
	return (preg_match ( '/^[-!#$%&\'*+\\.\/0-9=?A-Z^_`{|}~]+' . '@' . '([-0-9A-Z]+\.)+' . '([0-9A-Z]){2,4}$/i', trim ( $address ) ));
}

	$isInstalled = false;
	if(file_exists($_SERVER['DOCUMENT_ROOT'].'/data/uploads/language/config.php')) {
		$isInstalled = true;
	}

	$buff = scandir($_SERVER['DOCUMENT_ROOT'].'/base/languages/');
	$languages = array();
	if(is_array($buff)) {
		foreach($buff as $f) {
			if(is_file($_SERVER['DOCUMENT_ROOT'].'/base/languages/'.$f)) {
				$f = basename($f, '.php');
				$languages[$f] = $f;
			} 
		}
	}	
	
	if(isset($_POST['install']) && !$isInstalled) {
		
		if(!isset($_POST['mysql_user']) || trim($_POST['mysql_user']) == '') {
			$error = 'yes';
		}
		if(!isset($_POST['mysql_pass']) || trim($_POST['mysql_pass']) == '') {
			$error = 'yes';
		}
		if(!isset($_POST['mysql_db']) || trim($_POST['mysql_db']) == '') {
			$error = 'yes';
		}
		if(!isset($_POST['meta_title']) || trim($_POST['meta_title']) == '') {
			$error = 'yes';
		}
		if(!isset($_POST['meta_keywords']) || trim($_POST['meta_keywords']) == '') {
			$error = 'yes';
		}
		if(!isset($_POST['meta_description']) || trim($_POST['meta_description']) == '') {
			$error = 'yes';
		}
		if(!isset($_POST['admin_mail']) || !check_email($_POST['admin_mail'])) {
			$error = 'yes';
		}
		if(!isset($_POST['report_mail']) || !check_email($_POST['report_mail'])) {
			$error = 'yes';
		}
		if(!isset($_POST['paypal_email']) || !check_email($_POST['paypal_email'])) {
			$error = 'yes';
		}
		if(!isset($_POST['lang']) || trim($_POST['lang']) == '') {
			$error = 'yes';
		}
		
		if(!isset($error)) {
			
			$dbl = mysql_connect('localhost', $_POST['mysql_user'], $_POST['mysql_pass']);
			if($dbl === FALSE) {
				$error = 'yes';
			}
			else {
				$s = mysql_select_db($_POST['mysql_db']);
				if($s === FALSE) {
					$error = 'yes';
				}
			}
			
			if(!isset($error)) {
				
				$dm = $_SERVER['HTTP_HOST'];
				if(substr($dm, 0, 4) == 'www.') {
					$dm = substr($dm, 4);
				}
				
				mysql_query("SET NAMES UTF-8");
				
				copy($_SERVER['DOCUMENT_ROOT'].'/base/languages/'.$_POST['lang'].'.php', $_SERVER['DOCUMENT_ROOT'].'/data/uploads/language/lang.php');
			
				$handle = fopen($_SERVER['DOCUMENT_ROOT'].'/data/uploads/language/current.txt', 'w');
					fwrite($handle, $_POST['lang']);
				fclose($handle);
			
				$fp = fopen($_SERVER['DOCUMENT_ROOT'].'/data/uploads/language/config.php', 'w');
					fwrite($fp, "<?php \n\n");
					fwrite($fp, '$configArr = array('."\n");
					fwrite($fp, '	\'engine_path\' => \''.$_SERVER['DOCUMENT_ROOT'].'/engine/\', '."\n");
					fwrite($fp, '	\'root_path\' => \''.$_SERVER['DOCUMENT_ROOT'].'/\', '."\n");
					fwrite($fp, '	\'domain\' => \''.$dm.'\', '."\n");
					fwrite($fp, '	\'mysql_user\' => \''.$_POST['mysql_user'].'\', '."\n");
					fwrite($fp, '	\'mysql_pass\' => \''.$_POST['mysql_pass'].'\', '."\n");
					fwrite($fp, '	\'mysql_db\' => \''.$_POST['mysql_db'].'\', '."\n");
					fwrite($fp, '); '."\n\n");
					fwrite($fp, '?>');											
				fclose($fp);
	
				$fp = fopen($_SERVER['DOCUMENT_ROOT'].'/data/uploads/language/editor.config.php', 'w');
					fwrite($fp, "<?php \n\n");
					fwrite($fp, '$configArr = array('."\n");
					fwrite($fp, '	\'engine_path\' => \''.$_SERVER['DOCUMENT_ROOT'].'/engine/\', '."\n");
					fwrite($fp, '	\'root_path\' => \''.$_SERVER['DOCUMENT_ROOT'].'/\', '."\n");
					fwrite($fp, '	\'domain\' => \''.$dm.'\', '."\n");
					fwrite($fp, '); '."\n\n");
					fwrite($fp, '?>');											
				fclose($fp);
				
				$adminPassword = rand(0,9999).rand(0,9999).rand(0,9999);
				
				require_once 'db.php';
				
				mysql_close($dbl);
				
				$complete = 'yes';
				
			}
			
		}
		
	}
	else {
		$_POST['mysql_user'] = '';
		$_POST['mysql_pass'] = '';
		$_POST['mysql_db'] = '';
		$_POST['admin_mail'] = '';
		$_POST['report_mail'] = '';
		$_POST['paypal_email'] = '';
		$_POST['meta_title'] = '';
		$_POST['meta_keywords'] = '';
		$_POST['meta_description'] = '';
		$_POST['lang'] = '';
	}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>

	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta http-equiv="X-UA-Compatible" content="IE=EmulateIE7" />
	
	<title>Install script</title>
	
	<link rel="stylesheet" type="text/css" href="install.css"/>

	<meta name="robots" content="index,follow" />
	<meta name="author" content="" /> 
	
</head>
<body>

	<div id="header">
		<div class="content_holder">
		
			<a href="/" title=""><img src="/data/images/logo.png" alt="" title="" id="logo" /></a>
			
			<div id="breadcrumb">Installation script</div>
			
			<div class="clear"></div>
		
		</div>
	</div> <!-- end of header -->

	<div id="content">
		<div class="content_holder">
		
<?php 
	if($isInstalled) {
?>		
			<div class="box2">
				<div class="box_error">
					<strong>Your system has been installed!</strong>
					<br /><br />
					<strong>Please DELETE installation folder /install/</strong>
				</div>
			</div>		
<?php 			
	}
	elseif(isset($complete)) {
?>		
			<div class="box3">
				<div class="box_complete">
					<strong>You are DONE!</strong>
					<br /><br />
					Your password for the admin panel is: <strong><?php echo $adminPassword; ?></strong>
					<br /><br />
					<strong>WORNING: Change your password immediately after logging in!</strong>
					<br /><br />
					<a href="/" title="">Go to website</a>
					&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
					<a href="/admin/" title="">Go to admin panel</a>
				</div>
			</div>
<?php						
	}
	else {
?>

<?php 
	if(isset($error)) {
?>		
			<div class="box2">
				<div class="box_error">Please enter valid information in all fields</div>
			</div>
<?php						
	}
?>
			
			<div class="box">
				<div class="box_inner">
					<p>
						Before installation, you must set writing permission(777) in the following folders: <br /><br />
						<strong>/engine/data/cache/ and all subfolders</strong><br />
						<strong>/engine/data/logs/</strong><br />
						<strong>/data/uploads/ and all subfolders</strong>
					</p>
		
					<form method="post" action="">
						<label>MySQL user</label>
						<input type="text" name="mysql_user" value="<?php echo htmlspecialchars($_POST['mysql_user']); ?>" />
						
						<label>MySQL pass</label>
						<input type="text" name="mysql_pass" value="<?php echo htmlspecialchars($_POST['mysql_pass']); ?>" />
						
						<label>MySQL db</label>
						<input type="text" name="mysql_db" value="<?php echo htmlspecialchars($_POST['mysql_db']); ?>" />
						
						<div class="clear"><br /></div>

						<label>Admin e-mail</label>
						<input type="text" name="admin_mail" value="<?php echo htmlspecialchars($_POST['admin_mail']); ?>" />
						
						<label>E-mail for reports</label>
						<input type="text" name="report_mail" value="<?php echo htmlspecialchars($_POST['report_mail']); ?>" />
						
						<label>PayPal e-mail</label>
						<input type="text" name="paypal_email" value="<?php echo htmlspecialchars($_POST['paypal_email']); ?>" />
						
						<div class="clear"><br /></div>

						<label>Meta title</label>
						<input type="text" name="meta_title" value="<?php echo htmlspecialchars($_POST['meta_title']); ?>" />
						
						<label>Meta keywords</label>
						<input type="text" name="meta_keywords" value="<?php echo htmlspecialchars($_POST['meta_keywords']); ?>" />
						
						<label>Meta description</label>
						<input type="text" name="meta_description" value="<?php echo htmlspecialchars($_POST['meta_description']); ?>" />
						
						<div class="clear"><br /></div>

						<label>Language</label>
						<select name="lang">
<?php 
						if(isset($languages)) {
							foreach($languages as $l) {
								echo '<option value="'.$l.'"';
								if($_POST['lang'] == $l) echo ' selected="selected" ';
								echo '>'.$l.'</option>';									
							}
						}
?>						
						</select>

						<div class="clear"></div>
						
						<button type="submit" name="install">Install</button>		
					</form>										
					
				</div>
			</div>
			
<?php 
	}
?>			
		
		</div>		
	</div> <!-- end of content -->
	
	<div id="footer">
		<div class="content_holder">
			
			<div id="copyrights">				
				<a href="http://cloneforest.com" title="marketplace script" target="_blank">Marketplace script</a> from CloneForest
			</div>
			
		</div>
	</div> <!-- end of footer -->

</body>
</html>