<?php 
_setView(__FILE__);

	$collectionID = get_id(2);

	$collectionsClass = new collections();
	
	$collection = $collectionsClass->get($collectionID);
	if(!is_array($collection) || ($collection['public'] == 'false' && check_login_bool() && $collection['user_id'] != $_SESSION['user']['user_id'])) {
		refresh('/'.$languageURL.'collections/', $langArray['wrong_collection'], 'error');
	}
	
	abr('checkItemsType', 'yes');

	require_once ROOT_PATH.'/modules/users/models/users.class.php';
	$usersClass = new users();
	
	$collection['user'] = $usersClass->get($collection['user_id']);
	
	if(check_login_bool()) {
		$collection['rate'] = $collectionsClass->isRate($collectionID);
	}
	
	abr('collection', $collection);

#DELETE ITEM
	if(isset($_GET['delete']) && check_login_bool() && $collection['user_id'] == $_SESSION['user']['user_id']) {
		$collectionsClass->deleteBookmark($collectionID, $_GET['delete']);
		refresh('/'.$languageURL.'collections/view/'.$collectionID, $langArray['complete_delete_bookmark'], 'complete');
	}
	
#UPDATE COLLECTION
	if(check_login_bool() && isset($_POST['edit']) && $collection['user_id'] == $_SESSION['user']['user_id']) {
		$collectionsClass->edit($collectionID);
		refresh('/'.$languageURL.'collections/view/'.$collectionID, $langArray['complete_edit_collection'], 'complete');
	}

#DELETE COLLECTION
	if(check_login_bool() && isset($_POST['delete']) && $collection['user_id'] == $_SESSION['user']['user_id']) {
		$collectionsClass->delete($collectionID);
		refresh('/'.$languageURL.'collections/', $langArray['complete_delete_collection'], 'complete');
	}
	
#LOAD COLLECTION ITEMS
	$limit = 20;
	$start = (PAGE-1)*$limit;
	
	$order = '';
	if(!isset($_GET['sort_by'])) {
		$_GET['sort_by'] = '';
	}
	switch($_GET['sort_by']) {
		case 'name':
			$order = '`name`';
			break;
		case 'average_rating':
			$order = '`rating`';
			break;
		
		default:
			$order = '`datetime`';
			break;
	}
	if(!isset($_GET['order']) || $_GET['order'] == '' || $_GET['order'] == 'desc') {
		$_GET['order'] = 'desc';
		$order .= ' DESC';
	}
	else {
		$_GET['order'] = 'asc';
		$order .= ' ASC';
	}
	
	$items = $collectionsClass->getItems($collectionID, $start, $limit, " AND `status` = 'active' ", $order);
	if(is_array($items)) {
		
		require_once ROOT_PATH.'/modules/users/models/users.class.php';
		$usersClass = new users();
		
		$users = $usersClass->getAll(0, 0, $collectionsClass->usersWhere);
		abr('users', $users);
				
	}
	abr('items', $items);

	abr('paging', paging('/'.$languageURL.'collections/view/'.$collectionID.'/?p=', '&sort_by='.$_GET['sort_by'].'&order='.$_GET['order'], PAGE, $limit, $collectionsClass->foundRows));	

#LOAD CATEGORIES
	require_once ROOT_PATH.'/modules/categories/models/categories.class.php';
	$categoriesClass = new categories();

	$categories = $categoriesClass->getAll();
	abr('categories', $categories);	
	
#BREADCRUMB	
	abr('breadcrumb', '<a href="/'.$languageURL.'" title="">'.$langArray['home'].'</a> \ <a href="/'.$languageURL.'collections/" title="">'.$langArray['public_collections'].'</a> \ <a href="/'.$languageURL.'collections/view/'.$collection['id'].'" title="">'.$collection['name'].'</a>');		
	
	
?>