<?php 
_setView(__FILE__);

if(!check_login_bool()) {
	refresh('/'.$languageURL.'users/login/');
}

	$itemID = get_id(2);
	
	$itemsClass = new items();
	$item = $itemsClass->get($itemID);
	if(!is_array($item) || $item['user_id'] != $_SESSION['user']['user_id']) {
		refresh('/'.$languageURL, $langArray['wrong_item'], '');
	}
	abr('item', $item);
	
#LOAD ATTRIBUTES
	require_once ROOT_PATH.'/modules/attributes/models/attributes.class.php';
	$attributesClass = new attributes();
	
	$attributes = $attributesClass->getAllWithCategories(" `visible` = 'true' ");
	abr('attributes', $attributes);
	
#CHECK IS IN UPDATE QUEUE
	if($itemsClass->isInUpdateQueue($itemID)) {
		abr('inUpdateQueue', 'yes');
	}	
	
	
	if(isset($_POST['save'])) {
		$s = $itemsClass->edit($itemID);
		if($s === true) {
			refresh('/'.$languageURL.'items/'.$itemID.'/', $langArray['complete_update_item'], 'complete');
		}
		else {
			$message = '<ul>';
			foreach($s as $e) {
				$message .= '<li>'.$e.'</li>';
			}
			$message .= '</ul>';
			addErrorMessage($message, '', 'error');
		}
	}
	elseif(isset($_POST['upload'])) {
		$s = $itemsClass->edit_upload($itemID);
		if($s === true) {
			refresh('/'.$languageURL.'items/'.$itemID.'/', $langArray['complete_update_upload_item'], 'complete');
		}
		else {
			$message = '<ul>';
			foreach($s as $e) {
				$message .= '<li>'.$e.'</li>';
			}
			$message .= '</ul>';
			addErrorMessage($message, '', 'error');
		}
	}
	elseif(isset($_POST['delete'])) {
		$itemsClass->delete($itemID);
		refresh('/'.$languageURL.'users/dashboard/', $langArray['complete_delete_item'], 'complete');
	}
	else {
		$_POST = $item;
		unset($_POST['tags']);
		if(is_array($item['tags'])) {
			foreach($item['tags'] as $type=>$arr) {
				foreach($arr as $t) {
					if(!isset($_POST['tags'][$type])) {
						$_POST['tags'][$type] = '';
					}
					$_POST['tags'][$type] .= $t.',';
				}
			}
		}
	}
	
	abr('sessID', session_id());
	
?>