<?php 
_setView(__FILE__);

if(!check_login_bool()) {
	refresh('/'.$languageURL.'users/login/');
}

	if($_SESSION['user']['quiz'] != 'true') {
		refresh('/'.$languageURL.'quiz/', $langArray['message_quiz_to_upload'], 'warning');
	} 	

	if(!isset($_GET['category']) || !is_numeric($_GET['category']) || $_GET['category'] == '0') {
		$_GET['category'] = '';
	}
	
	$allCategories = $categoriesClass->getAllWithChilds(0, " `visible` = 'true' ");
	if(!array_key_exists($_GET['category'], $allCategories)) {
		addErrorMessage($langArray['error_wrong_category'], '', 'error');
		abr('hideForm', 'true');
	}
	else {
		
		if(!isset($_POST['category'])) {
			$_POST['category'] = 0;
		}
		
		$categoriesSelect = $categoriesClass->generateSelect($allCategories, $_POST['category'], $_GET['category']);
		abr('categoriesSelect', $categoriesSelect);

#LOAD ATTRIBUTES
		require_once ROOT_PATH.'/modules/attributes/models/attributes.class.php';
		$attributesClass = new attributes();
		
		$attributes = $attributesClass->getAllWithCategories(" `visible` = 'true' ");
		abr('attributes', $attributes);
		
#SAVE ITEM
		if(isset($_POST['upload'])) {
			require_once ROOT_PATH.'/modules/items/models/items.class.php';
			$itemsClass = new items();
			
			$s = $itemsClass->add();
			if($s === true) {
				refresh('/'.$languageURL.'users/dashboard/', $langArray['complete_upload_item'], 'complete');
			}
			else {
				$message = '<ul>';
				foreach($s as $e) {
					$message .= '<li>'.$e.'</li>';
				}
				$message .= '</ul>';
				addErrorMessage($message, '', 'error');
			}
		}		
		
		$fileTypes = '';
	  foreach($config['upload_ext'] as $ext) {
	  	if($fileTypes != '') {	  		
	  		$fileTypes .= ';';
	  	}
	  	$fileTypes .= '*.'.$ext;	  	
	  }
	  abr('fileTypes', $fileTypes);
	  
	  abr('sessID', session_id());
		
	}
	
#BREADCRUMB	
	abr('breadcrumb', '<a href="/'.$languageURL.'" title="">'.$langArray['home'].'</a> \ <a href="/'.$languageURL.'upload/form/?category='.$_GET['category'].'" title="">'.$langArray['upload_theme'].'</a>');		
	

?>