<?php
define ( 'USING_LANGUAGE', false );

require_once '../../../config.php';
require_once $config ['root_path'] . '/base/functions.php';

/*
 * START e7Engine...
 */
include_once $config ['engine_path'] . "/initEngine.php";
#########################################################

check_admin_login();

if (isset ( $_POST ['deleteUser'] ) && isset ( $_POST ['id'] )  && isset($_SESSION['user']['access']['users'])) {
	require_once ROOT_PATH . "/modules/users/models/users.class.php";
	$cms = new users( );
	
	$cms->delete ( intval ( $_POST ['id'] ) );
	die ( json_encode ( array_merge ( $_POST, array (
		'status' => 'true' 
	) ) ) );
}
elseif (isset ( $_POST ['deleteUserGroup'] ) && isset ( $_POST ['id'] ) && isset($_SESSION['user']['access']['users'])) {
	require_once ROOT_PATH . "/modules/users/models/groups.class.php";
	$cms = new groups( );
	
	$cms->delete ( intval ( $_POST ['id'] ) );
	die ( json_encode ( array_merge ( $_POST, array (
		'status' => 'true' 
	) ) ) );
}
elseif (isset ( $_POST ['deleteWithdraw'] ) && isset ( $_POST ['id'] ) && isset($_SESSION['user']['access']['users'])) {
	require_once ROOT_PATH . "/modules/users/models/deposit.class.php";
	$cms = new deposit( );
	
	$cms->deleteWithdraw ( intval ( $_POST ['id'] ) );
	die ( json_encode ( array_merge ( $_POST, array (
		'status' => 'true' 
	) ) ) );
}
elseif (isset ( $_POST ['deleteComment'] ) && isset ( $_POST ['id'] ) && isset($_SESSION['user']['access']['users'])) {
	require_once ROOT_PATH . "/modules/items/models/comments.class.php";
	$cms = new comments( );
	
	$cms->delete( intval ( $_POST ['id'] ) );
	die ( json_encode ( array_merge ( $_POST, array (
		'status' => 'true' 
	) ) ) );
}

echo json_encode ( array_merge ( $_POST, array (
	'status' => 'unknown error' 
) ) );
die ();

?>