<?php 

$langArray = array(

#BASE
	'username' => 'Nom d\'utilisateur',
	'password' => 'Mot de passe',
	'email' => 'E-mail',
	
	'remember_me' => 'Se souvenir de moi',
	'login' => 'Connectez-vous',
	'logout' => 'Déconnexion',

	'welcome' => 'Bienvenue',
	'edit_my_profile' => 'Modifier mon profil',
	'back' => 'Retour',
	'back_to_site' => 'Retour au site',

	'add' => 'Ajouter',
	'add_new' => 'Ajouter un nouveau',
	'edit' => 'Modifier',
	'delete' => 'Supprimer',
	'list' => 'Extrait',
	'send' => 'Envoyer',
	'save' => 'Enregistrer',

	'yes' => 'Oui',
	'no' => 'No',

	'up' => 'Jusqu\'à',
	'down' => 'en bas',

	'menu' => 'Menu',
	'home' => 'Home',

	'users' => 'Utilisateurs',
	'groups' => 'Groupes',
	'systems' => 'Paramètres système',
	'system' => 'Paramètres',
	'support' => 'Entretien',

	'add_complete' => 'Ces informations ont été ajoutées avec succès.',
	'edit_complete' => 'L\'information a été modifié avec succès.',
	'delete_complete' => 'L\'information a été supprimé avec succès.',
	'send_complete' => 'Envoi terminé.',

	'error_fill_this_field' => 'Ce champ est obligatoire.',
	'error_fill_this_field_all_langs' => 'Ce champ est obligatoire pour toutes les langues.',
	'error_fill_this_field_on' => 'Ce champ est obligatoire pour',
	'error_invalid_username_or_password' => 'Blancs nom d\'utilisateur ou mot de passe ou le compte n\'est pas activé.',

	'contact_with_us_info' => 'Pour nous contacter vous pouvez nous envoyer un email en utilisant le formulaire de contact e-mail et nous vous répondrons dès que possible.',
	'request_sended' => 'Votre demande a bien été envoyé. Nous vous répondrons dès que possible au numéro de téléphone ou l\'e-mail que vous avez indiqué.',
	'contact_sended' => 'Votre email a été envoyé avec succès. Nous vous répondrons dès que possible au numéro de téléphone ou l\'email que vous avez indiquée.',
	
	'system_information' => 'Informations sur le système',
	'system_information_text' => '',

	'keyword' => 'mot-clé',
	'value' => 'Valeur',
	'subject' => 'sujet',
	'text' => 'Texte',

	'meta_title' => 'Meta titre',
	'meta_keywords' => 'Meta mots-clés',
	'meta_description' => 'Meta description',

	'waiting' => 'En attente d\'activation', 
	'activate' => 'Activated', 
	'banned' => 'Forgotten (interdit)', 
	'generate_rand_password' => 'Générer un mot de passe aléatoire',

	'avatar' => 'Avatar',
	'city' => 'Ville',
	'address' => 'Adresse',
	'postcode' => 'Code postal',
	'phone' => 'Téléphone',
	'names' => 'Noms',
	'status' => 'Statut',
	'name' => 'Nom',
	'modules' => 'Modules',
	'sort' => 'Trier',

	'addPhotos' => 'Ajouter une image',
	'choose_photos' => 'Choisissez une image',
	'via_url' => 'Ajouter via URL (*.jpg, *.gif, *.png)',
	'title' => 'Titre',

	'error_exist_username' => 'Le nom d\'utilisateur n\'est pas disponible.',
	'error_not_valid_email' => 'L\'e-mail que vous avez entré n\'est pas valide.',
	'error_exist_email' => 'L\'e-mail que vous avez entré est déjà pris.',
	'access_error' => 'Vous n\'avez pas le droit de accesss ce module.',

	'error_no_file_upload' => 'Aucun fichier n\'est aurait mérité.',
	'error_invalid_file_ext' => 'Le fichier n\'est pas autorisé.',
	'error_file_too_big' => 'Le fichier est trop gros',
	'error_file_not_set' => 'Vous n\'avez pas choisi un fichier',

	'bg' => 'Bulgare',
	'en' => 'En anglais',

	'copy_value' => 'Copiez la valeur du champ pour toutes les langues.',

###
#	GLOBALS
###

	'are_you_sure_to_delete' => 'Etes-vous sûr de vouloir supprimer',
	'no_records' => 'Aucun résultat trouvé',

	#PAGES
	'pages' => 'Pages',

	'visible' => 'Visible',
	'in_menu' => 'Afficher dans le menu principal',
	'subpages' => 'Sous-page',
	'subpage_of' => 'Sous-page de',
	'none' => 'Aucun',
	'key' => 'Clé',

	'error_key_exist' => 'Une page avec cette clé existe déjà.',

	#CATEGORIES
	'categories' => 'Catégories',

	'subcategories' => 'Sous-catégories',
	'subcategory_of' => 'Sous-catégorie des',

	#TAGS
	'tags' => 'Tags',

	#ATTRIBUTES
	'attributes' => 'Attributs',
	'attribute' => 'attribut',

	'type' => 'Type',
	'photo' => 'Photo',

	#QUIZ
	'quiz' => 'Quiz',
	
	'answers' => 'Réponses',
	'answer' => 'Réponse',
	'right' => 'Droit',

	#BULLETIN
	'bulletin' => 'Bulletin',

	'emails' => 'E-mails',
	'send_bulletin' => 'Créer un nouveau bulletin',
	'unsubscribe' => 'Se désabonner',
	'subscribe' => 'Abonnez-vous',
	'unsubscribe2' => 'Se désabonner',
	'readed' => 'Lire',
	'view' => 'Voir',
	'sended_at' => 'Envoyer à',

	#COUNTRIES
	'countries' => 'Pays',

	#ITEMS
	'items' => 'Produits',

	'queue' => 'File d\'attente',
	'date' => 'Date',
	'preview' => 'Extrait',
	'user' => 'Utilisateur',
	'none1' => 'Aucun',

	'action' => 'Action',
	'approve' => 'Approbation',
	'back_with_comment' => 'Renvoyez l\'article avec un commentaire',
	'remove_item' => 'Supprimer l\'élément',
	'price' => 'Prix',
	'free_file' => 'gratuit de fichiers',

	'are_you_sure_submit' => 'Êtes-vous sûr de vouloir présenter cette action?',

	'queue_update' => 'Queue à jour',
	'remove_item_update' => 'Supprimer mise à jour article',
	'new_price' => 'Nouveau prix',
	'weekly_features_to' => 'Hebdomadaire caractéristiques à',

	'reported' => 'Signalé',
	'previewed' => 'Previewed',

	#PERCENTS
	'percents' => 'Pourcentages',

	'percent' => 'Pourcentages',
	'from_sum' => 'De la somme',
	'to_sum' => 'En résumé',

	'error_from_over_to' => 'La somme finale doit être plus élevé que celui initial',

	#CONTACTS
	'contacts' => 'Contact',

	#USERS
	'withdraws' => 'Gain libération',

	'australian_res' => 'Résident australien',
	'paid' => 'Payé',
	'payout' => 'Pay out',

	'complete_withdraw' => 'Est notifiée comme payé et est déduit de l\'utilisateur',
	'error_set_valid_sum' => '?',
	'error_not_enought_money_earning' => 'L\'utilisateur n\'a pas gagné de l\'argent qui est indiqué',

#ADMIN MENU
	'dashboard' => 'Tableau de bord',
	'report_comments' => 'Reported comments',
	'reports' => 'Reports',
	'reported_by' => 'Reported by',
	'report_check' => 'Report previewed',

#ADMIN
	'sales_this_month' => 'Ce mois-ci sur les ventes',
	'users_this_month' => 'Ce mois d\'utilisateurs de',
	'sales_total' => 'Les totaux des ventes',
	'users_total' => 'Nombre total d\'utilisateurs',
	'win_this_month' => 'Ce mois-ci but lucratif',
	'clear_win_this_month' => 'Bénéfice net de ce mois',
	'referal_money_this_month' => 'L\'argent du programme Référent',
	'user_win_this_month' => 'L\'utilisateur but lucratif',
	'withdraw_this_month' => 'Les sommes pour payer ce mois-ci',
	'withdraw_true_this_month' => 'Versé des sommes ce mois-ci',
	'finance' => 'Financement',
	'items_for_approve' => 'Articles pour approbation',
	'no_items_for_approve' => 'Pas d\'articles pour approbation',
	'quick_links' => 'Liens rapides',
	'win' => 'Bénéfice',
	'request_date' => 'Date de la demande',
	'commission' => 'Commission',
	'sales_earnings' => 'Revenus des ventes',
	'referal_earnings' => 'Bénéfice d\'orientation',
	'issue_categories' => 'Catégories d\'émission',
	'complete_answer_issue' => 'Votre réponse a été envoyée avec succès à l\'utilisateur.',
	'error_answer_issue' => 'Envoi d\'erreur s\'est produite réponse',
	'wrote' => 'Écrit',
	'last_contact' => 'Dernière contact',
	'read_more' => 'Lire la suite',
	'language' => 'Langue',
	'complete_change_language' => 'Vous avez réussi à changer la langue du système',

	'from_date' => 'From date',
	'to_date' => 'To date',
	'report_type' => 'Type de rapport',
	'generate_report' => 'Générer un rapport',
	'results' => 'Résultats',

	'report_1' => 'Global',
	'report_2' => 'Gains',
	'report_3' => 'Dépôt',
	'report_4' => 'sommes Versé',
	'report_5' => 'A utilisateurs',

#FRONT
	
	'complete_unsubscribe' => 'Vous avez réussi à désabonné forme notre bulletin',

	'sign_up' => 'Inscription',
	'verify_email' => 'Inscription confirmée',
	'complete' => 'Complète',

	'all_fields_required' => 'Tous se sent sont obligatoires',

	'step' => 'Étape',
	'view_all' => 'Voir tous',

	'your_details' => 'Détails du profil',
	'account_information' => 'Informations du compte',
	'first_name' => 'Nom',
	'last_name' => 'Nom de famille',
	're_type' => 'Retaper',
	'check_availability' => 'Vérifiez s\'il est aveilable',
	'agree_with_terms' => 'Je déclare que je suis d\'accord avec les termes d\'utilisation webiste',
	'sign_me_to_newsletter' => 'Ajouter mon email dans les bulletins',
	'create_account' => 'Créer mon compte',
	'why_sign_up' => 'Pourquoi devrais-je m\'inscrire?',
	'why_sign_up_info' => '<p>Il ne prend que quelques minutes et que votre compte vous permettra:</p>
		<ul class="fancy-list">
			<li>Dépôt en espèces &amp; Télécharger des fichiers</li>
			<li>Vous avez votre propre page de profil</li>
			<li>Chat sur les forums</li>
			<li>Vendez votre propre travail</li>
			<li>Membres Reportez-vous à faire de l\'argent</li>
		</ul>',

	'error_short_pass' => 'Le mot de passe est trop court',
	'error_bad_pass' => 'Le mot de passe n\'est pas assez fort. S\'il vous plaît saisir un mot de plus compliqué',
	'error_good_pass' => 'Le mot de passe est bon',
	'error_strong_pass' => 'Le mot de passe est compliquée. Bravo!',
	'error_same_password' => 'Le mot de passe et le nom d\'utilisateur sont les mêmes.',
	'error_sensetive_pass' => ' Choisissez un mot de passe sécurisé pour votre compte. Les mots de passe tels que \'123456\', \'password\' and \'xxxxxx\' e sont pas recommandés!',

	'error_not_set_username' => 'Vous devez entrer un nom d\'utilisateur',
	'error_exist_username' => 'Le nom d\'utilisateur existe déjà. S\'il vous plaît entrer un autre.',
	'error_free_username' => 'Le nom d\'utilisateur est libre',
	'error_not_valid_username' => 'Le usermane doivent se compose uniquement de lettres, chiffres et le tiret bas',
	'error_password_not_match' => 'Les deux mots de passe ne correspondent pas',
	'error_emails_not_match' => 'Les e-mails ne correspondent pas',
	'error_not_agree_with_terms' => 'Vous devez accepter les termes d\'utilisation du site',
	'error_wrong_captcha' => 'Vous devez saisir le code de l\'image',
	'error_fill_firstname' => 'Vous devez entrer votre nom',
	'error_fill_lastname' => 'Vous devez entrer votre nom de famille',
	'error_fill_email' => 'Vous devez entrer votre e-mail',
	'error_fill_email_confirm' => 'Vous devez confirmer votre e-mail',
	'error_fill_password' => 'Vous devez entrer votre mot de passe',
	'error_fill_password_confirm' => 'Vous devez confirmer votre mot de passe',
	'error_not_valid_activate_key' => 'Clé d\'activation le profil n\'est pas valide.',
	'error_invalid_username_email' => 'Aucun résultat trouvé entre votre nom d\'utilisateur et le courriel que vous avez entrée',
	'error_invalid_user_email' => 'e-mail d\'utilisateur incorrect',
	'error_wrong_old_password' => 'Votre mot de passe actuel n\'est pas valide',
	'error_choose_license' => 'Vous devez choisir votre licence',
	'error_wrong_category' => 'Vous avez choisi une catégorie de non-existantes',
	'error_not_set_name' => 'Vous devez saisir un nom',
	'error_not_set_description' => 'Vous avez à la description d\'entrée',
	'error_not_set_thumbnail' => 'Vous devez choisir une vignette',
	'error_thumbnail_jpg' => 'Vignette doit être JPG ou PNG file',
	'error_not_set_theme_preview' => 'Vous devez choisir un aperçu du thème',
	'error_theme_preview_zip' => 'Aperçu du thème devrait être un fichier ZIP',
	'error_not_set_main_file' => 'Vous devez choisir un fichier',
	'error_main_file_zip' => 'fichier principal doit être un fichier ZIP',
	'error_not_set_category' => 'Vous devez choisir une catégorie',
	'error_not_set_tags' => 'Vous devez remplir les trois champs avec des balises',
	'error_not_set_source_license' => 'Vous devez confirmer que vous disposez des droits d\'utiliser toutes les matières dans votre modèle',
	'error_set_all_attributes' => 'Vous devez marquer tous les attributs',
	'error_set_price' => 'Vous avez le prix d\'entrée',
	'error_set_comment_to_user' => 'Vous devez définir un commentaire à l\'utilisateur',
	'error_quiz' => 'Vous devez répondre à toutes les questions correctement. Vous avez {$RIGHT} bonnes réponses à partir de {$TOTAL} questions',
	'error_not_set_price' => 'Vous avez le prix d\'entrée',
	'error_deposit' => 'Un errror eu dépôt whlie réception',
	'error_not_set_question' => 'Vous n\'avez pas posé une question',
	'error_not_set_answer' => 'Vous n\'avez pas défini une réponse',
	'error_login_to_buy' => 'Vous devez vous connecter à la boutique',
	'error_paing' => 'Erreur de paiemen',
	'error_not_enought_money' => 'Vous n\'avez pas assez d\'argent dans votre compte',
	'error_item_comment' => 'Une erreur s\'est produite au moment de quitter un commentaire',
	'error_not_set_message' => 'Vous devez écrire un message',
	'error_all_fields_required' => 'Vous devez fullfil tous les champs',
	'error_invalid_email' => 'Le courriel que vous avez entrée n\'est pas valide',
	'wrong_amount' => 'Vous n\'avez pas d\'entrée une somme',
	'wrong_amount2' => 'Vous avez d\'entrée une somme nulle',
	'error_service' => 'Vous n\'avez pas choisi un moyen de paiement',
	'error_payment_email_address' => 'Vous devez entrer et confirmer votre e-mail',
	'error_australian_resident' => 'vous avez à l\'entrée et ABN ACN',
	'error_certificate' => 'Vous devez acheter un thème pour obtenir un certificat',

	'complete_create_account' => 'Votre profil a été créé avec succès. Une activation de votre compte a été envoyé à l\'e-mail indiquée.',
	'complete_activate_account' => 'Votre compte a été activé avec succès. Vous pouvez vous connecter avec votre nom d\'utilisateur et mot de passe.',
	'complete_reset_password' => 'Vous nouveau mot de passe est envoyé à votre e-mail',
	'complete_send_username' => 'Votre nom d\'utilisateur est envoyé à votre e-mail',
	'complete_change_password' => 'Votre mot de passe est modifié avec succès',
	'complete_exclusive_author_off' => 'Vous êtes vous désabonner à titre d\'auteur exclusif',
	'complete_exclusive_author_on' => 'Vous avez été marqués comme auteur exclusif',
	'complete_save_license' => 'Vous vente de licences sont correctement enregistrés',
	'complete_change_avatar_image' => 'Vous avez réussi à changer votre avatar et photo de profil',
	'complete_update_personal_info' => 'Vos données personnelles a été enregistré avec succès',
	'complete_update_social_networks' => 'Vous avez réussi à changer vos réseaux sociaux',
	'complete_upload_item' => 'Votre article a été ajouté à la file d\'attente d\'approbation',
	'complete_approve_item' => 'L\'ordre du jour est approuvé avec succès',
	'complete_unapprove_item' => 'L\'article est retourné à l\'utilisateur de révision',
	'complete_delete_item' => 'L\'article est supprimé avec succès',
	'complete_update_item' => 'Vous avez changé votre article succès',
	'complete_update_upload_item' => 'Les modifications sont acceptées. Après nos administrateurs en revue, elles seront visibles sur le site',
	'complete_delete_item' => 'L\'ordre du jour a été supprimé de la base de données', 
	'complete_approve_item_update' => 'Les mises à jour de la question sont approuvés',
	'complete_delete_item_update' => 'Les mises à jour de la question sont rejetées',
	'complete_score_quiz' => 'Le quiz est réussi. Vous pouvez commencer à vendre vos œuvres.',
	'complete_deposit' => 'Votre dépôt a été marqué avec succès. Vous pouvez maintenant magasiner à partir de notre site web',
	'complete_add_faq' => 'La question et la réponse ont été ajoutés avec succès',
	'complete_delete_faq' => 'La question et la réponse ont été supprimés avec succès',
	'complete_buy_theme' => 'Le thème a été acheté avec succès',
	'complete_add_comment' => 'Le commentaire a été ajouté avec succès',
	'complete_report_comment' => 'Merci pour avoir signalé ce commentaire',
	'complete_add_reply' => 'Votre réponse a été ajouté avec succès',
	'complete_bookmark_item' => 'Le thème est ajouté à vos favoris',
	'complete_add_collection' => 'La collection a été ajouté avec succès',
	'complete_edit_collection' => 'La collection a été changée avec succès',
	'complete_delete_collection' => 'La collection a été supprimé',
	'complete_delete_bookmark' => 'Le thème est effacé de votre collection',
	'complete_save_feature' => 'Les mises à jour sont enregistrés',
	'complete_send_email' => 'Le courriel est envoyé avec succès',
	'complete_add_to_newsletter' => 'Votre email ne sera ajouté à votre newsletter',
	'complete_add_withdrawal' => 'Votre demande pour recevoir l\'argent gagné est accepté',

	'already_in_newsletter' => 'Your email is already added to our newsletter',
	'error_newsletter' => 'Une erreur s\'est produite lors de l\'ajout des données. S\'il vous plaît vérifiez et essayez à nouveau',

	'forgot_password' => 'Mot de passe oublié',
	'forgot_username' => 'Oublié nom d\'utilisateur',
	'its_free' => 'Il est libre',
	'register_now' => 'Inscrivez-vous maintenant',

	'reset_password_info' => 'Remplissez votre nom d\'utilisateur et e-mail et nous vous enverrons le nouveau mot de passe il',
	'reset_password' => 'Nouveau mot de passe',
	'lost_username_info' => 'Remplissez le courriel que vous avez signé et nous vous enverrons notre usename',

	'my_account' => 'My account',

	'change_your_password' => 'Changez votre mot de passe',
	'current_password' => 'Mot de passe actuel',
	'new_password' => 'New password',
	'exclusive_author' => 'Auteur Exclisive',
	'exclusive_author_info' => '<p>Se mettre d\'accord pour que votre portefeuille d\'objets en vente exclusive à l\'Marchés CloneForest vous donne droit à un pourcentage plus élevé de chaque vente - de 40% à 70%. Vous pouvez toujours vendre <strong>autres</strong>articles ailleurs (sur d\'autres marchés, votre propre site) mais tous les éléments que vous placez sur un marché en CloneForest doit être exclusivement vendus sur place</p><p>articles ailleurs (sur d\'autres marchés, votre propre site) mais tous les éléments que vous placez sur un marché en CloneForest doit être exclusivement vendus sur place:</p>',
	'exclusive_author_true' => '<h3 class="underlined">Auteur Exclisive</h3><p>Vous pouvez choisir de ne pas l\'exclusivité du programme en cliquant sur le bouton ci-dessous. Vous recevrez une période de grâce de 30 jours dans lequel l\'accord est toujours observé, après quoi vos versements sera de retour à la normale et vous pouvez commencer à vendre vos articles ailleurs.</p>',	
	'exclusive_author_false' => '<h3 class="underlined">Auteur non-exclusif</h3><p>Vous pouvez choisir de ne pas l\'exclusivité du programme en cliquant sur le bouton ci-dessous. Vous recevrez une période de grâce de 30 jours dans lequel l\'accord est toujours observé, après quoi vos versements sera de retour à la normale et vous pouvez commencer à vendre vos articles ailleurs.</p>',
	'exclusive_off' => 'Me désabonner comme auteur exclusif',
	'exclusive_on' => 'Abonnez-moi à titre d\'auteur exclusif',
	'sale_license' => 'Vente de licence',
	'sale_license_info' => '<p>Choisissez les licences que vos articles sont vendus sous. Notez que toutes les licences seront utilisés pour tout type d\'objets. La norme unique de licence d\'utilisation est obligatoire.</p>',
	'extended_license' => 'Licence complète',
	'personal_license' => 'Licence d\'utilisation personnelle',	
	'avatar_homepage_image' => 'Avatar et page de l\'image',
	'homepage_image' => 'Profile photo',
	'replace' => 'Replace',
	'personal_information' => 'Les renseignements personnels',
	'company_name' => 'Nom de l\'entreprise',
	'company_name_info' => 'Si vous voulez que vos factures adressées à une société. Laissez vide pour utiliser votre nom complet.',
	'profile_head' => 'Titre du profil',
	'profile_head_info' => 'Apparaît sur votre page de profil',
	'profile_text' => 'Description',
	'lives_in' => 'Ville actuelle',
	'lives_in_info' => 'Par exemple: Sofia',
	'do_not_display_country' => 'Ne montrez pas le pays que je viens de',
	'country' => 'Pays',
	'country_info' => 'Votre sélection des pays détermine ce drapeau apparaît dans votre badge',
	'available_freelance' => 'Disponible pour les indépendants?',
	'formatting_help' => '
<p>Format votre entrée avec quelques HTML de base. <a href="http://wiki.CloneForest.com/community/forums-community/how-to-format-a-post/">Lisez les détails complets</a>, ou est ici un cours de recyclage:</p>
<p>
	&lt;strong&gt;&lt;/strong&gt; de faire des choses audacieuses<br />
	&lt;em&gt;&lt;/em&gt; mettre l\'accent sur<br />
	&lt;ul&gt;&lt;li&gt; or &lt;ol&gt;&lt;li&gt; pour faire des listes<br />
	&lt;h3&gt; or &lt;h4&gt; de faire Rubriques<br />
	&lt;pre&gt;&lt;/pre&gt; pour les blocs de code<br />
	&lt;code&gt;&lt;/code&gt; for a few words of code<br />
	&lt;a&gt;&lt;/a&gt; pour les liens<br />
	&lt;img&gt; coller dans une image (il faudra être hébergé ailleurs si)<br />
	&lt;blockquote&gt;&lt;/blockquote&gt; citer quelqu\'un<br />
</p>

<p class="smiley-help">
  <img src="/data/images/emoticons/emoticon_evilgrin.png" alt="]:)" />
  <img src="/data/images/emoticons/emoticon_grin.png" alt=":D" />
  <img src="/data/images/emoticons/emoticon_happy.png" alt=":))" />
  <img src="/data/images/emoticons/emoticon_smile.png" alt=":)" />
	<img src="/data/images/emoticons/emoticon_surprised.png" alt=":O" />
	<img src="/data/images/emoticons/emoticon_tongue.png" alt=":P" />
	<img src="/data/images/emoticons/emoticon_unhappy.png" alt=":(" />
	<img src="/data/images/emoticons/emoticon_wink.png" alt=";)" />
</p>	
	',
	'social_network_links' => 'Les médias sociaux profils',

	'wrong_page' => 'Vous avez sélectionné une page non-existante',
	
	'begin_upload' => 'Envoyer un article',
	'upload' => 'Envoyer',
	'help' => 'Aide',
	'name_desc' => 'Nom &amp; description',
	'description' => 'Description',
	'upload_name_info' => 'Max 50 symboles',
	'upload_desc_info' => 'Ce champ est utilisé pour la recherche, donc s\'il vous plaît être descriptive!',	
	'files' => 'Fichiers',
	'thumbnail' => 'Vignette',
	'thumbnail_info' => 'JPEG 80x80px Vignette',
	'theme_preview' => 'Theme Preview',
	'theme_preview_info' => 'Fichier ZIP des images (png / jpg) w / descriptions de texte en option pour l\'affichage sur le site',
	'main_file' => 'Main Fichiers',
	'main_file_info' => 'ZIP - Tous les fichiers en téléchargement',
	'filesize_info' => 'S\'il vous plaît noter que nous n\'acceptons que les tailles de fichiers jusqu\'à 500mb.',
	'category_attributes' => 'Catégorie &amp; Attributs',
	'demo_url' => 'Demo URL',
	'demo_url_info' => '*Facultatif*, un lien vers un aperçu en direct sur votre propre hébergement (i.e. http://my-site.com/demo/).',
	'category' => 'Catégorie',
	'switch_category' => 'Choisir une catégorie',
	'usage_tags' => 'Usage Tags',
	'usage_tags_info' => 'par exemple la photographie, design, mode, entreprise',
	'style_tags' => 'Style Tags',
	'style_tags_info' => 'par exemple, grunge, propre, vintage',
	'features_tags' => 'Features Tags',
	'features_tags_info' => 'par exemple jquery, php, Flash',
	'tags_info' => 'Entrez jusqu\'à 15 étiquettes dans toutes les catégories.',
	'message_to_reviewer' => 'Message le point examiné',
	'comment' => 'Commentaire',
	'comment_info' => 'S\'il vous plaît URL Etat et les détails pour toutes les images source, code, vidéo, audio ou autres éléments que vous avez utilisé dans le fichier, même si vous avez pris les photos vous-même.',
	'upload_terms' => 'Toutes les images / sons / vidéo / code / flash utilisées qui ne sont pas mes propres travaux ont été autorisés pour la revente. En dehors de ces articles, ce travail est tout à fait le mien et j\'ai plein droit de le vendre sur CloneForest.',
	'switch_upload_category' => 'Choisir une catégorie autre',
	
	'get_item_accepted' => 'Recevez votre article accepté',
	'get_item_accepted_text' => '<p>Pour donner votre article la meilleure chance possible d\'être accepté, s\'il vous plaît assurez-vous que vous avez à:</p>
      <ul class="fancy-list">
        <li>Lisez et suivez les instructions de téléchargement.</li>
        <li>Objets éléments d\'actif et de leur respect du copyright dans la boîte de NOTES AUX LECTEURS.</li>
        <li>Ajout de balises utiles et assuré qu\'ils sont correctement orthographiés (ce qui aide les acheteurs à trouver votre fichier).</li>
        <li>Ajout d\'une description de l\'objet approfondi et utile (ce qui aide également les acheteurs à trouver votre fichier).</li>
      </ul>
    <p>Si vous avez fait tout cela, vous êtes prêt à télécharger. Merci pour la vente avec CloneForest!</p>',

	'profile' => 'Profil',
	'settings' => 'Paramètres',
	'portfolio' => 'Portfolio',

	'wrong_user' => 'Vous avez sélectionné un utilisateur non-existantes',
	
	'page' => 'Page',
	'of' => 'des',
	'themes' => 'Thèmes',
	'no_items' => 'Pas d\'articles trouvés',
	'sales' => 'Ventes',
	'in' => 'In',
	'order_by' => 'Trier par',
	'rating' => 'évaluation',
	'list_view' => 'Liste',	
	'grid_view' => 'Grid',

	'off_prepaid_deposit' => 'Hors tout élément lorsque vous utilisez les dépôts payés d\'avance!',
	
	'about_the_author' => 'A propos de l\'auteur',
	'update_description' => 'Description mise à jour',
	'enter_new_details' => 'Saisissez de nouvelles données',

	'wrong_item' => 'Vous avez sélectionné un élément non-existantes',

	'save_changes' => 'Enregistrer les modifications',
	'update_item_tags_review' => 'De fichiers et de mise à jour tags (nécessite aperçu administrateur)',
	'delete_item' => 'Supprimer l\'élément',
	'delete_item_question' => 'Etes-vous sûr de vouloir supprimer cet élément? Une fois supprimé, il ne peut pas NE restauré à nouveau!',
	'delete_forever' => 'supprimer l\'élément à jamais',

	'is_in_update_queue' => 'Vous avez déjà fait des changements qui sont approuvés.',

	'message_quiz_to_upload' => 'Afin de télécharger vos fichiers pour la première vente, vous devez passer à notre quiz.',
	'check_quiz' => 'Vérifier le quiz',
	'question' => 'Question',
	'quiz_info' => 'Vous devez répondre à toutes les questions à vous vendre des œuvres',

	'deposit' => 'Dépôt',
	'current_balance' => 'Ballance Currenet',
	'need_invoice' => '<strong>Besoin d\'une facture d\'impôt?</strong><br />Assurez-vous que vous avez ajouté votre nom à la société',
	'how_much_deposit' => 'Comment veux-tu faire un dépôt?',
	'deposit_info' => 'Les dépôts sont en US$, ne sont pas remboursables et prendra fin un an après votre dernier dépôt',
	'pay_via_paypal' => 'Payer via PayPal',
	'paypal_info' => 'Vous allez être transféré vers une page sécurisée de PayPal.<br/>Après paiement de votre trésorerie sera affiché dans le panneau supérieur.',
	'pay' => 'Payer',
	'deposit_history' => 'Dépôt de $',
	'paypal_proceed' => 'En quelques secondes, vous serez transféré dans le système PayPal.',
	'select_amount' => 'Sélectionner le montant',
	'make_payment' => 'Effectuer un paiement',
	'return_to_site' => 'Retour au site',

	'wrong_item' => 'Vous avez sélectionné un élément non-existantes',
	
	'screenshots' => 'Captures d\'écran',
	'live_preview' => 'Extrait',
	'by' => 'par',
	'comments' => 'Commentaires',
	'more_items_by' => 'Plus d\'articles par',
	'prepaid_just' => 'clients des services prépayés<br/>ne payez que',
	'how' => 'Comment',
	'prepay_account' => 'Payez à partir du compte',
	'prepay_off' => 'Avec notre système de dépôt non seulement d\'achat est beaucoup plus rapide, mais nous allons également prendre 2$ de rabais sur le prix!',
	'click_to_deposit' => 'Rechargez votre compte',
	'this_is_your_file' => 'C\'est l\'un de vos fichiers',	
	'votes' => 'Votes',
	'view_portfolio' => 'Voir le portfolio',

	'all' => 'Tous les',
	'features' => 'Caractéristiques',
	'usage' => 'Utilisation',
	'style' => 'Style',
	'details' => 'Détails',
	'faqs' => 'FAQ',
	'comments1' => 'Commentaires',
	'create_faq' => 'Créer FAQ',
	'no_faq' => 'Pas de questions et réponses a ajouté encore.',

	'personal_license_info' => '<strong>Vous pouvez utiliser cet élément dans:</strong> un site (commercial, personnel, clients), ou projet de site intranet...',
	'extended_license_info' => '<strong>Vous pouvez utiliser cet élément dans:</strong> un modèle de service Web comme WPMU, ou dans le cadre d\'un progiciel pour la vente...',

	'purchase' => 'Acheter',
	'buy_now_paypal' => 'Acheter maintenant <span>(via PayPal)</span>',
	'via_paypal' => 'via PayPal',
	'redirect_to_paypal' => 'Vous allez être redirigé à payer',
	'use_prepaid_deposit' => 'Recours à des dépôts payés d\'avance <span>(Save $2)</span>',
	'from_your_account_balance' => 'du solde de votre compte',
	'make_deposit' => 'Faire un dépôt',
	'already_buyed' => 'Vous avez déjà acheté cet article. vous pouvez le télécharger à partir <a href="{$URL}" title="">d\'ici,</a>, mais si vous le souhaitez, vous pouvez l\'acheter à nouveau',
	'remove_frame' => 'Retirez le cadre',
	'purchase_this' => 'Achetez cet article',
	'item_preview' => 'Extrait l\'élément',
	'comment_item' => 'Commenter cet article',
	'comment_reply_notify' => 'Prévenez-moi lorsque je reçois une réponse',
	'post_comment' => 'Poster un commentaire',
	'no_comments' => 'Aucun commentaire n\'a été',
	'says' => 'Dire',
	'posted' => 'Publié',
	'report' => 'Rapport',
	'reply' => 'Répondre',

	'are_you_sure_report' => 'Êtes-vous sûr de vouloir rapport d\'irrégularité?',

	'wrong_comment' => 'Vous avez sélectionné un commentaire non-existantes',
	'reply_to_comment' => 'Répondre au commentaire',
	'post_reply' => 'Postez votre réponse',	
	'author' => 'Auteur',
	'replied' => 'Répondu',

	'all_right_reserved' => 'Tous droits réservés',
	'report_file' => 'Signaler ce fichier',

	'bookmark_this' => 'Ajouter à mes favoris dans les favoris',
	'private_bookmark' => 'favoris personnels',
	'or' => 'or',
	'create_bookmark' => 'Créer une nouvelle collection',
	'new_collection' => 'Nouvelle collection',
	'public_visible' => 'Vue du public',

	'collections' => 'collections',
	'create_collection' => 'Créer une collection',
	'create' => 'Créer',
	'your_public_collections' => 'Votre collections publiques',
	'your_private_collections' => 'Vos collections personnelles',

	'no_public_collections' => 'Aucun des collections publiques a ajouté',
	'no_private_collections' => 'Aucune collection personnelle ajouté',

	'wrong_collection' => 'Vous avez sélectionné une collection non-existantes',

	'home_info' => 'Modèles et des thèmes de $',
	'home_info2' => 'et etc.',

	'collection_owner' => 'Propriétaire de la collection',
	'edit_collection' => 'Modifier la collecte',
	'delete_collection' => 'collection Supprimer',
	'rate_this_collection' => 'taux de cette collection',
	'you_rate' => 'Vous nominale avec',

	'are_you_sure_delete_collection' => 'Etes-vous sûr de vouloir supprimer la collection?',
	'are_you_sure_delete_bookmark' => 'Etes-vous sûr de vouloir supprimer un élément de la collection?',

	'download_for_free' => 'Télécharger gratuitement',
	'free_file_info' => 'Ce fichier est marqué comme libre. Chaque utilisateur a une licence personnelle pour un usage privé et gratuit.<br /Vous pouvez télécharger le fichier à partir d\'ici<a href="{$URL}" title="">here</a>',

	'all_files' => 'Tous les fichiers',
	'all_categories' => 'Toutes les catégories',
	'more_categories' => 'Autres catégories',
	'browse_all_files' => 'Parcourir tous les fichiers',

	'wrong_category' => 'Vous avez choisi une catégorie non-existantes',

	'recent_items' => 'Articles récents',
	'more_recent_files' => 'Afficher les éléments plus récents',
	'grab_free_file' => 'Prenez une copie gratuite du fichier à partir',
	'here' => 'ici',
	'featured_author' => 'Auteur vedette',
	'featured_author_info' => 'Notre auteur en cours décrits ici sur CloneForest est {$USERNAME} qui se sont joints à {$MONTH} {$YEAR}, l\'an, a un portefeuille de {$ITEMS} articles à vendre et a accumulé {$SALES} de vente!',
	'view_portfolio_of' => 'Voir le portfolio de',
	'some_work_of' => 'Certaines œuvres de',
	'start_browsing' => 'Parcourir les fichiers',
	'weekly_features' => 'Hebdomadaire',

	'featured_items' => 'Point vedette',
	'item' => 'Article',

	'public_collections' => 'Collection publique',
	'view_all_collections' => 'Voir toute la collection',
	'feature_file' => 'Fichier d\'entité',
	'member_since' => 'Membre depuis',
	'social_profiles' => 'Profils sociaux',
	'profile_email_info' => 'Tous les messages sont enregistrés et le spam n\'est pas tolerated. Votre adresse e-mail sera montrée au destinataire de.',
	'from' => 'à partir de',
	'message' => 'Message',	
	'support_hours' => 'Heures de soutien',
	'support_hours_info' => 'Support CloneForest est ouvert 7 jours par semaine. billets soutien sera généralement répondu dans les 24 heures, des questions complexes peuvent prendre plus de temps.',
	'send_support_ticket' => 'Envoyer le soutien billet',
	'support_info' => 'Le soutien peut prendre jusqu\'à deux jours en période de pointe pour répondre à votre requête, mais le wiki peut avoir la réponse dont vous avez besoin, en ce moment.',
	
	'contact_username' => 'Votre nom d\'utilisateur sur les marchés',
	'contact_email' => 'Nous avons besoin de connaître l\'adresse e-mail qui est enregistrée sur votre compte Marketplace aux fins de vérification.',
	'contact_issue' => 'Commençons par la catégorie du meilleur votre problème relève de.',
	'contact_paypal' => 'Parlez-nous de la question financière ou de transaction liés que vous rencontrez.',
	'contact_transaction' => 'Cette information nous aidera à localiser le paiement sur notre compte.',
	'contact_financial' => 'Parlez-nous de la question financière ou de transaction liés que vous rencontrez.',
	'contact_item' => 'S\'il vous plaît nous fournir un lien vers l\'article que vous désirez obtenir un remboursement pour.',
	'contact_details2' => 'Explication détaillée du problème (s) que vous rencontrez dans cet article. S\'il vous plaît être aussi précis que possible lorsque vous décrivez le problème afin que nos commentateurs pouvez tenter de le reproduire.',
	'contact_details3' => 'Parlez-nous de votre problème liés au compte ou à la question.',
	'contact_details4' => 'S\'il vous plaît fournir autant de détails que possible.',
	'contact_details5' => 'Racontez-nous votre question connexe du droit d\'auteur. S\'il vous plaît fournir autant de détails que possible.',

	'your_issue' => 'Votre problème',
	'select_issue' => '- Sélectionner un problème -',
	'paypal_issue' => 'PayPal problème',
	'general_financial_issue' => 'Problème financier général',
	'item_or_file_issue' => 'Article ou le fichier problème',
	'account_issue' => 'Problèmes de compte',
	'copyright_issue' => 'Questions connexes du droit d\'auteur',
	'license_questions' => 'Questions License',
	'general_inquiry' => 'Renseignements généraux',

/*	'paypal_issue_info' => '<p> En raison de la nature complexe des demandes de renseignements financiers s\'il vous plaît vous assurer de fournir tous les renseignements pertinents à votre question, y compris. Une explication détaillée de votre problème et tous les détails reçu de la transaction, comme un numéro de transaction Paypal ou Moneybookers numéro de réception .</p><p>Fournir ces renseignements nous assurer que votre question est traitée le plus rapidement possible.</p>',
	'transaction_id' => 'Transaction ID/Réception ID',
	'financial_issue_info' => '<p>En raison de la nature complexe des demandes de renseignements financiers s\'il vous plaît vous assurer de fournir tous les renseignements pertinents à votre question, y compris. Une explication détaillée de votre problème et tous les détails reçu de la transaction, comme un numéro de transaction Paypal ou Moneybookers numéro de réception.</p><p>Ffournir ces renseignements nous assurer que votre question est traitée le plus rapidement possible.</p>',
	'item_issue_info' => '<h3>Article ou Fichier questions</h3>
<p>Malheureusement, le soutien ne peut pas vous aider si vous éprouvez des difficultés techniques générales avec un article que vous avez acheté sur le Marketplace. Si vous éprouvez des difficultés à obtenir un élément que vous avez acheté pour fonctionner correctement, s\'il vous plaît suivez ces étapes simples.</p>
<ol>
	<li>Lisez la documentation fournie avec le fichier, même si vous êtes un utilisateur expérimenté. Il ya souvent des instructions essentielles contenues dans ces documents.</li>
	<li>Lisez les commentaires et l\'onglet FAQ sur la page de l'objet. Si vous rencontrez un problème, les chances sont un autre acheteur a été dans la même position. Il ya peut-être déjà une réponse à votre question. Si votre problème n'a pas encore été abordés, vous pouvez poster une nouvelle question sur la page objet.</li>
	<li>Assurez-vous d\'avoir les compétences techniques nécessaires pour utiliser le fichier de manière efficace. En général tous les fichiers achetés sur le marché, il faudra au moins quelques connaissances avant de les utiliser correctement. Si vous n\'êtes pas sûr, essayez de chercher sur Google pour un how-to.</li>
	<li>Si vous ne pouvez toujours pas obtenir le fichier de travailler comme vous le souhaitez, vous pouvez contacter l'auteur du fichier via leur page de profil sur le Marketplace. Il est important de noter que, bien encouragés à le faire <strong>auteurs NE SONT PAS tenus de fournir soutien et vous ne sont pas garantis une réponse.</strong></li>
</ol>
<p>Si vous avez suivi ces étapes et croient encore que le fichier n'est pas comme décrit ou défectueux, vous pouvez demander un remboursement sous forme d\'un crédit site.</p>
<h3>Notre politique de remboursement</h3>
<p>Nous serons heureux de vous rembourser un crédit site pour tout fichier qui n\'est pas comme décrit, ou s\'il est défectueux. Dans les cas où un fichier a été acheté de manière incorrecte, nous ne remboursons que si vous n\'avez pas déjà téléchargé le fichier.</p>
<p><strong>S\'il vous plaît noter </strong> - l\'ouverture d'une opposition au paiement non autorisé avec votre institution financière ou illégitimement contestation d\'une transaction via Paypal ou Moneybookers est considéré comme une fraude et entraînera la désactivation de votre compte jusqu'\à ce que le problème a été résolu. S\'il vous plaît noter que les dépôts sont non remboursables comme prévu dans nos conditions d\'adhésion et les conditions (article 13. Paiements de membres Ledger).</p>',
	'account_issue_info' => '<h3>Problèmes de compte</h3>
<p>Si vous éprouvez des difficultés à accéder à votre compte et recevez une erreur qui dit:<em>"too many attempts to log in"</em>, alors s\'il vous plaît attendez une heure, puis essayez à nouveau. Si vous rencontrez toujours des difficultés, s\'il vous plaît essayer de réinitialiser votre mot de passe en utilisant l\'outil.</p>
<p><strong>Enfin, si vous ne pouvez toujours pas accéder essayez d\'effacer vos cookies et le cache du navigateur.</strong></p>
<h3>Changements Pseudo</h3>
<p>Lorsque vous soumettez une demande de changement de nom d\'utilisateur à l\'appui, s\'il vous plaît fournir deux préférences de votre nouveau nom d\'utilisateur dans le cas où le premier est déjà pris.<em>Note: Les utilisateurs ne peuvent changer leur nom d\'utilisateur une fois.</em></p>',
	'copyright_issue_info' => '<p><strong>Si vous croyez un article sur le Marketplace viole vos droits d\'auteur, vous devez soumettre un fonctionnaire DMCA take-down notification.</strong><br/><br/>CloneForest prend les allégations de violation de copyright au sérieux, c\'est pourquoi nous demandons à tous les individus ou d\'entités qui croient que leur auteur a été violé à nous envoyer une notification officielle et légale de l\'infraction. Cela est dû à la gravité de ces allégations et les implications juridiques possibles pour toutes les parties concernées. Pour plus d\'informations sur la façon de soumettre une demande de DMCA, s\'il vous plaît lire ici: </p>
<p>
	<strong>
		<span style="font-weight: normal;">
			<em>S\'il vous plaît envoyer toutes les demandes traitées au DMCA:</em>
		</span>
		<br />
		<span style="font-weight: normal;">
			<a href="mailto:support@CloneForest.com" target="_blank">support@CloneForest.com</a>
		</span>
	</strong>
</p>
<h3>Violation du droit d\'auteur Rapport</h3>
<p><strong>.</strong><br/>Si vous désirez signaler une infraction possible à qui vous avez remarqué que ne pas vous impliquer directement<br/>
Si vous êtes préoccupé par un point sur le marché peut empiéter sur une autre personne ou entreprise et du droit d\'auteur aimerait nous le faire savoir, s\'il vous plaît fournir autant de détails que possible et utilisez le formulaire ci-dessous. Nous allons prendre toutes les mesures nécessaires à la réception de votre avis.<em>S\'il vous plaît être conscient que nous ne répondrons pas à ces e-mails sauf demande expresse.</em></p>
<p><strong>Si vous avez trouvé l\'un de nos contenus piratés contenu en ligne.</strong><br/><br />
S\'il vous plaît nous en parler! Assurez-vous d\'inclure des liens vers le contenu que vous avez trouvé distribué illégalement. Nous allons prendre toutes les mesures nécessaires pour obtenir ces fichiers supprimés.</p>',
	'license_issue_info' => '<strong>Support ne peut pas répondre à des questions de licence.</strong>Malheureusement, en raison de la nature sensible et juridique des questions de licence, de soutien n\'est pas qualifié pour fournir une assistance à ces types d'enquêtes. S\'il vous plaît examiner tous les documents d'appui pertinents concernant les licences.',
*/

	'description_of_issue' => 'Description de votre problème',

	'item_link' => 'Lien article',
	'how_can_we_help' => 'Comment pouvons-nous vous aider?',
	
	'issue' => 'Problème',
	'submit' => 'Envoyer',

	'monthly_newsletter' => 'Lettre d\'information mensuelle',
	'check_out_the_archive' => 'Consulter les archives',

	'no_bulletin' => 'Pas encore ajouté bulletins',
	'followers' => 'Followers',
	'follow' => 'suite',
	'unfollow' => 'unfollow',
	'authors_i_follow' => 'Auteurs Je suis',

	'history' => 'Histoire',
	'deposit_history1' => 'Histoire de dépôt',
	'transaction_id1' => 'Transaction id',
	'when' => 'Lorsque',
	'withdrawal' => 'Retrait',

	'your_total_balance_is' => 'Votre solde total du compte est',
	'withdraw_earning' => 'Il inclut une trésorerie déposé le biais de PayPal et les gains. Vous êtes seulement en mesure de retirer les gains.',
	'current_balance_deposit' => 'Balance courante des Dépôts de fonds (payé via PayPal)',
	'current_balance_earning' => 'Balance courante des gains (Qu\'est-ce que vous pouvez retirer)',

	'make_payment_request' => 'Faire une demande de paiement',
	'payment_info' => 'Tous les retraits sont émis le 15 du mois suivant (sauf si le 15 tombe un week-end ou de vacances public, auquel cas il est délivré le jour ouvrable suivant).',
	'amount' => 'Montant',
	'all_earning_note' => 'S\'il vous plaît noter que les "salaires de l\'ensemble" demande doit être renouvelée chaque mois.<br />Cela signifie cliquant il ne provoquera pas de retraits automatiques pour les mois à venir.',
	'all_earning' => 'Tous les revenus',
	'available_at' => 'disponible à',
	'all_earning_info' => 'Si vous choisissez l\'option "Tous les revenus" option, vous devez toujours respecter les montants de retrait minimum au-dessous. Votre demande de retrait ne sera pas traitée si elle répond aux exigences minimales.',
	'payment_method' => 'Mode de paiement',
	'payment_info2' => 'Minimum $50.00 pour Moneybookers et PayPal<br />Minimum $500.00 pour Transfert de fonds international',
	'paypal_address' => 'Adresse Paypal',
	'moneybookers_address' => 'Moneybookers Adresse',
	'confirm_address' => 'S\'il vous plaît confirmer l\'adresse',
	'swift_transfer' => 'Vous Adresse complète (y compris le pays):
Compte bancaire nom (votre nom complet qui apparaît sur votre relevé de compte bancaire):
Bank Account number:
SWIFT Code:
IBAN (Le cas échéant):
Nom de la banque en pleine:
Adresse de la succursale de la Banque:
Pays de destination:',
	'taxation' => 'Fiscalité',
	'australian_resident' => 'Je suis un résident australien à des fins fiscales.',
	'i_am_author' => 'Je suis un auteur comme un hobby et une autre principale source de revenus.',
	'i_am_not_author' => 'Je ne suis pas un auteur comme un hobby et / ou c\'est ma principale source de revenus.',
	'swift_info2' => 'S\'il vous plaît noter que des frais de transaction 35.00 $ est prélevée sur tous les transferts internationaux (SWIFT).<br /><br /> CloneForest ne peut être tenu responsable des délais, des coûts supplémentaires ou aux pertes financières qui se pose d\'être fourni des informations de compte incorrect, donc s\'il vous plaît assurer que vous vérifiez les détails avec votre institution financière avant de soumettre une demande pour un transfert rapide de fil.',
	'submit_request' => 'Soumettre la demande',
	
	'downloads' => 'Téléchargements',
	'download_immediately' => 'Télécharger immédiatement',
	'download_immediately_info' => 'Vous devez télécharger vos achats <strong>immédiatement</strong> que les articles peuvent être enlevés de temps en temps.',

	'no_download_items' => 'Aucun élément encore acheté',
	'download' => 'Télécharger',

	'license_certificate' => 'Licence certificat',
	'current_featured_item' => 'Courant article en vedette',
	'featured_last_six_months' => 'Articles en vedette au cours des six derniers mois',
	'featured_authors' => 'Récemment en vedette des auteurs',
	'browse_categories' => 'Parcourir les catégories',
	'featured_files' => 'Fichiers recommandés',
	'available_freelancer' => 'Disponible pour travailler à la pige',
	'top_authors' => 'Auteurs Top',
	'view_public_collections' => 'Voir les collections publiques',

	'verify_registration' => '<h2 class="decorator">Vérifiez votre courrier électronique</h2><p>Vous recevrez un courriel avec un lien de confirmation.<br/>Cliquez sur le lien pour finaliser votre compte!</p>',
	'complete_activate' => '<h2 class="decorator">Félicitations</h2><p>Votre compte est maintenant prêt à rouler! Vous pouvez maintenant</p>',
	'deposit_cash' => 'Cash Deposit et télécharger des fichiers',
	'have_own_profile' => 'Vous avez votre propre page de profil',
	
	'old_price' => 'Ancien prix',
	'one_extended_licence' => 'Une étendue licence',
	'one_regular_licence' => 'Une licence ordinaire',

	'licence_text' => '
LICENCE CERTIFICAT : {$DOMAIN}
==============================================

Ce document atteste l\'achat de:
{$LICENCE}
tel que défini dans les termes et conditions standard sur les marchés CloneForest.

Pseudo Auteur Concédant: {$USERNAME}
Licencié: {$FIRSTNAME} {$LASTNAME}

Pour l\'article:
{$ITEMNAME}

http://{$DOMAIN}/{$LANGUAGEURL}items/{$ITEMID}
Item ID: {$ITEMID}

Licence Code: LCN{$ORDERID}



Pour toutes questions relatives à ce document ou de la licence s\'il vous plaît contacter support@{$DOMAIN}.


==== THIS IS NOT A TAX RECEIPT OR INVOICE ====		
	',

	'freelance' => 'Free-lance',
	'i_am_available' => 'Je suis disponible',
	'this_week_stats' => 'La Semaine Stats',
	'you_earned' => 'Vous avez gagné',
	'you_sold' => 'Vous avez vendu',	

	'earnings' => 'Gains',
	'redeem_earning' => 'Échangez vos gains?',
	'request_payout' => 'Demander un versement',
	'your_current_rate' => 'Votre taux',
	'rate_info1' => 'Vos tarifs sont déterminés en fonction de si vous vendez des objets exclusivement sur les marchés CloneForest et sur le volume des ventes.',
	'rate_info2' => 'C\'est la valeur totale des ventes que vous avez faites sur les marchés CloneForest! Nous utilisons ce chiffre afin de déterminer ce que votre taux est. Vous avez juste besoin de faire...',
	'rate_info3' => '...plus pour obtenir le taux de la prochaine commission. Voir <a href="/percents/">Tableau des taux</a> for more info.',

	'total_earning' => 'Total des gains',
	'referals' => 'Parrainages',
	'month' => 'Mois',
	'buy_items' => 'Les articles achetés',
	'your_balance' => 'Votre solde',
	'following_items' => 'Les articles suivants',

	'no_referals_earning' => 'Vous n\'avez pas encore obtenir de l\'argent à partir d\'un programme de parrainage',
	'total_referal_earning' => 'Total des gains d\'orientation',
	'total_sales' => 'Total des ventes',
	'sales_graph' => 'Ventes Graphique',
	'earnings_graph' => 'Résultat graphique',
	'statement' => 'Déclaration',
	'download_csv' => 'Télécharger un fichier CSV',
	'download_csv_info' => '<p>Il s\'agit d\'une déclaration complète de l\'activité qui a modifié le solde de votre compte. Il répertorie tous vos articles de vente, achats, dépôts, retraits, à l\'exclusion d\'inscription au programme auteur et non-scolarisation, le bénéfice programme de référence, etc.</p><p>Vous pouvez <strong class="strong"><a href="{$URL}">télécharger votre déclaration format CSV</a></strong>, l\'ouvrir dans un tableur et d\'effectuer vos propres calculs, graphiques, etc.</p>',
	'statement_for' => 'Déclaration de',
	'current_month' => 'Mois en cours (déclaration incomplète)',
	'past_statements' => 'Déclarations antérieures',
	'withdraw_money' => 'Retirer',
	'receive_money' => 'Reçu',
	'purchase_money' => 'prix d\'achat',
	'deposit_money' => 'déposer de l\'argent',
	'earning_money' => 'Money earning',
	'buy_item' => 'Acheter un élément',
	'sold_item' => 'Les articles vendus',
	'referal_money' => 'L\'argent gagné grâce à aiguillage vers des programmes',
	'to' => 'Pour',

	'your_recent_comments' => 'Vos commentaires récents',

	'want_to_be_freefile' => 'Je veux que mon fichier pour être libre',

	'welcome_text' => 'Bienvenue à CloneForest! Lisez notre <a href="/wiki/basics/CloneForest-basics/introduction-to-CloneForest/">Getting Started Guide</a>, visitez le <a href="http://notes.CloneForest.com/">Blog</a> pour des nouvelles et faites comme chez vous! Vous pouvez trouver des informations sur CloneForest dans notre <a href="http://wiki.CloneForest.com">Help Wiki</a>.',
	'last_signin' => 'DERNIER SignIn',
	'balance' => 'BALANCE',
	'balance1' => 'Balance',
	'hello' => 'Bonjour',
	'popular_files' => 'Fichiers populaires',
	'searching' => 'Rechercher',
	'upload_theme' => 'Envoyer thème',
	'lost_username' => 'Restaurer nom d\'utilisateur',
	'new_username' => 'nouveau nom d\'utilisateur',

	'weekly_top_sells' => 'Weekly Top ventes',
	'three_monthly' => 'Meilleures ventes - 3 mois se terminant',
	'top_authors_in' => 'Auteurs Top',
	'week_ending' => 'Semaine se terminant le',

	'start_searching' => 'Démarrer la recherche',
	'finetune_results' => 'Affiner les résultats',
	'search_within' => 'Rechercher dans',
	'view_account_history' => 'Histoire InfoCompte',

	'no_results_found' => 'Aucun résultat n\'a été trouvé',
	'search_for' => 'Rechercher',
	'search_in' => 'Chercher dans',
	'search_again' => 'Recherchez de nouveau',
	'search' => 'Rechercher',
	'search_collections' => 'Recherche Collections',
	'show_popular_items' => 'Afficher les articles populaires',
	'purchased' => 'Acheté',

	'grid_total' => 'Total des gains',
	'grid_receive' => 'Utilisateurs commission',
	'grid_referal' => 'sommes programme de référence',
	'grid_win' => 'Total net',
	'grid_deposit' => 'somme de dépôt',
	'grid_withdraw' => 'sommes Versé',
	'graph' => 'Graphic',
	'filter' => 'Filtrer',

	'what_are_collections' => 'Que sont les collections?',
	'what_are_collections_text' => 'Les collections sont des groupes d\'éléments rassemblés par les différents utilisateurs sur un thème.<br /><br />Ils peuvent être mis à privé pour un usage personnel ou public de sorte qu\'elles apparaissent sur cette page et la page d\'accueil d\'un utilisateur.',
	'ok' => 'OK',
	'no_collections' => 'Pas trouvé collections',

	'marketplace_members' => 'Marché membres',
	'total_marketplace_items' => 'Questions relatives au marché Total',
	'follow_us' => 'Suivez-nous',
	'rss_feed' => 'RSS Feed',
	'help_and_support' => 'Aide et support',
	'contact_support' => 'Contacter le support',
	'terms_of_usage' => 'CONDITIONS D\'UTILISATION',
	'copyright' => 'DROIT D\'AUTEUR',
	'category_rss' => 'Notifications un nouvel élément pour cette catégorie',
	'user_rss' => 'Nouveau flux RSS Point',

# EMAILS
	'email_activate_subject' => 'Activez votre profil',
	'email_activate_text' => 'Pour actovate votre profil dans {$DOMAIN}, s\'il vous plaît cliquer sur le lien suivant:	

{$LINK}
', 

	'email_reset_password' => 'Nouveau mot de passe',
	'email_reset_password_text' => 'Vos données pour la connexion au {$DOMAIN} sont:	

usename: {$USERNAME}
mot de passe: {$PASSWORD}
', 

	'email_lost_username' => 'Envoyez votre nom d\'utilisateur',
	'email_lost_username_text' => 'Votre nom d\'utilisateur {$DOMAIN} est {$USERNAME}',

	'email_unapprove_item_subject' => 'Votre article n\'était pas conforme',
	'email_unapprove_item_text' => 'Votre item {$THEMENAME} est retourné aux fins d\'approbation avec le commentaire suivant:

{$COMMENT}	
	
Vous pouvez modifier l\'article et le libérer à nouveau pour approbation.
	',

	'email_unapprove_delete_item_subject' => 'Votre article a été rejeté',
	'email_unapprove_delete_item_text' => 'Votre article {$THEMENAME} est rejeté avec le commentaire suivant:

{$COMMENT}	
	',

	'email_unapprove_delete_item_update_subject' => 'Votre mise à jour élément a été rejetée',
	'email_unapprove_delete_item_update_text' => 'Mises à jour de votre article {$THEMENAME} nous avons rejeté avec le commentaire suivant:
	
{$COMMENT}	
	',

	'email_report_comment_subject' => 'Avez un commentaire rapporté',
	'email_report_comment_text' => 'Rapport sur les irrégularités dans le commentaire.',

	'email_new_reply_subject' => 'Avez nouvelle réponse à votre commentaire.',
	'email_new_reply_text' => 'Une réponse est ajouté à votre commentaire {$THEMENAME}
	
{$URL}	
	',

	'email_profile_subject' => 'Message de votre profil',
	'email_profile_text' => '{$USERNAME} ({$EMAIL}) vous a envoyé un e-mail:
	
{$MESSAGE}	
	',

);

$langArray['monthArr'] = array(
	1 => 'Janvier',
	2 => 'Février',
	3 => 'Mars',
	4 => 'Avril',
	5 => 'Mai',
	6 => 'Juin',
	7 => 'Juillet',
	8 => 'Août',
	9 => 'Septembre',
	10 => 'Octomber',
	11 => 'Novembre',
	12 => 'Décembre',
	'01' => 'Janvier',
	'02' => 'Février',
	'03' => 'Mars',
	'04' => 'Avril',
	'05' => 'Mai',
	'06' => 'Juin',
	'07' => 'Juillet',
	'08' => 'Août',
	'09' => 'Septembre'
);


?>