<?php
/**
*
* @ This file is created by Decodeby.US
* @ deZender Public (PHP5 Decompiler)
*
* @	Version			:	1.0.0.1
* @	Author			:	Ps2Gamer & Cyko
* @	Release on		:	07.06.2011
* @	Official site	:	http://decodeby.us
*
*/

function smarty_function_fetch( $params, &$smarty )
{
    if ( empty( $params['file'] ) )
    {
        $smarty->_trigger_fatal_error( "[plugin] parameter 'file' cannot be empty" );
    }
    else
    {
        $content = "";
        if ( $smarty->security && !preg_match( "!^(http|ftp)://!i", $params['file'] ) )
        {
            $_params = array(
                "resource_type" => "file",
                "resource_name" => $params['file']
            );
            require_once( SMARTY_CORE_DIR."core.is_secure.php" );
            if ( !smarty_core_is_secure( $_params, $smarty ) )
            {
                $smarty->_trigger_fatal_error( "[plugin] (secure mode) fetch '".$params['file']."' is not allowed" );
            }
            else if ( $fp = @fopen( $params['file'], "r" ) )
            {
                while ( !feof( $fp ) )
                {
                    $content .= fgets( $fp, 4096 );
                }
                fclose( $fp );
                break;
            }
            else
            {
                $smarty->_trigger_fatal_error( "[plugin] fetch cannot read file '".$params['file']."'" );
            }
        }
        else
        {
            do
            {
                if ( preg_match( "!^http://!i", $params['file'] ) )
                {
                    if ( $uri_parts = parse_url( $params['file'] ) )
                    {
                        $host = $server_name = $uri_parts['host'];
                        $timeout = 30;
                        $accept = "image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*";
                        $agent = "Smarty Template Engine ".$smarty->_version;
                        $referer = "";
                        $uri = !empty( $uri_parts['path'] ) ? $uri_parts['path'] : "/";
                        $uri .= !empty( $uri_parts['query'] ) ? "?".$uri_parts['query'] : "";
                        $_is_proxy = FALSE;
                        if ( empty( $uri_parts['port'] ) )
                        {
                            $port = 80;
                        }
                        else
                        {
                            $port = $uri_parts['port'];
                        }
                        if ( !empty( $uri_parts['user'] ) )
                        {
                            $user = $uri_parts['user'];
                        }
                        if ( !empty( $uri_parts['pass'] ) )
                        {
                            $pass = $uri_parts['pass'];
                        }
                    default :
                        switch ( $param_key )
                        {
                            foreach ( $params as $param_key => $param_value )
                            {
                            case "file" :
                            case "assign" :
                            case "assign_headers" :
                            case "user" :
                                if ( empty( $param_value ) )
                                {
                                    continue;
                                }
                                $user = $param_value;
                                continue;
                            case "pass" :
                                if ( empty( $param_value ) )
                                {
                                    continue;
                                }
                                $pass = $param_value;
                                continue;
                            case "accept" :
                                if ( empty( $param_value ) )
                                {
                                    continue;
                                }
                                $accept = $param_value;
                                continue;
                            case "header" :
                                if ( empty( $param_value ) )
                                {
                                    continue;
                                }
                                if ( !preg_match( "![\\w\\d-]+: .+!", $param_value ) )
                                {
                                    $smarty->_trigger_fatal_error( "[plugin] invalid header format '".$param_value."'" );
                                }
                                else
                                {
                                    $extra_headers[] = $param_value;
                                }
                                continue;
                            case "proxy_host" :
                                if ( empty( $param_value ) )
                                {
                                    continue;
                                }
                                $proxy_host = $param_value;
                                continue;
                            case "proxy_port" :
                                if ( !preg_match( "!\\D!", $param_value ) )
                                {
                                    $proxy_port = ( integer )$param_value;
                                }
                                else
                                {
                                    $smarty->_trigger_fatal_error( "[plugin] invalid value for attribute '".$param_key."'" );
                                }
                                return;
                            case "agent" :
                                if ( empty( $param_value ) )
                                {
                                    continue;
                                }
                                $agent = $param_value;
                                continue;
                            case "referer" :
                                if ( empty( $param_value ) )
                                {
                                    continue;
                                }
                                $referer = $param_value;
                                continue;
                            case "timeout" :
                                if ( !preg_match( "!\\D!", $param_value ) )
                                {
                                    $timeout = ( integer )$param_value;
                                }
                                else
                                {
                                    $smarty->_trigger_fatal_error( "[plugin] invalid value for attribute '".$param_key."'" );
                                    return;
                                }
                            }
                            $smarty->_trigger_fatal_error( "[plugin] unrecognized attribute '".$param_key."'" );
                            return;
                        }
                        if ( !empty( $proxy_host ) || !empty( $proxy_port ) )
                        {
                            $_is_proxy = TRUE;
                            $fp = fsockopen( $proxy_host, $proxy_port, &$errno, &$errstr, $timeout );
                        }
                        else
                        {
                            $fp = fsockopen( $server_name, $port, &$errno, &$errstr, $timeout );
                        }
                        if ( !$fp )
                        {
                            $smarty->_trigger_fatal_error( "[plugin] unable to fetch: ".$errstr." ({$errno})" );
                        }
                        else
                        {
                            if ( $_is_proxy )
                            {
                                fputs( $fp, "GET ".$params['file']." HTTP/1.0\r\n" );
                            }
                            else
                            {
                                fputs( $fp, "GET ".$uri." HTTP/1.0\r\n" );
                            }
                            if ( !empty( $host ) )
                            {
                                fputs( $fp, "Host: ".$host."\r\n" );
                            }
                            if ( !empty( $accept ) )
                            {
                                fputs( $fp, "Accept: ".$accept."\r\n" );
                            }
                            if ( !empty( $agent ) )
                            {
                                fputs( $fp, "User-Agent: ".$agent."\r\n" );
                            }
                            if ( !empty( $referer ) )
                            {
                                fputs( $fp, "Referer: ".$referer."\r\n" );
                            }
                            if ( isset( $extra_headers ) && is_array( $extra_headers ) )
                            {
                                foreach ( $extra_headers as $curr_header )
                                {
                                    fputs( $fp, $curr_header."\r\n" );
                                }
                            }
                            if ( !empty( $user ) || !empty( $pass ) )
                            {
                                fputs( $fp, "Authorization: BASIC ".base64_encode( "{$user}:{$pass}" )."\r\n" );
                            }
                            fputs( $fp, "\r\n" );
                            while ( !feof( $fp ) )
                            {
                                $content .= fgets( $fp, 4096 );
                            }
                            fclose( $fp );
                            $csplit = split( "\r\n\r\n", $content, 2 );
                            $content = $csplit[1];
                            if ( empty( $params['assign_headers'] ) )
                            {
                                break;
                            }
                            $smarty->assign( $params['assign_headers'], split( "\r\n", $csplit[0] ) );
                            break;
                        }
                    }
                    else
                    {
                        $smarty->_trigger_fatal_error( "[plugin] unable to parse URL, check syntax" );
                    }
                }
                else if ( $fp = @fopen( $params['file'], "r" ) )
                {
                    while ( !feof( $fp ) )
                    {
                        $content .= fgets( $fp, 4096 );
                    }
                    fclose( $fp );
                }
                else
                {
                    $smarty->_trigger_fatal_error( "[plugin] fetch cannot read file '".$params['file']."'" );
                    return;
                }
            } while ( 0 );
            if ( !empty( $params['assign'] ) )
            {
                $smarty->assign( $params['assign'], $content );
            }
        }
    }
    return $content;
}

?>
