<?php
/**
*
* @ This file is created by Decodeby.US
* @ deZender Public (PHP5 Decompiler)
*
* @	Version			:	1.0.0.1
* @	Author			:	Ps2Gamer & Cyko
* @	Release on		:	07.06.2011
* @	Official site	:	http://decodeby.us
*
*/

class cache
{

    public $cacheDir = "../cache/phpcache/";
    public $defaultCacheLife = "3600";

    public function __construct( )
    {
        $this->cacheDir = ROOT_PATH.$this->cacheDir;
    }

    public function Set( $varId, $varValue )
    {
        global $config;
        if ( $config['debug'] == 1 )
        {
            add_debug( "recache: ".$varId." = ".$varValue );
        }
        $file = $this->cacheDir."cache.".$varId;
        $fileHandler = fopen( $file, "w" );
        $s = fwrite( $fileHandler, serialize( $varValue ) );
        fclose( $fileHandler );
        return $s;
    }

    public function Get( $varId, $cacheLife = "" )
    {
        global $config;
        if ( $cacheLife !== FALSE && $cacheLife != "0" && !is_numeric( $cacheLife ) )
        {
            $cacheLife = $this->defaultCacheLife;
        }
        if ( $cacheLife == 0 )
        {
            $cacheLife = FALSE;
        }
        $file = $this->cacheDir."cache.".$varId;
        if ( file_exists( $file ) && 0 < filesize( $file ) )
        {
            if ( $cacheLife === FALSE || time( ) - filemtime( $file ) <= $cacheLife )
            {
                $fileHandler = fopen( $file, "r" );
                $varValueResult = fread( $fileHandler, filesize( $file ) );
                fclose( $fileHandler );
                return unserialize( $varValueResult );
            }
            return FALSE;
        }
        if ( $config['debug'] == 1 )
        {
            add_debug( "cache file not exists! ".$varId );
        }
        return FALSE;
    }

    public function Delete( $varId )
    {
        $file = $this->cacheDir."cache.".$varId;
        if ( file_exists( $file ) )
        {
            unlink( $file );
            return TRUE;
        }
        return FALSE;
    }

}

?>
