<?php
/**
*
* @ This file is created by Decodeby.US
* @ deZender Public (PHP5 Decompiler)
*
* @	Version			:	1.0.0.1
* @	Author			:	Ps2Gamer & Cyko
* @	Release on		:	07.06.2011
* @	Official site	:	http://decodeby.us
*
*/

class Image
{

    public $image = NULL;
    public $target = NULL;
    public $size = NULL;
    public $debug = TRUE;
    public $quality = 100;
    public $cache = FALSE;
    public $expire = 172800;
    public $enlarge = TRUE;
    public $data = array( );
    public $forceType = FALSE;
    public $allowed = array
    (
        1 => "gif",
        2 => "jpg",
        3 => "png"
    );

    public function Image( )
    {
        ini_set( "memory_limit", "512M" );
    }

    public function debug( $message )
    {
        if ( $this->debug )
        {
            $debug = debug_backtrace( );
            rsort( &$debug );
            echo $message;
            foreach ( $debug as $k => $v )
            {
                echo "\n\n<br /><br />".str_repeat( "&nbsp;", 2 + $k * 2 )."FILE: ".$v['file'];
                echo "\n<br />".str_repeat( "&nbsp;", 2 + $k * 2 )."LINE: ".$v['line'];
            }
            echo "\n<br />";
        }
        return FALSE;
    }

    public function enlarge( $value )
    {
        $this->enlarge = $value;
    }

    public function forceType( $type )
    {
        $this->forceType = $type;
    }

    public function itsImage( $image )
    {
        if ( $data = @getimagesize( $image ) )
        {
            if ( empty( $this->allowed[$data[2]] ) )
            {
                return FALSE;
            }
            return $data;
        }
        return FALSE;
    }

    public function cache( $value )
    {
        if ( $value === FALSE )
        {
            $this->cache = FALSE;
        }
        else
        {
            if ( $value === TRUE && ( empty( $this->cache ) || $this->cache === TRUE || $this->cache === FALSE ) )
            {
                $this->cache = FALSE;
                $this->debug( "The cache folder haven't a valid path: ".$this->cache );
            }
            else
            {
                if ( is_dir( $value ) )
                {
                }
                if ( !is_writable( $value ) )
                {
                    $this->cache = FALSE;
                    $this->debug( "The cache folder isn't writable to me: ".$value );
                }
                else
                {
                    $this->cache = preg_match( "#/\$#", $value ) ? $value : $value."/";
                }
            }
        }
    }

    public function inlineHeaders( $name )
    {
        header( "Content-type: image/".$this->allowed[$this->data[2]] );
        header( "Content-Disposition: inline; filename=\"".$name."\"" );
    }

    public function view( $mode, $image, $param, $cache = TRUE )
    {
        if ( !( $this->data = $this->itsImage( $image ) ) )
        {
            return $this->debug( $image." isn't a valid image" );
        }
        $name = explode( "/", $image );
        $name = end( &$name );
        $ext = explode( ".", $name );
        $ext = strtolower( end( &$ext ) );
        if ( $mode == "resize" || $mode == "crop" )
        {
            list( $width, $height ) = explode( "x", $param );
            $width = intval( $width );
            $height = intval( $height );
            if ( $width <= 0 || $height <= 0 )
            {
                return $this->debug( "No size valid: ".$width."x".$height );
            }
            if ( $this->enlarge || !( $this->data[0] <= $width ) && $this->data[1] <= $height || $this->data[0] == $width && $this->data[1] == $height )
            {
                $this->inlineHeaders( $name );
                echo file_get_contents( $image );
                return TRUE;
            }
        }
        if ( $cache && $this->cache )
        {
            if ( $this->recursive_path( $this->cache ) )
            {
            }
            if ( !is_writable( $this->cache ) )
            {
                return $this->debug( "Can't write in the cahe folder: ".$this->cache );
            }
            $target = $this->cache.md5( $mode."x".$image."x".$param ).".".$ext;
            if ( is_file( $target ) && time( ) - $this->expire < filemtime( $target ) )
            {
                $this->inlineHeaders( $name );
                echo file_get_contents( $target );
                return TRUE;
            }
        }
        else
        {
            $target = FALSE;
        }
        $this->inlineHeaders( $name );
        switch ( $mode )
        {
        case "gray" :
            $ok = $this->gray( $image, $target, TRUE );
            break;
        case "rotate" :
            $ok = $this->rotate( $image, $param, $target, TRUE );
            break;
        case "resize" :
        case "crop" :
            $ok = $this->$mode( $image, $width, $height, $target, TRUE );
            break;
        case "flip" :
        case "flop" :
        case "flipflop" :
            $ok = $this->flipflop( $image, $mode, $target, TRUE );
            break;
            return $this->debug( $mode." isn't a valid mode" );
        }
        if ( !$target )
        {
            return $ok;
        }
        if ( $ok )
        {
            echo file_get_contents( $target );
        }
        return FALSE;
    }

    public function defineTarget( $thumb, $view )
    {
        if ( $view )
        {
            $this->target = $thumb ? $thumb : FALSE;
            return TRUE;
        }
        if ( empty( $thumb ) )
        {
            if ( !is_writable( $this->image ) )
            {
                return $this->debug( "The original image haven't write permissions to me: ".$this->image );
            }
            $this->target = $this->image;
            return TRUE;
        }
        $this->target = $thumb;
        $folder = dirname( $this->target ) == "" ? "./" : dirname( $this->target );
        if ( $this->recursive_path( $folder ) )
        {
        }
        if ( !is_writable( $folder ) )
        {
            return $this->debug( "Can't write in the target folder: ".$folder );
        }
        return TRUE;
    }

    public function gray( $image, $thumb = "", $view = FALSE )
    {
        if ( !( $this->data = $this->itsImage( $image ) ) )
        {
            return $this->debug( $image." isn't a valid image" );
        }
        $this->image = $image;
        $this->defineTarget( $thumb, $view );
        $thumb = $this->imageDefine( );
        $quality = TRUE;
        if ( $quality )
        {
            $c = 0;
            for ( ; $c < 256; ++$c )
            {
                $palette[$c] = imagecolorallocate( $thumb, $c, $c, $c );
            }
            $x = 0;
            for ( ; do
 {
 $x < $this->data[0]; ++$x )
                {
                    $y = 0;
                    for ( ; $y < $this->data[1]; ++$y, )
                    {
                        $gray = imagecolorat( $thumb, $x, $y ) >> 8 & 255;
                        $rgb = imagecolorat( $thumb, $x, $y );
                        $r = $rgb >> 16 & 255;
                        $g = $rgb >> 8 & 255;
                        $b = $rgb & 255;
                        $gs = $r * 0.299 + $g * 0.587 + $b * 0.114;
                        imagesetpixel( $thumb, $x, $y, $palette[$gs] );
                    }
                    break;
                }
            } while ( 1 );
        }
        else
        {
            $x = 0;
            for ( ; $x < $this->data[0]; ++$x )
            {
                $y = 0;
                for ( ; $y < $this->data[1]; ++$y )
                {
                    $gray = imagecolorat( $thumb, $x, $y ) >> 8 & 255;
                    imagesetpixel( $thumb, $x, $y, imagecolorallocate( $thumb, $gray, $gray, $gray ) );
                }
            }
        }
        if ( $this->imageCreate( $thumb ) )
        {
            return TRUE;
        }
        return $this->debug( "A problem occours creating the image. I can't finish the task." );
    }

    public function resize( $image, $width, $height, $thumb = "", $view = FALSE )
    {
        if ( !( $this->data = $this->itsImage( $image ) ) )
        {
            return $this->debug( $image." isn't a valid image" );
        }
        if ( $this->enlarge || !( $this->data[0] <= $width ) && $this->data[1] <= $height || $this->data[0] == $width && $this->data[1] == $height )
        {
            if ( $thumb != "" && $image != $thumb )
            {
                if ( $this->defineTarget( $thumb, FALSE ) )
                {
                    @copy( $image, $thumb );
                    return TRUE;
                }
                return FALSE;
            }
            return TRUE;
        }
        $this->image = $image;
        $this->size = array(
            $width,
            $height
        );
        $this->defineTarget( $thumb, $view );
        return $this->_mainTransform( );
    }

    public function flipflop( $image, $mode, $thumb = "", $view = FALSE )
    {
        if ( !( $this->data = $this->itsImage( $image ) ) )
        {
            return $this->debug( $image." isn't a valid image" );
        }
        $this->image = $image;
        $this->defineTarget( $thumb, $view );
        $newImage = $this->imageDefine( );
        $w = $this->data[0];
        $h = $this->data[1];
        $thumb = $this->transparency( $newImage, imagecreatetruecolor( $w, $h ) );
        if ( $mode == "flip" )
        {
            $x = 0;
            for ( ; do
 {
 $x < $w; ++$x, )
                {
                    imagecopy( $thumb, $newImage, $w - $x - 1, 0, $x, 0, 1, $h );
                    break;
                }
            } while ( 1 );
        }
        else if ( $mode == "flop" )
        {
            $x = 0;
            for ( ; do
 {
 $x < $h; ++$x, )
                {
                    imagecopy( $thumb, $newImage, 0, $h - $x - 1, 0, $x, $w, 1 );
                    break;
                }
            } while ( 1 );
        }
        else
        {
            $x = 0;
            for ( ; $x < $w; ++$x )
            {
                imagecopy( $thumb, $newImage, $w - $x - 1, 0, $x, 0, 1, $h );
            }
            $buffer = $this->transparency( $newImage, imagecreatetruecolor( $w, 1 ) );
            $y = 0;
            for ( ; $y < $h / 2; ++$y )
            {
                imagecopy( $buffer, $thumb, 0, 0, 0, $h - $y - 1, $w, 1 );
                imagecopy( $thumb, $thumb, 0, $h - $y - 1, 0, $y, $w, 1 );
                imagecopy( $thumb, $buffer, 0, $y, 0, 0, $w, 1 );
            }
            imagedestroy( $buffer );
        }
        if ( $this->imageCreate( $thumb ) )
        {
            return TRUE;
        }
        return $this->debug( "A problem occours creating the image. I can't finish the task." );
    }

    public function quality( $image, $quality, $thumb = "", $view = FALSE )
    {
        if ( !( $this->data = $this->itsImage( $image ) ) )
        {
            return $this->debug( $image." isn't a valid image" );
        }
        $this->image = $image;
        $this->defineTarget( $thumb, $view );
        $newImage = $this->imageDefine( );
        $thumb = $this->transparency( $newImage, imagecreatetruecolor( $this->data[0], $this->data[1] ) );
        imagecopy( $thumb, $newImage, 0, 0, 0, 0, $this->data[0], $this->data[1] );
        $old_quality = $this->quality;
        $this->quality = intval( $quality );
        if ( $this->forceType !== FALSE )
        {
            $this->data[2] = $this->forceType;
        }
        $ok = $this->imageCreate( $thumb );
        $this->quality = $old_quality;
        if ( $ok )
        {
            return TRUE;
        }
        return $this->debug( "A problem occours creating the image. I can't finish the task." );
    }

    public function crop( $image, $width, $height, $thumb = "", $view = FALSE )
    {
        if ( !( $this->data = $this->itsImage( $image ) ) )
        {
            return $this->debug( $image." isn't a valid image" );
        }
        if ( $this->enlarge || !( $this->data[0] <= $width ) && $this->data[1] <= $height || $this->data[0] == $width && $this->data[1] == $height )
        {
            if ( $thumb != "" && $image != $thumb )
            {
                if ( $this->defineTarget( $thumb, FALSE ) )
                {
                    @copy( $image, $thumb );
                    return TRUE;
                }
                return FALSE;
            }
            return TRUE;
        }
        $this->image = $image;
        $this->size = array(
            $width,
            $height
        );
        $this->defineTarget( $thumb, $view );
        if ( $width == $height )
        {
            $less = $this->data[1] < $this->data[0] ? $this->data[1] : $this->data[0];
            $width = $height = $less;
            $posX = intval( $this->data[0] / 2 - $less / 2 );
            $posY = intval( $this->data[1] / 2 - $less / 2 );
        }
        else if ( $height < $width )
        {
            list( $height, $width, $posX, $posY ) = $this->cropSize( $this->data[1], $this->data[0], $height, $width );
            if ( $posY < 0 )
            {
                list( $width, $height, $posY, $posX ) = $this->cropSize( $this->data[0], $this->data[1], $this->size[0], $this->size[1] );
            }
        }
        else if ( $width < $height )
        {
            list( $width, $height, $posY, $posX ) = $this->cropSize( $this->data[0], $this->data[1], $width, $height );
            if ( $posX < 0 )
            {
                list( $height, $width, $posX, $posY ) = $this->cropSize( $this->data[1], $this->data[0], $this->size[1], $this->size[0] );
            }
        }
        return $this->_mainTransform( $posX, $posY, $width, $height, FALSE );
    }

    public function cropSize( $sourceX, $sourceY, $targetX, $targetY )
    {
        $sizeX = round( $sourceX * $targetX / ( $sourceX * $targetY / $sourceY ) );
        $sizeY = $sourceY;
        $coordX = 0;
        $coordY = intval( $sourceX / 2 - $sizeX / 2 );
        return array(
            $sizeX,
            $sizeY,
            $coordX,
            $coordY
        );
    }

    public function rotate( $image, $degrees, $thumb = "", $view = FALSE )
    {
        if ( !( $this->data = $this->itsImage( $image ) ) )
        {
            return $this->debug( $image." isn't a valid image" );
        }
        $this->image = $image;
        $this->defineTarget( $thumb, $view );
        $newImage = $this->imageDefine( );
        if ( function_exists( "imagerotate" ) )
        {
            $thumb = $this->transparency( $newImage, imagerotate( $newImage, $degrees, 0 ) );
        }
        else
        {
            $src_x = imagesx( $newImage );
            $src_y = imagesy( $newImage );
            if ( $degrees == 180 )
            {
                $dest_x = $src_x;
                $dest_y = $src_y;
            }
            else if ( $src_x <= $src_y )
            {
                $dest_x = $src_y;
                $dest_y = $src_x;
            }
            else if ( $src_y <= $src_x )
            {
                $dest_x = $src_y;
                $dest_y = $src_x;
            }
            $thumb = $this->transparency( $newImage, imagecreatetruecolor( $dest_x, $dest_y ) );
            imagealphablending( $thumb, FALSE );
            switch ( $degrees )
            {
            case 270 :
                do
                {
                    $y = 0;
                    for ( ; $y < $src_y; ++$y )
                    {
                        $x = 0;
                        for ( ; $x < $src_x; ++$x, )
                        {
                            $color = imagecolorat( $newImage, $x, $y );
                            imagesetpixel( $thumb, $dest_x - $y - 1, $x, $color );
                        }
                        break;
                    }
                } while ( 1 );
            case 90 :
                do
                {
                    $y = 0;
                    for ( ; $y < $src_y; ++$y )
                    {
                        $x = 0;
                        for ( ; $x < $src_x; ++$x, )
                        {
                            $color = imagecolorat( $newImage, $x, $y );
                            imagesetpixel( $thumb, $y, $dest_y - $x - 1, $color );
                        }
                        break;
                    }
                } while ( 1 );
            case 180 :
                $y = 0;
                for ( ; do
 {
 $y < $src_y; ++$y )
                    {
                        $x = 0;
                        for ( ; $x < $src_x; ++$x, )
                        {
                            $color = imagecolorat( $newImage, $x, $y );
                            imagesetpixel( $thumb, $dest_x - $x - 1, $dest_y - $y - 1, $color );
                        }
                        break;
                    }
                } while ( 1 );
                $thumb = $newImage;
            }
        }
        if ( $this->imageCreate( $thumb ) )
        {
            return TRUE;
        }
        return $this->debug( "A problem occours creating the image. I can't finish the task." );
    }

    public function _mainTransform( $posX = 0, $posY = 0, $width = 0, $height = 0, $proportions = TRUE )
    {
        $newImage = $this->imageDefine( );
        if ( !$newImage )
        {
            return $this->debug( $this->image." isn't JPG, GIF nor PGN" );
        }
        if ( $proportions )
        {
            list( $dX, $dY ) = $this->proportions( $this->data[0], $this->data[1] );
            list( $width, $height ) = array(
                $this->data[0],
                $this->data[1]
            );
        }
        else
        {
            list( $dX, $dY ) = array(
                $this->size[0],
                $this->size[1]
            );
        }
        list( $posX, $posY ) = $this->maxSize( $posX, $posY, $width, $height );
        $thumb = $this->transparency( $newImage, imagecreatetruecolor( $dX, $dY ) );
        imagecopyresampled( $thumb, $newImage, 0, 0, $posX, $posY, $dX, $dY, $width, $height );
        if ( $this->imageCreate( $thumb ) )
        {
            return TRUE;
        }
        return $this->debug( "A problem occours creating the image. I can't finish the task." );
    }

    public function imageDefine( )
    {
        switch ( $this->data[2] )
        {
        case 1 :
            return imagecreatefromgif( $this->image );
        case 2 :
            return imagecreatefromjpeg( $this->image );
        case 3 :
            return imagecreatefrompng( $this->image );
        }
        return FALSE;
    }

    public function imageCreate( $thumb )
    {
        if ( $this->data[2] == 1 )
        {
            $ok = imagegif( $thumb, $this->target, $this->quality );
        }
        else if ( $this->data[2] == 3 )
        {
            $quality = 10 - round( $this->quality / 10 );
            $quality = $quality < 0 ? 0 : 9 < $quality ? 9 : $quality;
            $ok = imagepng( $thumb, $this->target, $quality );
        }
        else
        {
            $ok = imagejpeg( $thumb, $this->target, $this->quality );
        }
        if ( $ok )
        {
            imagedestroy( $thumb );
            return TRUE;
        }
        return FALSE;
    }

    public function transparency( $original, $new )
    {
        if ( $this->data[2] !== 1 && $this->data[2] !== 3 )
        {
            return $new;
        }
        $trans_index = imagecolortransparent( $original );
        if ( 0 <= $trans_index )
        {
            $trans_color = imagecolorsforindex( $original, $trans_index );
            $trans_index = imagecolorallocate( $new, $trans_index['red'], $trans_index['green'], $trans_index['blue'] );
            imagefill( $new, 0, 0, $trans_index );
            imagecolortransparent( $new, $trans_index );
            return $new;
        }
        if ( $this->data[2] === 3 )
        {
            imagealphablending( $new, FALSE );
            $colorTransparent = imagecolorallocatealpha( $new, 0, 0, 0, 127 );
            imagefill( $new, 0, 0, $colorTransparent );
            imagesavealpha( $new, TRUE );
        }
        return $new;
    }

    public function proportions( $width, $height )
    {
        if ( $height < $width )
        {
            $n_width = $this->size[0];
            $n_height = round( $n_width * $height / $width );
        }
        else if ( $width < $height )
        {
            $n_height = $this->size[1];
            $n_width = round( $n_height * $width / $height );
        }
        else if ( $this->size[1] < $this->size[0] )
        {
            $n_width = $this->size[1];
            $n_height = $this->size[1];
        }
        else
        {
            $n_width = $this->size[0];
            $n_height = $this->size[0];
        }
        if ( $this->size[0] < $n_width )
        {
            $n_width = $this->size[0];
            $n_height = round( $n_width * $height / $width );
        }
        if ( $this->size[1] < $n_height )
        {
            $n_height = $this->size[1];
            $n_width = round( $n_height * $width / $height );
        }
        return array(
            $n_width,
            $n_height
        );
    }

    public function maxSize( $posX, $posY, $width, $height )
    {
        $posX = $this->data[0] < $posX + $width ? $this->data[0] - $width : $posX;
        $posX = $posX < 0 ? 0 : $posX;
        $posY = $this->data[1] < $posY + $height ? $this->data[1] - $height : $posY;
        $posY = $posY < 0 ? 0 : $posY;
        return array(
            $posX,
            $posY
        );
    }

    public function recursive_path( $target )
    {
        if ( is_dir( $target ) )
        {
            return TRUE;
        }
        $dirs = explode( "/", $target );
        $dir = "";
        foreach ( $dirs as $part )
        {
            if ( !empty( $part ) )
            {
                if ( $part == "." )
                {
                    break;
                }
            }
            else
            {
                continue;
            }
            $dir .= "/".$part;
            if ( !( $part == ".." ) )
            {
                if ( $part == ".." )
                {
                    break;
                }
            }
            else
            {
                continue;
            }
            if ( @mkdir( $dir, 493 ) )
            {
                continue;
            }
            return $this->debug( "Can't write in the target folder: ".$dir );
        }
        clearstatcache( );
        return is_dir( $target );
    }

}

?>
