<?php
/**
*
* @ This file is created by Decodeby.US
* @ deZender Public (PHP5 Decompiler)
*
* @	Version			:	1.0.0.1
* @	Author			:	Ps2Gamer & Cyko
* @	Release on		:	07.06.2011
* @	Official site	:	http://decodeby.us
*
*/

class watermark
{

    public $watermarkFile = NULL;
    private $imageType = "jpg";
    private $position = "downright";

    public function __construct( $watermark, $position = "" )
    {
        if ( !isset( $watermark ) )
        {
            exit( "Error with load watermark" );
        }
        if ( $position != "" )
        {
            $this->position = $position;
        }
        $this->watermarkFile = $watermark;
    }

    private function getImageType( $imageFile )
    {
        $imageInfo = getimagesize( $filename );
        $imageInfo[2] = strtolower( $imageInfo[2] );
        switch ( $imageInfo[2] )
        {
        case "jpg" :
            $this->imageType = "jpg";
            break;
        case "gif" :
            $this->imageType = "gif";
            break;
        case "png" :
            $this->imageType = "png";
            break;
        default :
            exit( "Wrong file type." );
        }
    }

    public function addWatermark( $imageFile, $destinationFile = TRUE )
    {
        if ( $destinationFile )
        {
            $destinationFile = $imageFile;
        }
        if ( !( $watermark = @imagecreatefrompng( $this->watermarkFile ) ) )
        {
            exit( "Cannot open the watermark file." );
        }
        imagealphablending( $watermark, FALSE );
        imagesavealpha( $watermark, TRUE );
        if ( !( $image_string = @file_get_contents( $imageFile ) ) )
        {
            exit( "Cannot open image file." );
        }
        if ( !( $image = @imagecreatefromstring( $image_string ) ) )
        {
            exit( "Not a valid image format." );
        }
        $imageWidth = imagesx( $image );
        $imageHeight = imagesy( $image );
        $watermarkWidth = imagesx( $watermark );
        $watermarkHeight = imagesy( $watermark );
        if ( $this->position == "center" )
        {
            $coordinate_X = ( $imageWidth - $watermarkWidth ) / 2;
            $coordinate_Y = ( $imageHeight - $watermarkHeight ) / 2;
        }
        else
        {
            $coordinate_X = $imageWidth - 5 - $watermarkWidth;
            $coordinate_Y = $imageHeight - 5 - $watermarkHeight;
        }
        imagecopy( $image, $watermark, $coordinate_X, $coordinate_Y, 0, 0, $watermarkWidth, $watermarkHeight );
        if ( $this->imageType == "jpg" )
        {
            imagejpeg( $image, $destinationFile, 100 );
        }
        else if ( $this->imageType == "gif" )
        {
            imagegif( $image, $destinationFile );
        }
        else if ( $this->imageType == "png" )
        {
            imagepng( $image, $destinationFile, 100 );
        }
        imagedestroy( $image );
        imagedestroy( $watermark );
    }

}

?>
