<?php 

#LOAD ORDERS COUNT
	require_once ROOT_PATH.'/modules/items/models/orders.class.php';
	$ordersClass = new orders();

	$total = $ordersClass->getSalesStatus();
	abr('total', $total);

	$ref = $ordersClass->getSalesStatus(" AND `datetime` > '".date('Y-m')."-01 00:00:00' ", 'referal');
	$sales = $ordersClass->getSalesStatus(" AND `datetime` > '".date('Y-m')."-01 00:00:00' ");
	if(is_array($sales)) {
		$sales['referal'] = $ref['receive'];
		$sales['win'] = floatval($sales['total']) - floatval($sales['receive']) - floatval($sales['referal']);
		abr('sales', $sales);
	}
	unset($ref);
	
#LOAD USERS COUNT
	require_once ROOT_PATH.'/modules/users/models/users.class.php';
	$usersClass = new users();

	$users['month'] = $usersClass->getUsersCount(" `register_datetime` > '".date('Y-m')."-01 00:00:00' AND `status` = 'activate' ");
	$users['total'] = $usersClass->getUsersCount(" `status` = 'activate' ");
	abr('users', $users);

	$topAuthors = $usersClass->getAll(0, 5, " `status` = 'activate' ", "`sales` DESC");
	abr('topAuthors', $topAuthors);
	
#LOAD WITHDRAW
	require_once ROOT_PATH.'/modules/users/models/deposit.class.php';
	$depositClass = new deposit();

	$withdraw['no'] = $depositClass->getWithdrawCount(" `paid` = 'false' AND `datetime` > '".date('Y-m')."-01 00:00:00' ");
	$withdraw['paid'] = $depositClass->getWithdrawCount(" `paid` = 'true' AND `paid_datetime` > '".date('Y-m')."-01 00:00:00' ");
	abr('withdraw', $withdraw);
	
#LOAD THEMES
	require_once ROOT_PATH.'/modules/items/models/items.class.php';
	$itemsClass = new items();
	
	$items = $itemsClass->getAll(0, 5, " `status` = 'queue' ");
	abr('items', $items);	
	
#LOAD LAST REQUEST
	require_once ROOT_PATH.'/modules/contacts/models/contacts.class.php';
	$contactsClass = new contacts();

	$lastContact = $contactsClass->getAll(0, 1, " `answer` = '' ");
	if(is_array($lastContact)) {
		$lastContact = array_shift($lastContact);
	}
	abr('lastContact', $lastContact);
	
?>