<?php 
_setView(__FILE__);

	$itemID = get_id(2);
	
	$itemsClass = new items();
	
	$item = $itemsClass->get($itemID);
	if(!is_array($item) || (check_login_bool() && $item['status'] == 'unapproved' && $item['user_id'] != $_SESSION['user']['user_id']) || $item['status'] == 'queue' || $item['status'] == 'extended_buy') {
		refresh('/'.$languageURL, $langArray['wrong_item'], 'error');
	}
	
	require_once ROOT_PATH.'/modules/users/models/users.class.php';
	$usersClass = new users();
	
	$item['user'] = $usersClass->get($item['user_id']);
	abr('item', $item);
	
	$commentsClass = new comments();
	
#REPORT COMMENT
	if(check_login_bool() && isset($_GET['report']) && is_numeric($_GET['report'])) {
		$s = $commentsClass->report($_GET['report']);
		if($s === true) {
			refresh('/'.$languageURL.'items/comments/'.$itemID, $langArray['complete_report_comment'], 'complete');
		}
		else {
			addErrorMessage($s, '', 'error');
		}
	}
	
#ADD COMMENT
	if(check_login_bool() && isset($_POST['add'])) {
		$s = $commentsClass->add();
		if($s === true) {
			refresh('/'.$languageURL.'items/comments/'.$itemID, $langArray['complete_add_comment'], 'complete');
		}
		else {
			addErrorMessage($langArray['error_item_comment'], '', 'error');
		}
	}	
	elseif(isset($_POST['add_reply'])) {
		if(!isset($_POST['comment_id'])) {
			$_POST['comment_id'] = 0;
		}
		$s = $commentsClass->add($_POST['comment_id']);
		if($s === true) {
			refresh('/'.$languageURL.'items/comments/'.$itemID, $langArray['complete_add_reply'], 'complete');
		}
		else {
			addErrorMessage($langArray['error_item_comment'], '', 'error');
		}
	}
	
	
	$comments = $commentsClass->getAll(START, LIMIT, " `item_id` = '".intval($itemID)."' AND `reply_to` = '0' ", true, '`datetime` ASC');
	if(is_array($comments)) {
		$users = $usersClass->getAll(0, 0, $commentsClass->usersQuery);
		abr('users', $users);
		
		$ordersClass = new orders();
		$buyFromUsers = $ordersClass->isItemBuyed($itemID, $commentsClass->usersQuery);
		abr('buyFromUsers', $buyFromUsers);
	}
	abr('comments', $comments);
	
	abr('paging', paging('/'.$languageURL.'items/comments/'.$itemID.'/?p=', '', PAGE, LIMIT, $commentsClass->foundRows));
	
#BOOKMARK ITEM
	require_once ROOT_PATH.'/modules/items/controllers/_bookmark.php';	
	
#IS FREE FILE
	if($item['free_file'] == 'true') {
		abr('freeFileMessage', langMessageReplace($langArray['free_file_info'], array('URL' => '/'.$languageURL.'users/downloads/'.$item['id'])));
	}	
	
#LOAD OTHER ITEMS
	$otherItems = $itemsClass->getAll(0, 7, " `status` = 'active' AND `id` <> '".intval($itemID)."' ", "RAND()");	
	abr('otherItems', $otherItems);
	abr('otherItemsCount', count($otherItems));

#LOAD ATTRIBUTES
	require_once ROOT_PATH.'/modules/attributes/models/attributes.class.php';
	$attributesClass = new attributes();	

	$attributes = $attributesClass->getAll(0, 0, $itemsClass->attributesWhere);
	abr('attributes', $attributes);

	$attributeCategories = $attributesClass->getAllCategories(0, 0, $itemsClass->attributeCategoriesWhere);
	abr('attributeCategories', $attributeCategories);
	
#BREADCRUMB	
	abr('breadcrumb', '<a href="/'.$languageURL.'" title="">'.$langArray['home'].'</a> \ <a href="/'.$languageURL.'items/'.$item['id'].'" title="">'.$item['name'].'</a> \ <a href="/'.$languageURL.'items/comments/'.$item['id'].'" title="">'.$langArray['comments'].'</a>');		
	

?>