<?php 
_setView(__FILE__);

	$itemID = get_id(2);
	
	$itemsClass = new items();
	
	$item = $itemsClass->get($itemID);
	if(!is_array($item) || (check_login_bool() && $item['status'] == 'unapproved' && $item['user_id'] != $_SESSION['user']['user_id']) || $item['status'] == 'queue' || $item['status'] == 'extended_buy') {
		refresh('/'.$languageURL, $langArray['wrong_item'], 'error');
	}
	
	require_once ROOT_PATH.'/modules/users/models/users.class.php';
	$usersClass = new users();
	
	$item['user'] = $usersClass->get($item['user_id']);
	abr('item', $item);
	
#ADD FAQ ENTRY
	if(check_login_bool() && $item['user_id'] == $_SESSION['user']['user_id'] && isset($_POST['add'])) {
		$faqClass = new faq();
		$s = $faqClass->add($itemID);
		if($s === true) {
			refresh('/'.$languageURL.'items/faq/'.$itemID.'/', $langArray['complete_add_faq'], 'complete');
		}
		else {
			$message = '<ul>';
			foreach($s as $e) {
				$message .= '<li>'.$e.'</li>';
			}
			$message .= '</ul>';
			addErrorMessage($message, '', 'error');
		}
	}
	
	$faqClass = new faq();
	
	if(check_login_bool() && $item['user_id'] == $_SESSION['user']['user_id'] && isset($_GET['del']) && is_numeric($_GET['del'])) {
		$faqClass->delete($_GET['del'], $itemID);
		refresh('/'.$languageURL.'items/faq/'.$itemID.'/', $langArray['complete_delete_faq'], 'complete');
	}

#LOAD FAQs
	$faq = $faqClass->getAll($itemID);
	abr('faq', $faq);	
	
#BOOKMARK ITEM
	require_once ROOT_PATH.'/modules/items/controllers/_bookmark.php';
	
#IS FREE FILE
	if($item['free_file'] == 'true') {
		abr('freeFileMessage', langMessageReplace($langArray['free_file_info'], array('URL' => '/'.$languageURL.'users/downloads/'.$item['id'])));
	}	
	
#LOAD OTHER ITEMS
	$otherItems = $itemsClass->getAll(0, 6, " `status` = 'active' AND `id` <> '".intval($itemID)."' AND `user_id` = '".intval($item['user_id'])."' ", "RAND()");	
	abr('otherItems', $otherItems);
	if(!is_array($otherItems)) {
		abr('otherItemsCount', 0);
	}
	else {
		abr('otherItemsCount', count($otherItems));
	}

#LOAD ATTRIBUTES
	require_once ROOT_PATH.'/modules/attributes/models/attributes.class.php';
	$attributesClass = new attributes();	

	$attributes = $attributesClass->getAll(0, 0, $itemsClass->attributesWhere);
	abr('attributes', $attributes);

	$attributeCategories = $attributesClass->getAllCategories(0, 0, $itemsClass->attributeCategoriesWhere);
	abr('attributeCategories', $attributeCategories);
	
#BREADCRUMB	
	abr('breadcrumb', '<a href="/'.$languageURL.'" title="">'.$langArray['home'].'</a> \ <a href="/'.$languageURL.'items/'.$item['id'].'" title="">'.$item['name'].'</a> \ <a href="/'.$languageURL.'items/faq/'.$item['id'].'" title="">'.$langArray['faqs'].'</a>');		
	
	

?>