<?php 
_setView(__FILE__);

	$itemID = get_id(1);
	
	$itemsClass = new items();
	
	$item = $itemsClass->get($itemID);
	if(!is_array($item) || (check_login_bool() && $item['status'] == 'unapproved' && $item['user_id'] != $_SESSION['user']['user_id']) || $item['status'] == 'queue' || $item['status'] == 'extended_buy') {
		refresh('/'.$languageURL, $langArray['wrong_item'], 'error');
	}
	
	require_once ROOT_PATH.'/modules/users/models/users.class.php';
	$usersClass = new users();
	
	$item['user'] = $usersClass->get($item['user_id']);
	
	if(check_login_bool() && $item['user_id'] != $_SESSION['user']['user_id']) {
		$ordersClass = new orders();
		if($ordersClass->isBuyed($item['id'])) {
			$item['is_buyed'] = langMessageReplace($langArray['already_buyed'], array('URL' => '/'.$languageURL.'users/downloads/'));
		}
	}	
	
	$item['description'] = replaceEmoticons($item['description']);
	
	abr('item', $item);

#BUY ITEM	
	if(isset($_POST['licence'])) {	
		if(!check_login_bool()) {
			$_SESSION['temp']['golink'] = '/'.$languageURL.'items/'.$itemID;
			refresh('/'.$languageURL.'users/login/', $langArray['error_login_to_buy'], 'error');
		}
		
		$ordersClass = new orders();
		
		abr('paypal', $config['paypal']);
		
		if($_POST['licence'] == 'regular') {
			if(isset($_POST['pay_method']) && $_POST['pay_method'] == 'paypal') {
				$orderID = $ordersClass->add($item['price']);
				abr('orderID', $orderID);
				abr('paypal_show', 'yes');
				abr('price', $item['price']);
			}
			else {
				if($_SESSION['user']['total'] < $item['prepaid_price']) {
					addErrorMessage($langArray['error_not_enought_money'], '', 'error');
				}
				else {
					$ordersClass->buy($item['prepaid_price']);
					refresh('/'.$languageURL.'users/downloads/', $langArray['complete_buy_theme'], 'complete');
				}
			}
		}
		elseif($_POST['licence'] == 'extended') {
			if(isset($_POST['pay_method']) && $_POST['pay_method'] == 'paypal') {
				$orderID = $ordersClass->add($item['extended_price'], 'true');
				abr('orderID', $orderID);
				abr('paypal_show', 'yes');
				abr('price', $item['extended_price']);
			}
			else {
				if($_SESSION['user']['total'] < $item['extended_price']) {
					addErrorMessage($langArray['error_not_enought_money'], '', 'error');
				}
				else {
					$ordersClass->buy($item['extended_price'], true);
					refresh('/'.$languageURL.'users/downloads/', $langArray['complete_buy_theme'], 'complete');
				}
			}
		}
	}
	
#BOOKMARK ITEM
	require_once ROOT_PATH.'/modules/items/controllers/_bookmark.php';
	
#IS FREE FILE
	if($item['free_file'] == 'true') {
		abr('freeFileMessage', langMessageReplace($langArray['free_file_info'], array('URL' => '/'.$languageURL.'users/downloads/'.$item['id'])));
	}	
	
#LOAD OTHER ITEMS
	$otherItems = $itemsClass->getAll(0, 6, " `status` = 'active' AND `id` <> '".intval($itemID)."' AND `user_id` = '".intval($item['user_id'])."' ", "RAND()");	
	abr('otherItems', $otherItems);
	if(!is_array($otherItems)) {
		abr('otherItemsCount', 0);
	}
	else {
		abr('otherItemsCount', count($otherItems));
	}

#LOAD ATTRIBUTES
	require_once ROOT_PATH.'/modules/attributes/models/attributes.class.php';
	$attributesClass = new attributes();	

	$attributes = $attributesClass->getAll(0, 0, $itemsClass->attributesWhere);
	abr('attributes', $attributes);

	$attributeCategories = $attributesClass->getAllCategories(0, 0, $itemsClass->attributeCategoriesWhere);
	abr('attributeCategories', $attributeCategories);
	
#BREADCRUMB	
	abr('breadcrumb', '<a href="/'.$languageURL.'" title="">'.$langArray['home'].'</a> \ <a href="/'.$languageURL.'items/'.$item['id'].'" title="">'.$item['name'].'</a>');		
	
	
?>