<?php 
_setView(__FILE__);

	$username = get_id(1);
	
	$usersClass = new users();
	
	$user = $usersClass->getByUsername($username);
	if(!is_array($user)) {
		refresh('/'.$languageURL, $langArray['wrong_user'], 'error');
	}
	
	if(check_login_bool() && $_SESSION['user']['user_id'] != $user['user_id']) {
		$user['is_follow'] = $usersClass->isFollow($user['user_id']);
	}
	
	abr('user', $user);
	
#SEND EMAIL
	if(check_login_bool() && isset($_POST['send_email'])) {
		$s = $usersClass->sendEmail();
		if($s === true) {
			refresh('/'.$languageURL.'users/'.$user['username'], $langArray['complete_send_email'], 'complete');
		}
		else {
			addErrorMessage($s, '', 'error');
		}
	}
		
#FOLLOW USER
	if(check_login_bool() && isset($_GET['follow']) && $_SESSION['user']['user_id'] != $user['user_id']) {
		$usersClass->followUser($user['user_id']);
		if(isset($_POST)) {			
			if($user['is_follow']) {
				$text = $langArray['follow'];
			}
			else {
				$text = $langArray['unfollow'];
			}
			die('
				jQuery("#follow_btn").html("'.$text.'");
			');
		}
		refresh('/'.$languageURL.'users/'.$user['username']);
	}	
	
#LOAD PUBLIC COLLECTIONS
	require_once ROOT_PATH.'/modules/collections/models/collections.class.php';
	$collectionsClass = new collections();

	$collections = $collectionsClass->getAll(0, 2, " `public` = 'true' AND `user_id` = '".intval($user['user_id'])."' ");
	abr('collections', $collections);
	
#GET FEATURE FILE
	if($user['featured_item_id'] != '0') {
		require_once ROOT_PATH.'/modules/items/models/items.class.php';
		$itemsClass = new items();
		
		$featureItem = $itemsClass->get($user['featured_item_id']);
		abr('featureItem', $featureItem);
	}

#GET FOLLOWERS
	$follow['to'] = $usersClass->getFollowers($user['user_id'], 0, 9, 'RAND()', true);
	$follow['to_count'] = $usersClass->foundRows;
	$follow['from'] = $usersClass->getFollowers($user['user_id'], 0, 9, 'RAND()');
	$follow['from_count'] = $usersClass->foundRows;	
	abr('follow', $follow);
	
#BREADCRUMB	
	abr('breadcrumb', '<a href="/'.$languageURL.'" title="">'.$langArray['home'].'</a> \ <a href="/'.$languageURL.'users/'.$user['username'].'" title="">'.$user['username'].'</a>');		
	
	
?>